#
#   $Header: /netrcs/RCS/oracle/network/csm/RCS/csmgen.tcl,v 1.24 1995/12/15 18:34:55 dmcbride Exp $
#   Copyright (C) 1995 David McBride
#
#
# NAME
#   
# CONTENTS
#   routines/functions for client status monitor for both tk and tcl
#   versions of the product
#
# NOTES
#
# OWNER
#   dmcbride
# DATE
#   10/13/95
# MODIFIED
# 
#
#

#
######################################################
# initialize all variables
######################################################
proc InitSm {} {
  global user home oracle_home oracle_sid tns_admin oracle_path two_task DEBUG TEST

  if { $DEBUG } { puts "*************** init startup *********************************." }
  #### data variables #########
  global sqlnetversion;     set sqlnetversion ""
  global sqlnetnames;       set sqlnetnames ""
  global productlist;       set productlist ""
  global protocollist;      set protocollist ""
  global cryptolist;        set cryptolist ""
  global authlist;          set authlist ""
  global encryptlist;       set encryptlist ""

  global nameslist;         set nameslist ""
  global namelist;          set namelist ""
  global namesfound;        set namesfound ""
  global sourcestring;      set sourcestring ""
  global aliasstring;       set aliasstring "";
  
  global logfilelocation;          set logfilelocation ""
  global tracefilelocation;        set tracefilelocation ""
  global syssqlnetfilelocation ;   set syssqlnetfilelocation ""
  global usersqlnetfilelocation ;  set usersqlnetfilelocation ""
  global tnsnamesfilelocation;     set tnsnamesfilelocation ""
  global tnsnavfilelocation;       set tnsnavfilelocation ""
  global protocolfilelocation;     set protocolfilelocation ""

  global manfile;             
  global sqlnettmpfile;        
  global faxpagelocation;       
  global productlistfilelocation;
  global protocollistfilelocation;
  global csifilelocation;         
  global csifiledir;               
  ##porting notes
  if {$TEST} {
    set manfile "csmman.man"
    set sqlnettmpfile /tmp/sqlnet.$user
    set faxpagelocation /tmp/faxpage.$user
    set productlistfilelocation unix.rgs
    set protocollistfilelocation /tmp/adapters.$user
    set csifilelocation "$home/.csi_info"
    set csifiledir "$home"
  } else {
    set manfile $oracle_home/network/admin/csmman.man
    set sqlnettmpfile /tmp/sqlnet.$user
    set faxpagelocation /tmp/faxpage.$user
    set productlistfilelocation $oracle_home/orainst/unix.rgs
    set protocollistfilelocation /tmp/adapters.$user
    set csifilelocation $oracle_home/bin/.csi_info
    set csifiledir $oracle_home/bin
  }
                            # sqlnet.ora defaults 
  global automaticipc;      set automaticipc 1
  global dedicatedserver;   set dedicatedserver 0
  global disableoob;        set disableoob 0
  global sqlnettracelevel;  set sqlnettracelevel "OFF"

  global registration;      set registration ""
  global tnspingtracelevel; set tnspingtracelevel ""
  global tnspingtracedir;   set tnspingtracedir ""
  global sqlnettraceunique; set sqlnettraceunique ""
  global sqlnettracename;   set sqlnettracename ""
  global sqlnetlogpath;     set sqlnetlogpath ""
  global sqlnetlogname;     set sqlnetlogname ""
  global sqlnettracepath;   set sqlnettracepath ""
  global tnspingpath;       set tnspingpath ""

  global authentication;     set authentication ""
  global auth_gssapi;        set auth_gssapi ""
  global snsseed;            set snsseed ""
  global snsclient;          set snsclient ""
  global snsclienttype;      set snsclienttype ""
  global snsserver;          set snsserver ""
  global snsservertype;      set snsservertype ""
  global snsclientcksum;     set snsclientcksum ""
  global snsclienttypecksum; set snsclienttypecksum ""
  global snsservercksum;     set snsservercksum ""
  global snsservertypecksum; set snsservertypecksum ""
  
  global default_domain;    set default_domain ""
  global namescommunity;    set namescommunity ""
  global namesport;         set namesport  ""
  global nameshost;         set nameshost   ""
  global namesaddress;      set namesaddress ""
  global namesprotocol;     set namesprotocol ""
  global namesaddresslist;  set namesaddresslist ""

  global csiname;           set csiname "default"
  global csiphone;          set csiphone "default"
  global csifax;            set csifax "default"
  global csinumber;         set csinumber "default"
  global csifileaccess;     set csifileaccess FALSE
  global csisubject;        set csisubject ""
  global csicomment;        set csicomment ""
   
  #### program control flow variables #########
  global viewfile;      set viewfile "sqlnet"
  global statusfile;    set statusfile ""
  global filetotrace;   set filetotrace ""
  global errors;        set errors ""
  global infilename;    set infilename ""
  global fileline;      set fileline ""
  global printfilename; set printfilename ""

  ### set up everything ###
  GetProducts
  GetProtocols
  GetCsiInfo
  GetConfigFiles
  if { $DEBUG } { puts "*************** done with init *******************************." }
} 

######################################################
# print all info to stdout
######################################################
proc Init {} {
  global syssqlnetfilelocation usersqlnetfilelocation   

  set usersqlnetfilelocation ""
  set syssqlnetfilelocation ""
  GetCsiInfo
  GetConfigFiles
}

######################################################
# retrieve csi info from file
######################################################
proc GetCsiInfo {} {
  global user tns_admin oracle_home errors DEBUG csifiledir
  global csiname csiphone csifax csinumber csifilelocation csifileaccess csisubject csicomment


  if { $DEBUG } { puts "*************** in customer info *********************************." }
  set csifileaccess FALSE
  set csidiraccess FALSE
  set newlinenow FALSE

  if { [file isdirectory $csifiledir ] } {
    if { [file writable $csifiledir] } {
      if { $DEBUG } {puts "Customer Information dir writable." }
      set csidiraccess TRUE
    } 
    if { [file exists $csifilelocation] } {
      # puts "Customer Information file found."
      set csi [open $csifilelocation]
      while {![eof $csi] } {
        set new [gets $csi line] 
        set tmp [lindex $line 0]
        set value [lindex $line 2]
        set name [string toupper $tmp]
        if { $DEBUG } { puts "line from csi information => $name = $value" }
        switch $name {
          CSI_FROM { set csiname $value }
          CSI_PHONE { set csiphone $value }
          CSI_FAX { set csifax $value }
          CSI_ID { set csinumber $value }
          CSI_SUBJECT { set csisubject $value }
          CSI_COMMENT { set csicomment $value }
          default { }
        }
      }
      close $csi
      if { $DEBUG } {puts "Retrieved CSI: $csiname, $csiphone, $csinumber, $csifax." }
      if { [file writable $csifilelocation] } {
        # puts "Customer Information file writable."
        set csifileaccess TRUE
      }
    } else {
      if { $DEBUG } { puts "Customer Information file NOT found."}
      if { $csidiraccess  } {
        if { $DEBUG } { puts "Created initial Customer Information file." }
        set csi_first [open $csifilelocation w]
        puts $csi_first " "
        close $csi_first
        PutCsiInfo
      }
    }
  } else {
    set errors "Customer Information Directory\n $csifiledir\n         NOT found."
  }
  if { $DEBUG } { puts "*************** out customer info *********************************." }
}

######################################################
# save csi info to file
######################################################
proc PutCsiInfo {} {
  global tns_admin oracle_home errors DEBUG csifiledir
  global csiname csiphone csifax csinumber csifilelocation csifileaccess csisubject csicomment

  if { [file isdirectory $csifiledir] } {
    if { [file writable $csifiledir] } {
      if { $DEBUG } {puts "Customer Information directory writable." }
      set csidiraccess TRUE
      if { [file writable $csifilelocation] } {
        set csi [open $csifilelocation w]
        puts $csi "CSI_FROM = \"$csiname\""
        puts $csi "CSI_PHONE = \"$csiphone\""
        puts $csi "CSI_ID = \"$csinumber\""
        puts $csi "CSI_FAX = \"$csifax\""
        puts $csi "CSI_SUBJECT = \"$csisubject \""
        puts $csi "CSI_COMMENT = \"$csicomment\""
        close $csi
        set errors "Customer Information saved."
        if { $DEBUG } {puts "Saved Customer Information: $csiname, $csiphone, $csinumber, $csifax." }
      } else {
        set errors "Customer Information NOT saved, File write protected."
      }
    } else {
      set errors "Customer Information NOT saved, $csifiledir not writable."
    }
  } else {
    set errors "Customer Information NOT saved, $csifiledir not found."
  }
}

###################################################### 
# save all info to tmp file
######################################################
proc MakeFaxPage {} {
  global faxpagelocation user home productlist errors 
  global two_task tns_admin oracle_home oracle_path oracle_sid sqlnetversion 
  global logfilelocation tracefilelocation syssqlnetfilelocation usersqlnetfilelocation protocollist
  global tnsnamesfilelocation tnsnavfilelocation protocolfilelocation registration 
  global tnspingtracelevel tnspingtracedir sqlnettracelevel sqlnettracename sqlnettracepath
  global automaticipc dedicatedserver disableoob nameslist namesfound
  global snsseed snsclient snsclienttype snsserver snsservertype snsclientcksum
  global snsclienttypecksum snsservercksum snsservertypecksum 
  global csiname csiphone csifax csinumber csifilelocation csifileaccess csisubject csicomment

  global cryptolist authlist encryptlist authentication
     
  catch {set time [eval exec date]} result
  set faxpage [open $faxpagelocation w]
  puts $faxpage "===================================================================="
  puts $faxpage "=                  Report On Sqlnet"
  puts $faxpage "===================================================================="
  puts $faxpage "=  Date          $time"
  puts $faxpage "= "
  puts $faxpage "=  To:           Oracle Corporation "
  puts $faxpage "=  Fax No.:      415.506.7000"
  puts $faxpage "=  From:         $csiname   "
  puts $faxpage "=  Support Id:   $csinumber"
  puts $faxpage "=  Phone No.:    $csiphone " 
  puts $faxpage "=  Fax No.:      $csifax"
  puts $faxpage "=  Subject:      $csisubject"
  puts $faxpage "=  Comment:      $csicomment"
  puts $faxpage "===================================================================="
  puts $faxpage " "
  puts $faxpage "       *** SQL*Net Environment Evaluation ***"
  puts $faxpage " "
  puts $faxpage "TNS for Unix: Version $sqlnetversion Production"
  puts $faxpage " "
  puts $faxpage "Environment Variables"
  puts $faxpage "--------------------------------------------------------------------"
  puts $faxpage "ORACLE_HOME  => $oracle_home"
  puts $faxpage "ORACLE_SID   => $oracle_sid"
  puts $faxpage "ORACLE_PATH  => $oracle_path"
  puts $faxpage "TNS_ADMIN    => $tns_admin"
  puts $faxpage "TWO_TASK     => $two_task"
  puts $faxpage "USER         => $user"
  puts $faxpage "HOME         => $home"

  puts $faxpage " "
  puts $faxpage "Installed Products:"
  puts $faxpage "--------------------------------------------------------------------"
  foreach product $productlist {
    puts $faxpage "$product"
  }

  puts $faxpage " "
  puts $faxpage "Enabled Protocols Adapters:"
  puts $faxpage "---------------------------"
  foreach prot $protocollist {
    puts $faxpage "$prot"
  }

  puts $faxpage " "
  puts $faxpage "Installed Crypto Services:"
  puts $faxpage "--------------------------"
  foreach secure $cryptolist {
    puts $faxpage "$secure"
  }
  puts $faxpage " "
  puts $faxpage "Installed Encryption Services:"
  puts $faxpage "-----------------------------"
  foreach secure $encryptlist {
    puts $faxpage "$secure"
  }
  puts $faxpage " "
  puts $faxpage "Installed Authentication Services:"
  puts $faxpage "----------------------------------"
  foreach secure $authlist {
    puts $faxpage "$secure"
  }

  puts $faxpage " "
  puts $faxpage "Native Naming Adapters:"
  puts $faxpage "-----------------------"
  foreach prot $nameslist {
    puts $faxpage "$prot"
  }

  puts $faxpage " "
  puts $faxpage "SQL*Net Option Settings"
  puts $faxpage "--------------------------------------------------------------------"
  puts $faxpage "Authentication       => $authentication"
  puts $faxpage "Crypto Client Level  => $snsclientcksum"
  puts $faxpage "Crypto Client Type   => $snsclienttypecksum"
  puts $faxpage "names.directory_path => $namesfound"
  puts $faxpage "Encryption Seed      => $snsseed"
  puts $faxpage "Encryption Client Level => $snsclient"
  puts $faxpage "Encryption Client Type  => $snsclienttype"
  puts $faxpage " "

  if {$disableoob != ""} {
    if {$disableoob == 0} {
      puts $faxpage "disable out of band breaks   => OFF"
    } else {
      puts $faxpage "disable out of band breaks   => ON"
    }
  }
  if {$automaticipc != ""} {
    if {$automaticipc == 0} {
      puts $faxpage "automatic ipc      => OFF"
    } else {
      puts $faxpage "automatic ipc      => ON"
    }
  }
  if {$dedicatedserver != ""} {
    if {$dedicatedserver == 0} {
      puts $faxpage "dedicated server   => OFF"
    } else {
      puts $faxpage "dedicated server   => ON"
    }
  }
  if {$sqlnettracelevel != ""} {
      puts $faxpage "sqlnet tracelevel  => $sqlnettracelevel"  
      puts $faxpage "sqlnet tracename   => $sqlnettracename"
      puts $faxpage "sqlnet tracepath   => $sqlnettracepath"
  }
  if {$tnspingtracelevel != ""} {
      puts $faxpage "tnsping tracelevel => $tnspingtracelevel" 
      puts $faxpage "tnsping tracedir   => $tnspingtracedir"
  }
  if {$registration != ""} {
      puts $faxpage "registration       => $registration"
  }
  puts $faxpage " "

  puts $faxpage "Configuration Files"
  puts $faxpage "--------------------------------------------------------------------"
  puts $faxpage "SYSTEM sqlnet.ora => $syssqlnetfilelocation "
  puts $faxpage "USER sqlnet.ora   => $usersqlnetfilelocation  "
  puts $faxpage "tnsnames.ora      => $tnsnamesfilelocation "
  puts $faxpage "tnsnav.ora        => $tnsnavfilelocation "
  puts $faxpage "protocol.ora      => $protocolfilelocation"

  puts $faxpage " "
  puts $faxpage "log file   => $logfilelocation "
  puts $faxpage "trace file => $tracefilelocation"
  puts $faxpage " "

  close $faxpage
}

######################################################
# find files in env
######################################################
proc FindFile {infile} {
  global tns_admin oracle_home oracle_sid oracle_path errors DEBUG home

  set outfile ""
  ## SYSTEM
  if {[file exists $oracle_home/network/admin/$infile] } {
    if { $DEBUG } { puts "found SYSTEM $infile, in oracle_home $oracle_home "}
      set outfile $oracle_home/network/admin/$infile
  } else {
    if {[file exists /etc/$infile] } {
      if { $DEBUG } { puts "found SYSTEM $infile, in /etc "}
      set outfile /etc/$infile
    }
  }
  ## USER
  if {[file exists $tns_admin/$infile] } {
    if { $DEBUG } { puts "found USER tns_admin $infile sqlnet.ora in $tns_admin "}
    set outfile $tns_admin/$infile
  } else {
    if {[file exists $home/$infile] } {
      if { $DEBUG } { puts "found USER $infile in home $home "}
      set outfile $home/$infile
    }
  }
  return $outfile
}

######################################################
# find all configuration files in SYSTEM
######################################################
proc GetConfigFiles {} {
  global oracle_home errors DEBUG TEST user tracefilelocation sqlnettraceunique
  global tnsnamesfilelocation tnsnavfilelocation protocolfilelocation

  ### porting notes
  if {$TEST} {
    set command "csmnl -i > /tmp/csmnl.$user"
  } else {
    set command "$oracle_home/bin/csmnl -i > /tmp/csmnl.$user"
  }
  catch {eval exec $command } result
  GetSqlnetEnv
  set tnsnamesfilelocation [FindFile tnsnames.ora]
  set tnsnavfilelocation [FindFile tnsnav.ora]
  set protocolfilelocation [FindFile protocol.ora]
  GetSystemFile 
  GetUserFile 
  if {$sqlnettraceunique == 1} {
    set tracefilelocation "File name Unique for each connection attempt"
  }
}

######################################################
# get tnsnames alias list 
######################################################
proc GetTnsnamesList {} {
  global errors DEBUG tnsnamesfilelocation fileline

  if { $DEBUG } { puts "*************** in tnsnames.ora *********************************." }
  if { $DEBUG } { puts "In get tnsnames.ora aliasname list at $tnsnamesfilelocation." }
  set tnsnameslistv2 ""
  set tnsnameslist ""
  if {$tnsnamesfilelocation != "" } {
    if {[file exists $tnsnamesfilelocation ] } {
      if { $DEBUG } { puts " "}
        set tnsn [open $tnsnamesfilelocation r] 
        while {![eof $tnsn] } {
          set new [gets $tnsn fileline]
          set equalplace [string first "=" $fileline]; incr equalplace -1
          set tmpvar [string range $fileline 0 $equalplace]; set aliasname [string trim $tmpvar]
          if {$aliasname != ""} {
            set result [GetAddress $tnsn]
            if {$result != ""} {
              lappend tnsnameslistv2 $aliasname
              set tnsnameslist ""
            }
            if { $DEBUG } { puts "tnsnames.ora => aliasname = $aliasname" }
          }
        }
        close $tnsn
        if { $DEBUG } { puts "tnsnames.ora => aliasname list = $tnsnameslistv2" }
    } 
  } 
  if { $DEBUG } { puts "*************** out tnsnames.ora *********************************." }
  set errors ""
  return $tnsnameslistv2
}

######################################################
# get user sqlnet values
######################################################
proc GetUserFile {} {
  global oracle_home errors DEBUG usersqlnetfilelocation  

  if { $DEBUG } { puts "*************** in user sqlnet.ora *********************************." }
  if {$usersqlnetfilelocation != "" } {
    if {[file exists $usersqlnetfilelocation ] } {
      if { $DEBUG } { puts "found USER sqlnet.ora in $usersqlnetfilelocation "}
      GetSqlnetOptions $usersqlnetfilelocation 
    } 
  } 
  if { $DEBUG } { puts "*************** out user sqlnet.ora *********************************." }
}

######################################################
# USER overrides SYSTEM values
######################################################
proc GetSystemFile {} {
  global tns_admin oracle_home errors DEBUG syssqlnetfilelocation 

  if { $DEBUG } { puts "*************** in system sqlnet.ora *********************************." }
  if {$syssqlnetfilelocation != "" } {
    if {[file exists $syssqlnetfilelocation ] } {
      if { $DEBUG } { puts "found SYSTEM sqlnet.ora in $syssqlnetfilelocation "}
      GetSqlnetOptions $syssqlnetfilelocation 
    } 
  } 
  if { $DEBUG } { puts "*************** out system sqlnet.ora ********************************." }
}

######################################################
# get sqlnet.ora values
######################################################
proc GetSqlnetFile {} {
  global viewsqlnet errors DEBUG syssqlnetfilelocation 

  ClearSqlnet
  if {$viewsqlnet == "SYSTEM" } {
    GetSystemFile
  } else {
    GetUserFile
  }
}

######################################################
# retrieve sqlnet init info
######################################################
proc GetSqlnetEnv {} {
  global syssqlnetfilelocation usersqlnetfilelocation user
  global errors tracefilelocation DEBUG TEST logfilelocation 
  global tnspingtracelevel tnspingtracedir sqlnettracelevel sqlnettracename sqlnettracepath
  global automaticipc dedicatedserver disableoob nameslist protocollist
  global snsseed snsclient snsclienttype snsserver snsservertype snsclientcksum
  global snsclienttypecksum snsservercksum snsservertypecksum 

  set protocollist ""
  set nameslist ""
  if { [file readable /tmp/csmnl.$user] } {
    set csm [open /tmp/csmnl.$user] 
    while {![eof $csm] } {
      set new [gets $csm line] 
      set tmp [lindex $line 0]
      set name [string toupper $tmp]
      set value [lindex $line 2]
      if { $DEBUG } { puts "line from csmnl => $name = $value" }
      switch $name {
        TRACE_LEVEL { if {($value == "OFF") || ($value == "ADMIN") 
                          || ($value == "USER")} {
                        set sqlnettracelevel $value
                        if { $DEBUG } { puts "set TRACE_LEVEL with $value" }
                      } else {
                        if { $DEBUG } { puts "in switch with $value" }
                        switch $value {
                          0 { set sqlnettracelevel "OFF" }
                          1 { set sqlnettracelevel "OFF" }
                          2 { set sqlnettracelevel "OFF" }
                          3 { set sqlnettracelevel "OFF" }
                          4 { set sqlnettracelevel "USER" }
                          5 { set sqlnettracelevel "USER" }
                          6 { set sqlnettracelevel "ADMIN" }
                          7 { set sqlnettracelevel "ADMIN" }
                          8 { set sqlnettracelevel "ADMIN" }
                          9 { set sqlnettracelevel "ADMIN" }
                          10 { set sqlnettracelevel "ADMIN" }
                          11 { set sqlnettracelevel "ADMIN" }
                          12 { set sqlnettracelevel "ADMIN" }
                          13 { set sqlnettracelevel "ADMIN" }
                          14 { set sqlnettracelevel "ADMIN" }
                          15 { set sqlnettracelevel "ADMIN" }
                          16 { set sqlnettracelevel "ADMIN" }
                          default {  set sqlnettracelevel $value }
                        }
                      }
                    }
        TRACE_FILE { set tracefilelocation $value }
        LOG_FILE { set logfilelocation $value }
        USER.SQLNET.FILE { set usersqlnetfilelocation $value }
        SYSTEM.SQLNET.FILE { set syssqlnetfilelocation $value }
        BANNER { set new [lappend protocollist $value] }
        NAMES { set new [lappend nameslist $value] }
        default {if { $DEBUG } { puts "    *** did not use $name $value "} }
      }
      set name ""; set value "";
    }
    close $csm
    catch {eval exec "rm /tmp/csmnl.$user" } result
  } else { 
    set errors "can NOT get sqlnet environment."
  }    
}

######################################################
# retrieve sqlnet.ora options from file
######################################################
proc ClearSqlnet {} {
  global errors DEBUG
  global tnspingtracelevel tnspingtracedir sqlnettracelevel sqlnettracename sqlnettracepath
  global registration automaticipc dedicatedserver disableoob namesfound 
  global snsseed snsclient snsclienttype snsserver snsservertype snsclientcksum
  global snsclienttypecksum snsservercksum snsservertypecksum authentication auth_gssapi 
  global default_domain namescommunity namesport nameshost 
  global namesaddresslist namesprotocol namesaddress sqlnettraceunique

  if { $DEBUG } { puts "clearing sqlnet values" }
  set automaticipc 1
  set dedicatedserver 0
  set registration ""
  set sqlnettraceunique ""
  set disableoob 0
  set tnspingtracelevel ""
  set tnspingtracedir ""
  set sqlnettracelevel "OFF"
  set sqlnettracename ""
  set sqlnettracepath ""
  set authentication ""
  set snsseed ""
  set snsclient ""
  set snsclienttype ""
  set snsserver ""
  set snsservertype ""
  set snsclientcksum ""
  set snsclienttypecksum ""
  set snsservercksum ""
  set snsservertypecksum ""
  set default_domain ""
  set namescommunity ""
  set namesport ""
  set namesprotocol ""
  set nameshost  ""
  set namesaddress ""
  set namesaddresslist ""
  set auth_gssapi ""
  set namesfound ""

  if { $DEBUG } { puts "out of Clear"}
}

######################################################
# retrieve sqlnet.ora options from file
######################################################
proc GetSqlnetOptions {filename} {
  global errors tracefilelocation value DEBUG fileline
  global syssqlnetfilelocation usersqlnetfilelocation tnspingpath sqlnettraceunique
  global tnspingtracelevel tnspingtracedir sqlnettracelevel sqlnettracename sqlnettracepath
  global registration automaticipc dedicatedserver disableoob namesfound 
  global snsseed snsclient snsclienttype snsserver snsservertype snsclientcksum
  global snsclienttypecksum snsservercksum snsservertypecksum authentication auth_gssapi 
  global default_domain namescommunity namesport nameshost  
  global namesaddresslist namesprotocol namesaddress sqlnetlogpath sqlnetlogname

  if { $DEBUG } { puts "*************** in GetSqlnetOptions "}
  if { $DEBUG } { puts "using sqlnet.ora => $filename"; puts "" }

  if { [file readable $filename] } {
    set sn [open $filename ]
    while {![eof $sn] } {
      set new [gets $sn fileline] 
      set equalplace [string first "=" $fileline]; incr equalplace -1
      set tmpvar [string range $fileline 0 $equalplace]; set tmpname [string trim $tmpvar]
      set name [string toupper $tmpname]

      incr equalplace 2; set last [string length $fileline]; 
      set tmpvalue [string range $fileline $equalplace $last]
      set value [string trim $tmpvalue]

      if { $DEBUG } { puts "...line from sqlnet.ora => $name = $value" }
      switch $name {
        AUTOMATIC_IPC { 
            if {$value == "OFF"} {
              set automaticipc 0
            } else {
              set automaticipc 1
            }
        }
        DISABLE_OOB {
            if {$value == "OFF"} {
              set disableoob 0
            } else {
              set disableoob 1
            }
        }
        USE_DEDICATED_SERVER { 
            if {$value == "OFF"} {
              set dedicatedserver 0
            } else {
              set dedicatedserver 1
            }
        }
        TRACE_UNIQUE_CLIENT { 
            if {$value} {
              set sqlnettraceunique 1
            } else {
              set sqlnettraceunique 0
            }
        }
        TRACE_FILE_CLIENT  { set sqlnettracename $value }
        LOG_DIRECTORY_CLIENT  { set sqlnetlogpath $value }
        LOG_FILE_CLIENT  { set sqlnetlogname $value }
        TRACE_LEVEL_CLIENT { if {($value == "OFF") || ($value == "ADMIN")
                                || ($value == "USER")} {
                              set sqlnettracelevel $value
                              if { $DEBUG } { puts "set TRACE_LEVEL with $value" }
                            } else {
                              if { $DEBUG } { puts "in switch with $value" }
                              switch $value {
                                0 { set sqlnettracelevel "OFF" }
                                1 { set sqlnettracelevel "OFF" }
                                2 { set sqlnettracelevel "OFF" }
                                3 { set sqlnettracelevel "OFF" }
                                4 { set sqlnettracelevel "USER" }
                                5 { set sqlnettracelevel "USER" }
                                6 { set sqlnettracelevel "ADMIN" }
                                7 { set sqlnettracelevel "ADMIN" }
                                8 { set sqlnettracelevel "ADMIN" }
                                9 { set sqlnettracelevel "ADMIN" }
                                10 { set sqlnettracelevel "ADMIN" }
                                11 { set sqlnettracelevel "ADMIN" }
                                12 { set sqlnettracelevel "ADMIN" }
                                13 { set sqlnettracelevel "ADMIN" }
                                14 { set sqlnettracelevel "ADMIN" }
                                15 { set sqlnettracelevel "ADMIN" }
                                16 { set sqlnettracelevel "ADMIN" }
                                default {  set sqlnettracelevel $value }
                              }
                            }
        }
        TRACE_DIRECTORY_CLIENT  { set sqlnettracepath $value }
        TNSPING.TRACE_LEVEL {if {($value == "OFF") || ($value == "ADMIN")
                                 || ($value == "USER")} {
                               set tnspingtracelevel $value
                               if { $DEBUG } { puts "set tnspingTRACE_LEVEL with $value" }
                             } else {
                               if { $DEBUG } { puts "in tnsping switch with $value" }
                               switch $value {
                                 0 { set tnspingtracelevel "OFF" }
                                 1 { set tnspingtracelevel "OFF" }
                                 2 { set tnspingtracelevel "OFF" }
                                 3 { set tnspingtracelevel "OFF" }
                                 4 { set tnspingtracelevel "USER" }
                                 5 { set tnspingtracelevel "USER" }
                                 6 { set tnspingtracelevel "ADMIN" }
                                 7 { set tnspingtracelevel "ADMIN" }
                                 8 { set tnspingtracelevel "ADMIN" }
                                 9 { set tnspingtracelevel "ADMIN" }
                                 10 { set tnspingtracelevel "ADMIN" }
                                 11 { set tnspingtracelevel "ADMIN" }
                                 12 { set tnspingtracelevel "ADMIN" }
                                 13 { set tnspingtracelevel "ADMIN" }
                                 14 { set tnspingtracelevel "ADMIN" }
                                 15 { set tnspingtracelevel "ADMIN" }
                                 16 { set tnspingtracelevel "ADMIN" }
                                 default {  set tnspingtracelevel $value }
                               }
                             }
        }
        TNSPING.TRACE_DIRECTORY { set tnspingtracedir $value; set tnspingpath $tnspingtracedir/tnsping.trc  }
        SQLNET.AUTHENTICATION_SERVICES {
            set authentication ""
            set leftparen [string first "(" $value]; incr leftparen 1
            set rightparen [string first ")" $value]; incr rightparen -1
            set tmpvar [string range $value $leftparen $rightparen]; 
            set notdone TRUE
            while {$notdone} {
              set comma [string first "," $tmpvar] 
              if {$comma == "-1"} {
                set notdone FALSE
                set tmpname $tmpvar
              } else {
                incr comma -1
                set tmpname [string range $tmpvar 0 $comma]; 
                incr comma 2
                set tmpvar [string range $tmpvar $comma end]; 
                set tmpvar [string trim $tmpvar]
              }
              set value [string toupper $tmpname]
              lappend authentication $value
              if { $DEBUG } { puts "added to auth $authentication '$value'" }
            }
        }
        SQLNET.AUTHENTICATION_GSSAPI_SERVICE {set auth_gssapi $value }
        SQLNET.CRYPTO_SEED {set snsseed [lindex $value 0] }
        SQLNET.ENCRYPTION_CLIENT {set snsclient $value }
        SQLNET.ENCRYPTION_SERVER {set snsserver $value }
        SQLNET.ENCRYPTION_TYPES_CLIENT {
            set snsclienttype ""
            set leftparen [string first "(" $value]; incr leftparen 1
            set rightparen [string first ")" $value]; incr rightparen -1
            set tmpvar [string range $value $leftparen $rightparen]; 
            set notdone TRUE
            while {$notdone} {
              set comma [string first "," $tmpvar] 
              if {$comma == "-1"} {
                set notdone FALSE
                set tmpname $tmpvar
              } else {
                incr comma -1
                set tmpname [string range $tmpvar 0 $comma]; 
                incr comma 2
                set tmpvar [string range $tmpvar $comma end]; 
                set tmpvar [string trim $tmpvar]
              }
              set value [string toupper $tmpname]
              lappend snsclienttype $value
              if { $DEBUG } { puts "added to encrypt $snsclienttype '$value'" }
            }
        }
        SQLNET.ENCRYPTION_TYPES_SERVER {set snsservertype $value }
        SQLNET.CRYPTO_CHECKSUM_CLIENT {set snsclientcksum $value }
        SQLNET.CRYPTO_CHECKSUM_SERVER {set snsservercksum $value }
        SQLNET.CRYPTO_CHECKSUM_TYPES_SERVER {set snsservertypecksum $value }
        SQLNET.CRYPTO_CHECKSUM_TYPES_CLIENT {
            set snsclienttypecksum ""
            set leftparen [string first "(" $value]; incr leftparen 1
            set rightparen [string first ")" $value]; incr rightparen -1
            set tmpvar [string range $value $leftparen $rightparen]; 
            set notdone TRUE
            while {$notdone} {
              set comma [string first "," $tmpvar] 
              if {$comma == "-1"} {
                set notdone FALSE
                set tmpname $tmpvar
              } else {
                incr comma -1
                set tmpname [string range $tmpvar 0 $comma]; 
                incr comma 2
                set tmpvar [string range $tmpvar $comma end]; 
                set tmpvar [string trim $tmpvar]
              }
              set value [string toupper $tmpname]
              lappend snsclienttypecksum $value
              if { $DEBUG } { puts "added to chksum $snsclienttypecksum '$value'" }
            }
        }
        SQLNET.CLIENT_REGISTRATION { set registration $value}
        NAMES.DEFAULT_DOMAIN { set default_domain $value}
        NAMES.DIRECTORY_PATH { 
            set namesfound ""
            set leftparen [string first "(" $value]; incr leftparen 1
            set rightparen [string first ")" $value]; incr rightparen -1
            set tmpvar [string range $value $leftparen $rightparen]; 
            set notdone TRUE
            while {$notdone} {
              set comma [string first "," $tmpvar] 
              if {$comma == "-1"} {
                set notdone FALSE
                set tmpname $tmpvar
              } else {
                incr comma -1
                set tmpname [string range $tmpvar 0 $comma]; 
                incr comma 2
                set tmpvar [string range $tmpvar $comma end]; 
                set tmpvar [string trim $tmpvar]
              }
              set value [string toupper $tmpname]
              lappend namesfound $value
              if { $DEBUG } { puts "add to names directory path $namesfound '$value'" }
            }
        }
        default {if { $DEBUG } { puts "    >>> did not use $name $value "} }
      }
#        NAMES.PREFERRED_SERVERS { 
#                     set namesaddresslist ""
#                     set namesaddresslist [GetAddress $sn]
#                     if { $DEBUG } { puts "'$errors' of $namesaddresslist "} 
#        }
      set name ""; set value "";
    }
    close $sn
    if {($sqlnettracename != "") && ($sqlnettracepath != "") } {
      set tracefilelocation $sqlnettracepath/$sqlnettracename
    }
  } else { 
    set errors "can NOT read sqlnet.ora file $infilename"
  }    

  if { $DEBUG } { puts "*************** out GetSqlnetOptions "}
}

######################################################
# save sqlnet.ora options to file
######################################################
proc GetAddress { sn } {
  global errors DEBUG fileline 

  if { $DEBUG } { puts -nonewline "<>>>>>> GetAddress inline: $fileline, file: $sn" }
  set nsobj ""
  set nssid ""
  set parens 0
  set num 0
  set nsaddress ""
  set nscommunity ""
  set nsprotocol ""
  set nshost ""
  set nsport ""
  set result ""
  set errors ""
  set nsaddrlist ""
  set address_found FALSE
  set addresslist_found FALSE
  set result [GetToken $sn ]
  set result [string trim $result]
  set notdone TRUE
  while {$notdone} {
      set result [string trim $result]
      if { $DEBUG } { puts -nonewline "switch on '$result'..." }
      switch $result {
        LPAREN { incr parens 1}
        RPAREN { 
                 if { $DEBUG } { puts -nonewline "ADDRESS_LIST $addresslist_found, ADDRESS $address_found "} 
                 if {$addresslist_found } {
                   if {$parens == 1} {
                     set addresslist_found FALSE
                     if { $DEBUG } { puts -nonewline "end of ADDRESS_LIST $nsaddrlist "} 
                   }
                 }
  
                 if {$address_found } {
                   if {$parens == 2} {
                     set address_found FALSE
                     set nsaddress ""
                     lappend nsaddress $num $nscommunity $nsprotocol $nshost $nsport 
                     incr num 1
                     if { $DEBUG } { puts "  end of ADDRESS $nsaddress"} 
                     if { $DEBUG } { puts "  Connectdata $nsobj $nssid $nshost"} 
                     if {$addresslist_found } {
                       lappend nsaddrlist $nsaddress
                       if { $DEBUG } { puts "add to ADDRESS_LIST $nsaddrlist "} 
                     }
                   }
                 }
                 if {$parens == 3} {
                   if { $DEBUG } { puts -nonewline "    found id = value rparen"} 
                 }
       
                 incr parens -1
                 if {$parens == 0} {
                   set notdone FALSE
                   if { $DEBUG } { puts "end address parsing" }
                 }
        }
        DESCRIPTION { 
                       set addresslist_found TRUE
                       if { $DEBUG } { puts "found DESCRIPTION"} 
        }
        ADDRESS_LIST { 
                       set addresslist_found TRUE
                       if { $DEBUG } { puts "found ADDRESS_LIST"} 
        }
        CONNECT_DATA { 
                  set address_found TRUE
                  if { $DEBUG } { puts "  found CONNECT_DATA" } 
        }
        ADDRESS { 
                  set address_found TRUE
                  if { $DEBUG } { puts "  found ADDRESS" } 
        }
        OBJECT {  
                    set result [GetToken $sn ]; 
                    set result [string trim $result]
                    set nsobj $result 
        }
        NODE {  
                    set result [GetToken $sn ]; 
                    set result [string trim $result]
                    set nshost $result 
        }
        SERVICE {  
                    set result [GetToken $sn ]; 
                    set result [string trim $result]
                    set nsservice $result 
        }
        SID {  
                    set result [GetToken $sn ]; 
                    set result [string trim $result]
                    set nssid $result 
        }
        COMMUNITY {  
                    set result [GetToken $sn ]; 
                    set result [string trim $result]
                    set nscommunity $result 
        }
        PROTOCOL { 
               set result [GetToken $sn ]; 
               set result [string trim $result]
               set nsprotocol $result 
        }
        PORT { 
               set result [GetToken $sn ]; 
               set result [string trim $result]
               set nsport $result 
        }
        HOST { 
               set result [GetToken $sn ]; 
               set result [string trim $result]
               set nshost $result 
        }
        EOF {
               set errors "****** end of file found ****** " 
               set notdone FALSE 
               if { $DEBUG } { puts "****** end of file found ****** " }
        }
        EQUAL { }
        EOL   { }
        ERROR  { set notdone FALSE }
        NAMES.DEFAULT_DOMAIN {  set notdone FALSE}
        SQLNET.AUTHENTICATION_SERVICES { set notdone FALSE }
        TNSPING.TRACE_DIRECTORY { set notdone FALSE }
        SQLNET.AUTHENTICATION_GSSAPI_SERVICE { set notdone FALSE}
        SQLNET.CRYPTO_SEED { set notdone FALSE}
        SQLNET.ENCRYPTION_CLIENT { set notdone FALSE}
        SQLNET.ENCRYPTION_SERVER { set notdone FALSE}
        SQLNET.ENCRYPTION_TYPES_CLIENT { set notdone FALSE}
        SQLNET.ENCRYPTION_TYPES_SERVER { set notdone FALSE}
        SQLNET.CRYPTO_CHECKSUM_CLIENT { set notdone FALSE}
        SQLNET.CRYPTO_CHECKSUM_SERVER { set notdone FALSE}
        SQLNET.CRYPTO_CHECKSUM_TYPES_SERVER { set notdone FALSE}
        SQLNET.CRYPTO_CHECKSUM_TYPES_CLIENT { set notdone FALSE}
        SQLNET.CLIENT_REGISTRATION {  set notdone FALSE}
        NAMES.DIRECTORY_PATH { set notdone FALSE}
        TRACE_DIRECTORY_CLIENT  {  set notdone FALSE}
        TNSPING.TRACE_LEVEL { set notdone FALSE}
        TRACE_FILE_CLIENT  {  set notdone FALSE}
        TRACE_LEVEL_CLIENT { set notdone FALSE}
        LOG_DIRECTORY_CLIENT  { set notdone FALSE}
        LOG_FILE_CLIENT  { set notdone FALSE}
        TRACE_UNIQUE_CLIENT {  set notdone FALSE}
        USE_DEDICATED_SERVER {  set notdone FALSE}
        DISABLE_OOB {  set notdone FALSE}
        AUTOMATIC_IPC {  set notdone FALSE}
        default { 
                  if { $DEBUG } { puts -nonewline "... $result... "}
        }
      }
      # end switch 
      if {$notdone} {
        set result [GetToken $sn ] 
        set result [string trim $result]
      }
  }
  # end while loop

  if {$addresslist_found} {
    if { $DEBUG } { puts "****** paren mismatch in sqlnet.ora file at ADDRESS_LIST level " }
    set errors "ADDRESS_LIST -Found sqlnet variable name before end of address." 
    set nsaddrlistm ""
  }
  if {$address_found} {
    if { $DEBUG } { puts "****** paren mismatch in sqlnet.ora file at ADDRESS level " }
    set errors "ADDRESS - Found sqlnet variable name before end of address." 
    set nsaddrlistm ""
  }
  return $nsaddrlist
}

######################################################
# save sqlnet.ora options to file
######################################################
proc GetToken {sn} {
  global errors DEBUG fileline

  set fileline [string trim $fileline]
  set quote [string first "'" $fileline]; 
  if {$quote == "0" } {
        #found quote
        set fileline [string range $fileline 1 end]
        if { $DEBUG } { puts  "GET_TOKEN found extra QUOTE..." }
  } 

  if { $DEBUG } { puts -nonewline "\n==>>>> GET_TOKEN inline => $fileline..." }
  if {[eof $sn] } {
    return "EOF"
  } else {
    if {$fileline == ""} {
      if {![eof $sn] } {
        if { $DEBUG } { puts  "GET_TOKEN found EOL..." }
        set new [gets $sn fileline]
        if { $DEBUG } { puts -nonewline "GET_TOKEN new line $fileline..." }
        return ""
      } else {
        if { $DEBUG } { puts  "GET_TOKEN found EOF..." }
        return "EOF"
      }
    } else {
      ## still have more on line, left or right paren?
      set rparen [string first ")" $fileline]; 
      if {$rparen == "0" } {
        #found right paren
        set fileline [string range $fileline 1 end]
        if { $DEBUG } { puts  "GET_TOKEN found RPAREN..." }
        return "RPAREN"
      } else {
        set lparen [string first "(" $fileline]; 
        if {$lparen == "0" } {
          #found left paren
          set fileline [string range $fileline 1 end]; 
          if { $DEBUG } { puts  "GET_TOKEN found LPAREN..." }
          return "LPAREN"
        } else {
          set equalplace [string first "=" $fileline]; 
          if {$equalplace == "0" } {
            #found value to equal or another left paren?
            set fileline [string range $fileline 1 end]
            set fileline [string trim $fileline]
            set lparen [string first "(" $fileline];
            if {$lparen == "0"} {
              if { $DEBUG } { puts -nonewline "GET_TOKEN found LPAREN after EQUAL, next level..." }
              return "EQUAL"
            } else {
              if { $DEBUG } { puts -nonewline "GET_TOKEN found NO LPAREN $lparen on line after EQUAL..." }
              set rparen [string first ")" $fileline];
              if {$rparen == "-1"} {
                set value $fileline
                if { $DEBUG } {puts -nonewline "GET_TOKEN found NO RPAREN $rparen, VALUE = $value..." }
              } else {
                set endvalue $rparen
                incr endvalue -1
                set value [string range $fileline 0 $endvalue]
                set fileline [string range $fileline $rparen end]
                if { $DEBUG } { puts -nonewline "GET_TOKEN found RPAREN $rparen, VALUE = $value..." }
              }
              if { $DEBUG } { puts  "    GET_TOKEN VALUE = $value..." }
              return $value
            }
          } else {
            #found id ? or more left paren?
            set equalplace [string first "=" $fileline]; 
            set endname $equalplace
            incr endname -1
            set token [string range $fileline 0 $endname];
            set name [string toupper $token]
            set fileline [string range $fileline $equalplace end]
            if { $DEBUG } { puts  "    GET_TOKEN ID is $name to an EQUAL..." }
            return $name 
          }
        }
      }
    }
  }
}

######################################################
# save sqlnet.ora options to file
######################################################
proc PutSqlnetOption {option invalue} {
  global tns_admin user home oracle_home sqlnettmpfile errors DEBUG fileline
  global syssqlnetfilelocation usersqlnetfilelocation viewsqlnet

  set errors ""
  set newfile ""
  set notfound TRUE
  set fileline ""
  set value $invalue
  set sqlnetfiletouse ""
  if {$viewsqlnet == "SYSTEM" } {
    set sqlnetfiletouse $syssqlnetfilelocation
    if {$sqlnetfiletouse == ""} {
      if {$tns_admin == ""} {
        set sqlnetfiletouse $oracle_home/network/admin/sqlnet.ora
      } else {
        set sqlnetfiletouse $tns_admin/sqlnet.ora
      }
    }
  } else {
    set sqlnetfiletouse $usersqlnetfilelocation
    if {$sqlnetfiletouse == ""} {
        set sqlnetfiletouse $home/.sqlnet.ora
    }
  }
  if { $DEBUG } { puts ">>>Start PutSqlnetOption"; 
               puts "$sqlnetfiletouse read => $option = $value for > $sqlnettmpfile" }
  
  if {! [file exists $sqlnetfiletouse] } {
    if {! [file readable $sqlnetfiletouse] } {
      if {[file writable [file dirname $sqlnetfiletouse] ]} {
        set insqlnet [open $sqlnetfiletouse w]
        puts $insqlnet "### new $viewsqlnet sqlnet.ora file"
        close $insqlnet
        if {$viewsqlnet == "SYSTEM" } {
          set syssqlnetfilelocation $sqlnetfiletouse 
        } else {
          set usersqlnetfilelocation $sqlnetfiletouse 
        }
        set newfile "Saving by creating $viewsqlnet File \n$sqlnetfiletouse"
      }
    }
  }

if {[file readable $sqlnetfiletouse] } {
  set insqlnet [open $sqlnetfiletouse r]

  set tmpsqlnet [open $sqlnettmpfile w]
  set notdone TRUE
  while { $notdone } {
      if { [eof $insqlnet] } {
        set notdone FALSE
        if {$notfound} { 
          set name $option
          if { $DEBUG } { puts "        **** End. adding new $option = $value" }
        }
      } else {
        set new [gets $insqlnet fileline]
        set equalplace [string first "=" $fileline]; incr equalplace -1
        set tmpvar [string range $fileline 0 $equalplace]; set tmpname [string trim $tmpvar]
        set name [string toupper $tmpname]
        set tmp [lindex $fileline 0]
        set name [string toupper $tmp]
      }

    if { $DEBUG } { puts "line => $option <=> $name " }
    switch $name {
      AUTOMATIC_IPC { 
                              if {$option == "AUTOMATIC_IPC"} {
                                set value [string toupper $invalue]
                                set notfound FALSE; puts $tmpsqlnet "$option = $value" 
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      TRACE_UNIQUE_CLIENT { 
                              if {$option == "TRACE_UNIQUE_CLIENT"} {
                                set value [string toupper $invalue]
                                set notfound FALSE; puts $tmpsqlnet "$option = $value" 
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      DISABLE_OOB {          
                             if {$option == "DISABLE_OOB"} {
                                set value [string toupper $invalue]
                                set notfound FALSE; puts $tmpsqlnet "$option = $value" 
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      USE_DEDICATED_SERVER { 
                              if {$option == "USE_DEDICATED_SERVER"} {
                                set value [string toupper $invalue]
                                set notfound FALSE; puts $tmpsqlnet "$option = $value" 
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.CLIENT_REGISTRATION { 
                              if {$option == "SQLNET.CLIENT_REGISTRATION"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      LOG_DIRECTORY_CLIENT  { if {$option == "LOG_DIRECTORY_CLIENT"} {
                                set notfound FALSE;
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      LOG_FILE_CLIENT  { if {$option == "LOG_FILE_CLIENT"} {
                                set notfound FALSE;
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      TRACE_FILE_CLIENT { if {$option == "TRACE_FILE_CLIENT"} {
                                set notfound FALSE;
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      TRACE_LEVEL_CLIENT {if {$option == "TRACE_LEVEL_CLIENT"} {
                                set notfound FALSE;
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      TRACE_DIRECTORY_CLIENT { 
                              if {$option == "TRACE_DIRECTORY_CLIENT"} {
                                set notfound FALSE;
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      TNSPING.TRACE_LEVEL  { 
                              if {$option == "TNSPING.TRACE_LEVEL"} {
                                set notfound FALSE;
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      TNSPING.TRACE_DIRECTORY  { 
                              if {$option == "TNSPING.TRACE_DIRECTORY"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.AUTHENTICATION_SERVICES {
                              if {$option == "SQLNET.AUTHENTICATION_SERVICES"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts -nonewline $tmpsqlnet "$option = (" 
                                  set item [lindex $value 0]
                                  puts -nonewline $tmpsqlnet "$item" 
                                  set rest [lrange $value 1 end]
                                  foreach item $rest {
                                    puts -nonewline $tmpsqlnet ", $item" 
                                  }
                                  puts $tmpsqlnet ")" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.AUTHENTICATION_GSSAPI_SERVICE {
                              if {$option == "SQLNET.AUTHENTICATION_GSSAPI_SERVICE"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.CRYPTO_SEED {
                              if {$option == "SQLNET.CRYPTO_SEED"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.ENCRYPTION_CLIENT {
                              if {$option == "SQLNET.ENCRYPTION_CLIENT"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.ENCRYPTION_SERVER {
                              if {$option == "SQLNET.ENCRYPTION_SERVER"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.ENCRYPTION_TYPES_CLIENT {
                              if {$option == "SQLNET.ENCRYPTION_TYPES_CLIENT"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts -nonewline $tmpsqlnet "$option = (" 
                                  set item [lindex $value 0]
                                  puts -nonewline $tmpsqlnet "$item" 
                                  set rest [lrange $value 1 end]
                                  foreach item $rest {
                                    puts -nonewline $tmpsqlnet ", $item" 
                                  }
                                  puts $tmpsqlnet ")" 
                                }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.ENCRYPTION_TYPES_SERVER {
                              if {$option == "SQLNET.ENCRYPTION_TYPES_SERVER"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts -nonewline $tmpsqlnet "$option = ("
                                  set item [lindex $value 0]
                                  puts -nonewline $tmpsqlnet "$item"
                                  set rest [lrange $value 1 end]
                                  foreach item $rest {
                                    puts -nonewline $tmpsqlnet ", $item"
                                  }
                                  puts $tmpsqlnet ")" 
                                }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.CRYPTO_CHECKSUM_CLIENT {
                              if {$option == "SQLNET.CRYPTO_CHECKSUM_CLIENT"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.CRYPTO_CHECKSUM_SERVER {
                              if {$option == "SQLNET.CRYPTO_CHECKSUM_SERVER"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.CRYPTO_CHECKSUM_TYPES_SERVER {
                              if {$option == "SQLNET.CRYPTO_CHECKSUM_TYPES_SERVER"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts -nonewline $tmpsqlnet "$option = ("
                                  set item [lindex $value 0]
                                  puts -nonewline $tmpsqlnet "$item"
                                  set rest [lrange $value 1 end]
                                  foreach item $rest {
                                    puts -nonewline $tmpsqlnet ", $item"
                                  }
                                  puts $tmpsqlnet ")" 
                                }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      SQLNET.CRYPTO_CHECKSUM_TYPES_CLIENT {
                              if {$option == "SQLNET.CRYPTO_CHECKSUM_TYPES_CLIENT"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts -nonewline $tmpsqlnet "$option = ("
                                  set item [lindex $value 0]
                                  puts -nonewline $tmpsqlnet "$item"
                                  set rest [lrange $value 1 end]
                                  foreach item $rest {
                                    puts -nonewline $tmpsqlnet ", $item"
                                  }
                                  puts $tmpsqlnet ")" 
                                }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      NAMES.DIRECTORY_PATH {
                              if {$option == "NAMES.DIRECTORY_PATH"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts -nonewline $tmpsqlnet "$option = ("
                                  set item [lindex $value 0]
                                  puts -nonewline $tmpsqlnet "$item"
                                  set rest [lrange $value 1 end]
                                  foreach item $rest {
                                    puts -nonewline $tmpsqlnet ", $item"
                                  }
                                  puts $tmpsqlnet ")" 
                                }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      NAME.DEFAULT_ZONE { 
                              if {$option == "NAMES.DEFAULT_DOMAIN"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "NAME.DEFAULT_ZONE = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      NAMES.DEFAULT_DOMAIN { 
                              if {$option == "NAMES.DEFAULT_DOMAIN"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  puts $tmpsqlnet "$option = $value" 
                                } else {  puts $tmpsqlnet "# $fileline" }
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      NAMES.PREFERRED_SERVERS {
                              if {$option == "NAMES.PREFERRED_SERVERS"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  if { $DEBUG } { puts "  list => $value" }
                                  set result [GetAddress $insqlnet]
                                  puts $tmpsqlnet "$option = "
                                  puts $tmpsqlnet "  (ADDRESS_LIST = "
                                  foreach add_item $value {
                                    puts $tmpsqlnet "    (ADDRESS = "
                                    if { $DEBUG } { puts "    from list => $add_item" }
                                    puts $tmpsqlnet "      (COMMUNITY = [lindex $add_item 1])"
                                    puts $tmpsqlnet "      (PROTOCOL = [lindex $add_item 2])"
                                    puts $tmpsqlnet "      (HOST = [lindex $add_item 3])"
                                    puts $tmpsqlnet "      (PORT = [lindex $add_item 4])"
                                    puts $tmpsqlnet "    )" 
                                  }
                                  puts $tmpsqlnet "  )" 
                                } else { 
                                  set result [GetAddress $insqlnet] 
                                }
                                puts $tmpsqlnet "$fileline" 
                              } else { puts $tmpsqlnet "$fileline"  } 
      }
      NAME.PREFERRED_SERVERS {
                              if {$option == "NAME.PREFERRED_SERVERS"} {
                                set notfound FALSE; 
                                if {$value != ""} {
                                  if { $DEBUG } { puts "  2list => $value" }
                                  set result [GetAddress $insqlnet]
                                  puts $tmpsqlnet "NAME.PREFERRED_SERVERS = "
                                  puts $tmpsqlnet "  (ADDRESS_LIST = "
                                  foreach add_item $value {
                                    if { $DEBUG } { puts "    from 2list => $add_item" }
                                    puts $tmpsqlnet "    (ADDRESS = "
                                    puts $tmpsqlnet "      (COMMUNITY = [lindex $add_item 1])"
                                    puts $tmpsqlnet "      (PROTOCOL = [lindex $add_item 2])"
                                    puts $tmpsqlnet "      (HOST = [lindex $add_item 3])"
                                    puts $tmpsqlnet "      (PORT = [lindex $add_item 4])"
                                    puts $tmpsqlnet "    )" 
                                  }
                                  puts $tmpsqlnet "  )" 
                                } else { 
                                  set result [GetAddress $insqlnet] 
                                }
                                puts $tmpsqlnet "$fileline" 
                              } else {  puts $tmpsqlnet "$fileline" }
      }
      default { if { $fileline != "" } {puts $tmpsqlnet "$fileline"}
      }
    }
    # end switch 
    set fileline ""
    if { $DEBUG } { puts -nonewline "...$option not found >> $notfound..." }
  } 
  # end while loop

  close $insqlnet
  close $tmpsqlnet
  if { [file writable $sqlnetfiletouse ] } {
    if {[file exists $sqlnetfiletouse.$user]} {
    } else {
      catch {eval exec "/bin/mv -f $sqlnetfiletouse $sqlnetfiletouse.$user"} result
    } 
    catch {eval exec "/bin/mv -f $sqlnettmpfile $sqlnetfiletouse"} result
    set errors "$newfile \n\n Saved changes to $viewsqlnet sqlnet.ora file $sqlnetfiletouse"
    if { $DEBUG } { puts ""; puts "done moving new sqlnet file over."}
  } else {
    set errors "could NOT write to $viewsqlnet sqlnet.ora - saved $option in $sqlnettmpfile"
  }
  return TRUE
} else {
  set errors "could NOT write to $viewsqlnet sqlnet.ora - did NOT save changes"
  return FALSE
}
}
  
######################################################
# find out which products have been installed
######################################################
proc GetProducts {} {
  global oracle_home sqlnetversion productlist errors productlistfilelocation DEBUG

  set productlist ""
  if {[file exists $productlistfilelocation]} {
    set prods [open $productlistfilelocation r]
    while {![eof $prods] } {
      set new [gets $prods line]
      set productnmc [lindex $line 3]
      set version [lindex $line 4]
      set title [lindex $line 5]
  
      if {($version != "\[\]") && ($version != "")} {
        if { $DEBUG } { puts "  .....   parsing installed products => $productnmc $title $version " }
        if {$productnmc == "network"} {set sqlnetversion $version}
        set tmp "$title    $version" 
        set new [lappend productlist $tmp]
        if { $DEBUG } { puts -nonewline "products found => $tmp" }
      }
    }
    close $prods
  }
}

######################################################
# find out which protocols have been installed
######################################################
proc GetProtocols {} {
  global oracle_home errors DEBUG TEST nameslist 
  global protocollistfilelocation protocollist cryptolist authlist encryptlist 

  set securelist ""
  set protocollist ""
  set nameslist ""
  set line ""
  if {[file exists $oracle_home/bin/adapters] } {
    if {$TEST} {
      catch {eval exec "adapters > $protocollistfilelocation"} result
    } else {
      catch {eval exec "$oracle_home/bin/adapters > $protocollistfilelocation"} result
    }
    if { $DEBUG } { puts "   get adapters " }
    set secure FALSE
    set prot FALSE
    set names FALSE

    if {[file exists $protocollistfilelocation]} {
      set adp [open $protocollistfilelocation]
      while {![eof $adp] } {
        set new [gets $adp newline]
        if {$line != ""} {
          #if { $prot } {
          #    set new [lappend protocollist $line]
          #}
          if { $secure } {
            set new [lappend securelist $line]
          }
          #if { $names } {
          #  set new [lappend nameslist $line]
          #}
        }
  
        if {([string first "V2 Protocol" $newline ] != "-1") } {
           set prot TRUE
           set line ""
        } else {
          if { ([string first "security" $newline ] != "-1") } {
             set secure TRUE
             set prot FALSE
             set line ""
          } else {
            if { ([string first "Naming" $newline ] != "-1") } {
               set names TRUE
               set secure FALSE
               set line ""
            } else {
              set line $newline
            }
          }
        }
  
        if { $DEBUG } { puts "   add => $line"; 
               puts ">>>>>=> $line,  <<<  $protocollist, $nameslist." }
      }
      close $adp
    } else {
      set errors "Could not find protocl file"
    }
  } else {
    set errors "Could not find installation of adapters"
  }
  if {$securelist != ""} {
    foreach item $securelist {
      if {[string first "encryption" $item ] != "-1" } {
        lappend encryptlist [lindex $item 0]
      } else {
        if {[string first "crypto-checksumming" $item ] != "-1" } {
          lappend cryptolist [lindex $item 0]
        } else {
          if {[string first "Authentication" $item ] != "-1" } {
            lappend authlist [lindex $item 0]
          }
        }
      }
    }
    if { $DEBUG } { puts "   security menus => $cryptolist $authlist $encryptlist." }
  }
}

######################################################
# find out which protocols have been installed
######################################################
proc LprFaxPage {} {
  global DEBUG errors faxpagelocation printfilename

  GetCsiInfo
  GetConfigFiles
  MakeFaxPage 
  set printfilename $faxpagelocation
  if { $DEBUG } { puts "Report File to print: $faxpagelocation"}
  PrintFile 
}

######################################################
# find out which protocols have been installed
######################################################
proc PrintFile {} {
  global errors DEBUG printfilename

  if { $DEBUG } { puts "In PrintFile. File to print: $printfilename"}
  if {[file readable $printfilename]} {
    set errors "Printing $printfilename ..."
    catch {eval exec "lpr $printfilename"} result
  } else {
    set errors "Did NOT Print \n$printfilename\nWas not find a readable file."
  }
}

########################################################################################
# see how an alias is resolved using tns
########################################################################################
proc ResolveAlias {aliasstring filetotrace} {
  global DEBUG TEST errors sourcestring address oracle_home

  set result ""
  if { $DEBUG } { puts "   $aliasstring" }
  ###porting notes
  if {$TEST} {
    set command "csmnl -r $aliasstring"
  } else {
    set command "$oracle_home/bin/csmnl -r $aliasstring" 
  }
  catch {eval exec $command} tmpresult
  set sourcestring [lindex $tmpresult 0]
  set result [lrange $tmpresult 1 end]
  set address $result
  return $result
}
 
########################################################################################
# try a connection using the connect sting values
########################################################################################
proc ConnectAlias {aliasstring filetotrace traceconnect} {
  global DEBUG TEST errors oracle_home address sourcestring 

  if {$aliasstring == ""} {
      set result "Connection not attempted, Service Name is blank."
  } else {
    set address [ResolveAlias $aliasstring $filetotrace]
    if { $DEBUG } { puts "$aliasstring for connect is $address" }
    set command "$oracle_home/bin/tnsping $aliasstring" 
    catch {eval exec $command} tmpresult 
  
    if { $DEBUG } { puts "$tmpresult" }
    set found [string first "OK" $tmpresult]
    if {$found ==  "-1"} {
      set place [string first "TNS-" $tmpresult]
      set error [string range $tmpresult $place end]
      set result "TNSPing Attempt Unsuccessful.\n$error"
    } else {
      set result "TNSPing Successful.\nConnected to Listener for\n$aliasstring."
    }
  
    ###porting notes
    # to put in tracing option?
  
    ### can use this when diag program works
    # if {$TEST} {
    #   set command "csmnl -c $address" 
    # } else {
    #  set command "$oracle_home/bin/csmnl -c $address" 
    # }
    # catch {eval exec $command} result 
    # set command "$oracle_home/bin/oerr ora $result" 
    # set result [eval exec $command]
  }
  set errors "$result"
}
