#
#   $Header: /netrcs/RCS/oracle/network/csm/RCS/csmman.man,v 1.5 1995/12/15 18:41:26 dmcbride Exp $
#   Copyright (C) 1995 David McBride
#
#
# NAME
#   
# CONTENTS
#   man page for SQL*Net Client's  Status Monitor
#   
# NOTES
#
# OWNER
#   dmcbride
# DATE
#   10/13/95
# MODIFIED
# 
#
#
######################################
man page:    Status Monitor

Status Monitor utilizes the tcl or tk to create an easy to use line or gui mode application 
for evaluating the sqlnet environment for a potential connection to an Oracle database using 
a Service Name.

Usage: csm

In line mode these are possible.
Usage: csm
Usage: csm <command>
Usage: csm show <option>
Usage: csm set <option> <value>

Invocation
==========
csm invokes a unix shell that first evaluates the user's environment, then starts tk's 
wish if the TK_LIBRARY variable has been set, or tcl's tclsh if the TCL_LIBRARY 
variable has been set.  Otherwise an error message appears suggesting an appropriate 
course of action. 

Setup Required
==============
A user needs to set unix environment variables, either the TK_LIBRARY or the TCL_LIBRARY.  
TK_LIBRARY or TCL_LIBRARY must be set to where the system administrator has placed the 
installation of tcl or tk library (usually /usr/local/lib).

Window Mode
************ ************ ************ ************ ************ ************ ************ 

Main Window
------------
The main window displays the 5 major dialogs - General, Network Protocol Adapters,
Secure Network Services, Native Naming Adapters, and Resolve Service Name - along
with the menu bar which allows access to the customer support information, unix 
environment information, and sqlnet.ora editor.  The main window is the foundation
window from which other information is found.

General
=========================
This window shows the user which version of sqlnet will be used when a connection
is attempted.  It displays the names of the sqlnet.ora files found in your 
environment during configuration initialization.  Log File and Trace File display
the file names used by those functions when they write out connection information.
The trace level value, found in the sqlnet.ora file, shows the level of the
tracing when a connection is made or attempted.  
Registration displays the value set in the sqlnet.ora file to uniquely identify the client.

You can browse any of the files listed by selecting the browse button, and print them by
pressing print.

Network Protocol Adapters
=========================
This window shows the ACTUALLY installed adapters.

Secure Network Services
=========================
This window shows the ACTUALLY installed services plus the type
of authentication specified in the sqlnet.ora configuration file.
The encryption and cryto checksum services settings are shown as well.
All of these values must agree with the server configuration to complete a 
connection.
Note that if the client is acting as a client, only the client services selected
 apply. If the client is acting as a server, only the server services selected 
apply.
Name Resolution Services
=========================
This window shows the ACTUALLY installed servces plus the methods sqlnet
will use to resolve a Service Name.

Resolve Service Name
=========================
This window provides diagnostic information about connection requests for a 
user. A user enters a Service Name, then can choose the Resolve button or Connect button.
 
The Resolve function shows what address is used for a connection.  Source shows
what name resolution method is used to resolve that Service Name.
Note: Service Name is the only field that accepts user input on this screen.
 
The Connect button initiates a tnsping command. It uses the service name to contact 
the listener of the database. (Alternatively, sqlplus or server manager can
be used to connect directly to the database account.) The TNSPing Trace Level is
 set in the sqlnet.ora file, and you can use the sqlnet.ora editor to change it.
 Select Browse to read the TNSPing file that results.

Sqlnet.ora Editor Menu
-----------
From the sqlnet.ora editor menu, select the sqlnet.ora file you want to edit. 
The values in the user level file take precedence over the values in the system 
level file. The system level file may not be writable.

SQLNet Editor
=========================
You can edit the following optional parameter values in sqlnet.ora:
 
Registration
Enter a unique identifier for the client machine. This identifer is passed to 
the listener with any connection request and is included in the Audit Trail. The
identifier can be any alphanumeric string.
 
Client Trace Level
Select a trace level from the scrolling list. Unless you are trouble-shooting a
particular problem, the trace level should be OFF. Other choices are USER, for a
 moderately detailed trace report, and ADMIN, for more extensive trace 
information.
 
NOTE: After trouble-shooting your connection problem, turn trace level back to 
OFF. Leaving the trace facility on can impact performance.

Client Trace File Name
You can change the existing name of the trace file in this field. In most 
operating systems, the trace file name is  automatically appended with the
 suffix .TRC. You do not need to enter that suffix in the field.
 
Client Trace Directory
You can change the existing directory to which the client trace file is written
in this field. Be sure that you have write permission to the directory you select.
 
TNSPing Trace Level
If you want to trace the behavior of the TNSPing utility, select a trace level 
from the scrolling list. Unless you are trouble-shooting a particular problem,
 the trace level should be OFF. Other choices are USER, for a moderately detailed 
trace report, and ADMIN, for more extensive trace information.
 
NOTE: After trouble-shooting your connection problem, turn trace level back to 
OFF. Leaving the trace facility on can impact performance.

TNSPing Trace Directory
To override the default location of the TNSPing trace file, enter it in this field. 
Be sure that you have write permission to the directory you select.
 
You can toggle the following features on and off by selecting the buttons next
to their names.
 
Automatic IPC
Select this button if you want the client to try an IPC (internal) connection
before trying other protocols. The default is for Automatic IPC to be on.
 
Use Dedicated Server
Select this button if you want to make a connection to a dedicated server rather
 than to use a multi-threaded server.
 
DISABLE Out of Band Breaks (OOB)
Select this button if you want to disable out of band breaks.

The TK version of the product has an enhanced sqlnet.ora editor with online help
windows for each dialog window encountered.

Environment Menu
----------------
This menu provides a choice of read-only windows displaying UNIX environment variables,
SQL*Net configuration files, and installed Oracle products.

Unix Variables
=========================
Displays the environment variables set for your machine.

SQLNet Config Files
=========================
Displays the paths of all the SQL*Net configuration files on the client machine. You can select
one and press Browse to display a file. While it is displayed, select print to print it.

Installed Products
=========================
Displays a list of all installed Oracle products on this machine.

Support Information Menu
--------------------

CSI Editor
=========================
Displays an editable window showing Customer Support Information. Use this window to provide
identifying information for Oracle Support. This information will be included on the fax page
that the Client Status Monitor creates.

From Person
Name of the person at your location who is the liason with Oracle Support

Phone
Phone number of the leason with Oracle Support

Fax Number
Fax number of the liason with Oracle Support

Support ID
Oracle customer support ID (to authorize you to receive Oracle Support).

Subject
Short text on the main idea of problem.

Comment
Please enter text less than 80 characters long, no return or enter needed at end.

Line Mode
************ ************ ************ ************ ************ ************ ************ 

In line mode the status Monitor can either accept one command at a time, or run interactively, 
much line a unix shell.  The help command displays the available commands and their options.

Show All
	The Show All displays the various sqlnet values, Network Protocol Adapters, Secure 
Network Services, Name Resolution Services, and Resolve Service Name along with 
the Customer Support Information, Unix environment information, and the sqlnet.ora options.  
Information includes: the show all displays the version of sqlnet currently being used. 
-  The sqlnet.ora files are those found in your environment during configuration initialization.  
-  Log File and Trace File display the paths used by those functions when they write out 
connection information.  
-  Registration displays the value set by the user or system administrator in the 
sqlnet.ora file to identify this client.
-  The trace level value, found in the sqlnet.ora file, shows the level of the 
tracing when a connection attempt occurs. 
  
Show Network Protocol Adapters 
	This command shows the installed protocol adapters with version numbers.

Show Secure Network Services 
	This command shows the currently installed services plus the type of authentication 
specified in the sqlnet.ora configuration file. The encryption and cryto checksum services 
settings are shown as well. These values must be compatible with the settings for the server 
configuration for a connection to complete successfully.

	Note: that if the client is acting as a client, only the client services selected apply. 
If the client is acting as a server, only the server services selected apply.

Show Name Resolution Services 
	This command shows the currently installed names resolution services and the 
preferred methods used to resolve a Service Name. The preferred methods are obtained 
from the sqlnet.ora file.
  
Resolve Service Name 
	This command provides diagnostic information about connection requests for a user. 
A user provides a Service Name.  The Resolve function shows the address that is used for a 
connection.  Source indicates what name resolution method is used to resolve that Service Name.  

Attempt Connect 
	The command executes tnsping. It uses the service name to contact the listener of the 
database. (Alternatively, sqlplus or server manager can be used to connect directly to the 
database account.) The TNSPing Trace Level is set in the sqlnet.ora file, and you can use 
the Set command to change it. 
  
Show User or System SQLNet.ora Values
	This command enables you to edit certain optional parameters in the system or user 
sqlnet.ora file.  
    
From the Set command, select the sqlnet.ora option you want to change. The values in the user 
level file take precedence over the values in the system level file. The system level file 
may not be writable.  You can edit the following optional parameter values with Set:

Set Registration <id>
	Enter a unique identifier for the client machine. This identifer is passed to the 
listener with any connection request and is included in the Audit Trail.  The identifier 
can be any alphanumeric string.
 
Set Client Trace Level <OFF, USER, ADMIN>
	Select a trace level from the scrolling list. Unless you are trouble-shooting 
a particular problem, the trace level should be OFF. Other choices are USER, for a 
moderately detailed trace report, and ADMIN, for more extensive trace information.
 
NOTE: After trouble-shooting your connection problem, turn trace level back to OFF. 
Leaving the trace facility on can impact performance.

Set Client Trace File Name <name>
	You can change the existing name of the trace file in this field. In most operating 
systems, the trace file name is  automatically appended with the suffix .TRC. You do not 
need to enter that suffix in the field.
 
Set Client Trace Directory <directorypath>
	You can change the existing directory to which the client trace file is written 
in this field. Be sure that you have write permission to the directory you select.
 
Set TNSPing Trace Level <OFF, USER, ADMIN>
	If you want to trace the behavior of the TNSPing utility, select a trace level 
from the scrolling list. Unless you are trouble-shooting a particular problem, the 
trace level should be OFF. Other choices are USER, for a moderately detailed trace 
report, and ADMIN, for more extensive trace information.

	NOTE: After trouble-shooting your connection problem, turn trace level back to OFF. 
Leaving the trace facility on can impact performance.
 
Set TNSPing Trace Directory <directorypath>
	To override the default location of the TNSPing trace file, enter it in this field. 
Be sure that you have write permission to the directory you select.
 
	You can toggle the following features on and off by selecting the buttons next to 
their names.
 
Set Automatic IPC <ON, OFF>
	Select this button if you want the client to try an IPC (internal) connection
before trying other protocols. The default is for Automatic IPC to be on.
 
Set Use Dedicated Server <ON, OFF>
	Select this button if you want to make a connection to a dedicated server rather 
than to use a multi-threaded server.
 
Set DISABLE Out of Band Breaks (OOB) <ON, OFF>
	Select this button if you want to disable out of band breaks.
 
For further information about the Trace parameters, see Chapter 2 in this manual .  For 
further information about all other optional parameters, please refer to the appropriate 
sections in Understanding SQL*Net.
  
Show Environment Information 
	This command enables you to display information about your environment. All the 
command are read-only and cannot be edited.  This command provides UNIX environment, 
configuration files, and installed products information.  Displays the environment 
variables set for your machine.

Show Installed Products
	Displays a list of all installed Oracle products on this machine.

Show SQL*Net Configuration Files
	Displays the paths of all the SQL*Net configuration files on the client machine. 
Select one and select Browse to display a file.  While it is displayed, select Print 
to print it.

Show Customer Support Information 
	This command provides information on various items of interest to Oracle's customer 
support personnel.  
    
	From the Support Info command, select CSI Editor (Customer Support Information) to 
display a command in which you can provide identifying information for Oracle Support. 
This information will be included on the fax page that the Client Status Monitor creates.

	Enter the following information using the the appropriate command:
Set Contact Person <name>
	Name of person at your location who is the liason with Oracle Support
Set Phone <number>
	Phone number of the liason with Oracle Support
Set Fax Number <number>
	Fax number of the liason with Oracle Support
Set Customer Support ID <id>
	Identifying number that authorizes you to get help from Oracle Support
  
Print Fax Page
	This command enables you to print a fax page that includes diagnostic information.
    
Quit to exit the Client Status Monitor.
  
