//
//  dmuICdvdecoder.h
//
//  Author: Tim Davison
//  Date:   Oct, 1996
//
//  <dmu>
//  <B>
//  This class uses an unsupported and unreleased features.  You need
//  a special dmedia libraries to use this object.  </B>
//
//  This objects decompresses dv frames that are given to it.  This
//  object is a subclass of the <I>dmuIC</I> object.
//  This objects overrides the setup method to pick the correct
//  image conversion context for DV.
//  </dmu>
//
#ifndef _DMUICDVDECODER_H
#define _DMUICDVDECODER_H

#include "dmuIC.h"

class dmuICdvdecoder : public dmuIC {
public:

  // Constructor:  This is the constructor that setups up some default
  // values.  If you use this constructor, you must set the image
  // width and height before you call the setup method.  
  dmuICdvdecoder();

  // Constructor: You probably want to use this constructor.  It set some
  // default values and sets the image width and height.  
  dmuICdvdecoder(int imageSizeX, int imageSizeY);

  // Destructor:  Right now this does nothing other than implicitly calling
  // the superclass' destructor
  virtual ~dmuICdvdecoder();

  // This is the method that creates the image conversion context.  When
  // creating the conversion context, the object has to know a couple
  // of different things.  They are shown below with defaults.
  // <TABLE BODER=1>
  // <TR><TD> Compressions Type</TD><TD>
  //            DV</TD></TR>
  // <TR><TD> Conversion Direction</TD><TD>
  //            DM_IC_CODE_DIRECTION_DECODE</TD></TR>
  // </TABLE><P>
  // If these parameters are not right, you must change them before you
  // call this method.  The conversion context is passed to VICE with
  // every request, so that VICE knows what it is supposed to do.
  int setup();

protected:

private:
};

#endif // _DMUICDVDECODER_H
