#ifndef _DMUMOVIE_H
#define _DMUMOVIE_H

#include "dmuObj.h"

// <dmu> The dmuMovie acts as a base class for all the dmuMovie
// objects.  currently there is not much implemented in this class,
// and most methods are virtual.  Once more objects are implmented
// under dmuMovie, the commonalities between the objects will be
// extracted into dmuMovie.  This object just keeps a few member
// variables that will obviously fall into this category. </dmu>

class dmuMovie:public dmuObj {

public:

  // The constructor initializes member variables.
  dmuMovie();

  // The destructor performs norman dmuObj destruction. 
  virtual ~dmuMovie();


  // <dmu> 
  // <LI> <B>Virtual Methods</B> - The following methods are pure
  // virtuals and are implemented in classes that inherit from
  // dmuMovie <UL> 
  // </dmu>


  virtual int init(dmuParams *params = NULL);
  virtual int addSrcConstraints(DMparams *params);
  virtual int addDstConstraints(DMparams *params);
  virtual int start(int propagate = DMU_PROPAGATE);
  virtual int getFD();
  virtual int receive(DMbuffer inBuffer);
  virtual int handleEvents(fd_set fdSet);

protected:
  
  int movieStarted;
private:
};

#endif
