#ifndef _DMUMOVIECHAIN_H
#define _DMUMOVIECHAIN_H

#include "dmuChain.h"
#include "dmuMovieIn.h"
#include "dmuMovieInRender.h"
#include "dmuMovieInCompressed.h"
#include "dmuICjdecoder.h"
#include "dmuPixelTrans.h"

class dmuMovieChain:public dmuChain {
public:
  dmuMovieChain();
  ~dmuMovieChain();

  int setup();
  int setup(char *fileName);

  // These are things that we expose from our movie object.
  void getImageDimensions(int *sizeX,int *sizeY);
  void getBufferDimensions(int *sizeX,int *sizeY);
  int getImageSizeX();
  int getImageSizeY();
  int getBufferSizeX();
  int getBufferSizeY();

  void movieTexCoord2d(GLdouble x, GLdouble y);
  void movieTexCoord2f(GLfloat x, GLfloat y);


protected:
  int        compressionType;
  char       *fileName;
  dmuMovieIn *movieIn;

  int setupHardwareJPEGPath();
  int setupSoftwareDecodePath();
  
};

#endif
