#ifndef _DMUCMOVIEIN_H
#define _DMUCMOVIEIN_H

#include "dmuMovieIn.h"

// <dmu> The dmuMovieInCompressed class implements the functionality
// needed to read raw, compressed JPEG frames into an DMbuffer.
// To do this, the object uses the movie library to perform
// an <i>mvReadCompressedImage(3dm)</i> operation into a DMbuffer. </P>

// <P> This object is usually used in conjunction with a dmuICjdecoder
// object which can be used to decode video frames quickly using the
// hardware acceleration of the O2.</P>

// <P> The public interface for dmuMovieInCompressed is no different
// than that of a dmuMovieIn object.  The implementation of certain
// virtual methods (both public and protected) are what provides the
// functionality described above.  See <i>dmuMovieIn</i> for more
// information on the methods available to this class.</P> </dmu>


class dmuMovieInCompressed: public dmuMovieIn{
public:
  dmuMovieInCompressed();
  ~dmuMovieInCompressed();
  int init(dmuParams *params = NULL);
  
  virtual int setup(char *newFileName) {fprintf (stderr, "hello\n"); return (dmuMovieIn::setup(newFileName)); }
protected:

  // Implements the appropriate read behavior to read a compressed
  // movie frame into a DMbuffer.
  virtual int getImageFrameTime(long long movieTime);
  virtual int getImageFrameIndex(int frameIndex);

private:
  
};

#endif

