//
//  dmuPixelTrans.h
//
//  Author: Tim Davison
//  Date:   Oct, 1996
//
#ifndef _DMUPIXELTRANS_H
#define _DMUPIXELTRANS_H

#include "dmuObj.h"
#include <GL/glx.h>
#include <GL/gl.h>
#include <movie.h>

class dmuPixelTrans : public dmuObj {
public:
  dmuPixelTrans();
  dmuPixelTrans(int initXSize, int initYSize);
  ~dmuPixelTrans();

  int init(dmuParams *params = NULL);

  int addSrcConstraints(DMparams *params);
  int addDstConstraints(DMparams *params);  

  int receive(DMbuffer inBuffer);
  int handleEvents(fd_set fdSet);

protected:
  DMbuffer myDMBuffer;
  int glPacking;
  DMimagepacking dmPacking;
  int pixelType;

  DMparams    *pbufParams;
  Display         *dpy;
  GLXFBConfigSGIX fbConfig;
  GLXPbufferSGIX  pbuffer;
  GLXContext      context;        
  int  setupFBConfig();
  void printFBConfig();
  
  int poolFD;
  
  int xSize;
  int ySize;
private:
  
};

#define dmerr(dmFunc, retVal)  { \
      DMstatus stat;\
      if ((stat = (dmFunc)) != DM_SUCCESS) { \
        fprintf(stderr, "dmerr failure file:%s line:%d\n",__FILE__,__LINE__);\
	char errorBuf[DM_MAX_ERROR_DETAIL]; \
	int errorNum; \
        fprintf(stderr, "Error description:%s\n", \
		dmGetError(&errorNum, errorBuf));\
        fprintf(stderr, "   errorNum:%d\n", errorNum);\
        fprintf(stderr, "   detail:%s\n", errorBuf);\
	fprintf(stderr, "   object:%s\n", getName());\
	fprintf(stderr, "   stat:%\n", stat);\
	return(retVal);\
      }\
   }

#endif // _DMUPIXELTRANS_H
