#ifndef CATMULLROM_CURVE_H
#define CATMULLROM_CURVE_H

#include "ParametricCurve.h"

// GL
#include "GL/gl.h"

#define MAX_INTERPOLATION_POINTS 50

class CatmullRomCurve: public ParametricCurve {

  public:
    CatmullRomCurve( void );

    virtual void addKnot( KNOT *whichKnot, int x, int y);
    virtual void finish( void );
    virtual Bool saturated( void );
    virtual void render( void );
    virtual Bool getPoints(int (**point)[2], int *num_points );
    virtual Bool isDirectDraw( void );
  protected:
    virtual Bool buildGeometryMatrix( KNOT whichKnot,
				      float (*geometryMatrix)[4][4] );

    virtual void renderDirect( KNOT startKnot );
  
  private:
    Bool eraseKnots;
    short knot_count;
    Bool newStroke;
};

#endif
