#ifndef PRIMITIVE_H
#define PRIMITIVE_H

#include <X11/Xlib.h>

class Primitive {
  public:
    Primitive( void );
    
    static unsigned short DRAW_STEP;

    typedef struct {
	int x, y;
    } Point;

    typedef void (*RenderPrimitiveCallback)(int,int);

    void registerPrimitiveCallback(RenderPrimitiveCallback);

    void moveTo( int x, int y);
    void drawPoint( int x, int y);
    void drawTo( int x, int y);
    void drawLine( int x0, int y0, 
		   int x1, int y1 );
    static Bool shouldDraw( void );
  void reset() {drawStep = 1;}
  
  private:
    static unsigned short	drawStep;
    RenderPrimitiveCallback	renderPrimitive;
    Point			current;
};

#endif
