#ifndef COMMON_H
#define COMMON_H

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <assert.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <arpa/inet.h>
#include <errno.h>

// General errors
#define PENT_OK                      0
#define PENT_GENERIC_ERR             1
#define PENT_VIRTUAL_CALLED_ERR      2
#define PENT_BAD_ADDR_ERR            3
#define PENT_RANGE_ERR               4
#define PENT_CONNECTION_CLOSED_ERR   5

// pentTCPSocketClient.c++ errors
#define PENT_TCP_CLIENT_SETUP_ERR    100
#define PENT_TCP_CLIENT_CREATE_ERR   101
#define PENT_TCP_CLIENT_CONNECT_ERR  102

// pentTCPSocketServer.c++ errors
#define PENT_TCP_SERVER_SETUP_ERR    200
#define PENT_TCP_SERVER_CREATE_ERR   201
#define PENT_TCP_SERVER_BIND_ERR     202
#define PENT_TCP_SERVER_LISTEN_ERR   203
#define PENT_TCP_SERVER_ACCEPT_ERR   204

// pentData.c++ errors
#define PENT_DATA_WRITE_ERR          500
#define PENT_DATA_READ_ERR           501
#define PENT_DATA_READ_DATA_ERR      502
#define PENT_NO_FD_ERR               503

// PENT connection types 
#define PENT_CONNECTION_TYPE_STREAM    1
#define PENT_CONNECTION_TYPE_DGRAM     2
#define PENT_CONNECTION_TYPE_UNKNOWN   3


#define PENT_TRUE   1
#define PENT_FALSE  0

#define PENT_ERR(cond, ret) { \
    if (cond) {\
       if (printReturnErr == PENT_TRUE) { \
          fprintf(stderr, "PENT error:%d (line:%d file:%s) errno:%d\n", \
	          ret, __LINE__, __FILE__, errno); \
       } \
       return(ret);\
    }}

#define PENT_D1(x) x
#define PENT_D2(x) 
#define PENT_D3(x) 

#endif


