#ifndef PENT_TCP_CONNECTION_MANAGER_COMMON_H
#define PENT_TCP_CONNECTION_MANAGER_COMMON_H

#define CM_MONITOR_LAUNCH_FAILURE 100
#define CM_MONITOR_INVALID_CONNECTION_REQUEST 101

#define CM_SERVER_LAUNCH_FAILURE 200

#define CM_RECEIVER_INVALID_CONNECTION_REQUEST 102

#define CM_INITIATOR_INVALID_CONNECTION_REQUEST 103

#define CM_TRUE   1
#define CM_FALSE  0

#define cmPrintReturnErr CM_TRUE

#define CM_ERR(cond, ret) { \
    if (cond) {\
       if (cmPrintReturnErr == CM_TRUE) { \
          fprintf(stderr, "CM error:%d (line:%d file:%s) errno:%d\n", \
	          ret, __LINE__, __FILE__, errno); \
       } \
    }}

#define CM_RETURN_ERR(cond, ret) { \
    if (cond) {\
       if (cmPrintReturnErr == CM_TRUE) { \
          fprintf(stderr, "CM error:%d (line:%d file:%s) errno:%d\n", \
	          ret, __LINE__, __FILE__, errno); \
       } \
       return(ret);\
    }}

short CM_MONITOR_PORT = 5300; // make dynamic, w/ monitoring daemon
short CM_INITIATOR_PORT = 5301; // make dynamic, w/ monitoring daemon

// internal state
typedef enum {
  MONITOR_NO_STATE,
  MONITOR_WAITING,
  MONITOR_CLIENT_LAUNCH,
  //  MONITOR_CLIENT_KILL,
  MONITOR_DIE
} MonitorStateID;

// Monitor message indicator
typedef enum {
  MONITOR_PACKET_ID = 1024,
  RECEIVER_PACKET_ID,
  SERVER_PACKET_ID
} MessageHeaderID;

// Type of monitor request
typedef enum {
  RECEIVE_MESSAGE_DATA,
  MONITOR_REQUEST_INITIATE_CONNECTION,
  MONITOR_REQUEST_TERMINATE_CONNECTION
} MessageTypeID;

typedef struct {
  MessageHeaderID id;
  MessageTypeID type;
  int port;
} MessageHeader;


// typedef struct {
//   unsigned int id;
//   int port;
// } ReceiverMessage;

// typedef struct {
//   unsigned int id;
//   int port;
// } ConnectionRequest;

// typedef struct {
//   unsigned int id;
//   int port;
// } AnyMessage;

#endif PENT_TCP_CONNECTION_MANAGER_COMMON_H
