#ifndef PENT_TCP_CONNECTION_MANAGER_H
#define PENT_TCP_CONNECTION_MANAGER_H

#include "pentCommon.h"
#include "pentTCPSocketServer.h"
#include "pentTCPSocketClient.h"
#include "pentData.h"

// System V
#include <sys/types.h>
#include <sys/prctl.h>

// libpent connection manger
#include "pentTCPCMCommon.h"

class pentTCPConnectionManager {

public:
  // launch the monitor..
  pentTCPConnectionManager( void );
  void setup( void );

  // callback
  typedef void (*connectionCallback)(pentData *, void *);
  virtual void registerCallback(connectionCallback cb,void *data );
  
private:

  // callback
  typedef struct {
    pentData *dataObj;
    void *userData;
    connectionCallback connectionCB;
  } callbackDataStruct;

  pid_t monitorPID;
  
  // callbacks
  callbackDataStruct  callbackData;

  // monitor child data receiving process
  static void receive( void *data );

  // sproc'd main loop
  static void monitor( void * );

  // sproc'd child receiver
  virtual pid_t launchReceiver( pentData *monitorObj );

}; // class

#endif PENT_TCP_CONNECTION_MANAGER_H

