#ifndef PENT_UDP_INITIATOR_H
#define PENT_UDP_INITIATOR_H

#include "pentCommon.h"
#include "pentTCPSocketServer.h"
#include "pentTCPSocketClient.h"
#include "pentUDPSocketServer.h"
#include "pentUDPSocketClient.h"
#include "pentData.h"

// System V
#include <sys/types.h>
#include <sys/prctl.h>

// libpent connection manger
#include "pentTCPCMCommon.h"

class pentUDPInitiator {

public:
  pentUDPInitiator( void );
  void setup( char *addr, void *userData, int bufSize );
  
  // callback
  typedef void (*connectionCallback)(pentData *, 
				void *);
  virtual void registerCallback(connectionCallback cb,
				void *data );
private:
  // callbacks
  void *callbackUserData;
  connectionCallback connectionCB;

}; // class

#endif PENT_UDP_INITIATOR_H
