#ifndef PENT_UDP_CONNECTION_MANAGER_H
#define PENT_UDP_CONNECTION_MANAGER_H

#include "pentCommon.h"
#include "pentTCPSocketServer.h"
#include "pentTCPSocketClient.h"
#include "pentUDPSocketServer.h"
#include "pentUDPSocketClient.h"
#include "pentData.h"

// System V
#include <sys/types.h>
#include <sys/prctl.h>

// libpent connection manger
#include "pentTCPCMCommon.h"

class pentUDPConnectionManager {

public:
  // launch the monitor..
  pentUDPConnectionManager( void );
  ~pentUDPConnectionManager( void );
  void setup( void );

  // callback
  typedef void (*connectionCallback)(pentData *,
				     void *connectionData,
				     int connectionDataSize,
				     void *data);

  virtual void registerCallback(connectionCallback cb, 
				void *data );
  
private:

  // callback
  typedef struct {
    pentData *dataObj;
    void *userData;
    int userTransmitSize;
    void *userTransmitData;
    connectionCallback connectionCB;
  } callbackDataStruct;

  pid_t monitorPID;
  
  // callbacks
  callbackDataStruct  callbackData;

  // monitor child data receiving process
  static void receive( void *data );

  // sproc'd main loop
  static void monitor( void * );

  // call child receiver - no sproc.. the app will have to sproc if
  // it's required.
  virtual void launchReceiver( pentData *monitorObj );

}; // class

#endif PENT_UDP_CONNECTION_MANAGER_H

