#ifndef PSOUND_INPUT
#define PSOUND_INPUT

#include "PSoundBuffer.h"


class PSoundInput : public PSoundBuffer {

public:
  // Constructors
  PSoundInput();
  ~PSoundInput();

  // Open the audio input port and name it 'name'
  int openPort(char *name);

  // getSamples - OVERRIDDEN.fill the buffer with n seconds worth of samples.  
  //              Do the up-sampling or downsampling needed to get to 
  //              sampleRate.  (buf must be allocated already)
  int getSamples(float nSeconds,int serverRate, 
		 int serverChannels,Sample *serverBuffer);

  int setPitchShift(float val);

protected:
  char *portName;
  ALconfig      portConfig;
  ALport        port;
  
private:
};

#endif
