#ifndef PSOUND_NETSOURCE
#define PSOUND_NETSOURCE

#include "PSoundBuffer.h"

#include "libpent/pentCommon.h"
#include "libpent/pentTCPSocketServer.h"
#include "libpent/pentData.h"


class PSoundNetSource : public PSoundBuffer {

public:
  // Constructors
  PSoundNetSource();
  ~PSoundNetSource();

  // Open the audio input port and name it 'name'  You can pass in a 
  // callback for for handling broken connections
  int setPentRecvData(pentData *newObj);
  
  // getSamples - OVERRIDDEN.fill the buffer with n seconds worth of samples.
  //              Do the up-sampling or downsampling needed to get to 
  //              sampleRate.  (buf must be allocated already)
  int getSamples(float nSeconds,int serverRate, 
		 int serverChannels,Sample *serverBuffer);

  int setPitchShift(float val);

protected:
  pentTCPSocketServer *pentServerSocket;
  pentData            *pentRecData;

  void (*userConnectLostHandler)(void *);
  void *userConnectLostData;

private:
};

#endif
