#ifndef WACOM_TABLET_H
#define WACOM_TABLET_H
 
#include "XInputDevice.h"

class WacomTablet: public XInputDevice {

  public:
    WacomTablet( Display *display );
    ~WacomTablet( void );

    // (New) From event data
    virtual int			getWindowX( void );
    virtual int			getWindowY( void);
    virtual int			getTabletX( void );
    virtual int			getTabletY( void);
    virtual unsigned int	getPressure( void );
    virtual unsigned int	getButton( void );
    virtual void 		parseEvent( Window win, XEvent *event );

    // Old Valuator (on-demand query code)
    virtual Bool		queryValuators( void );
    virtual unsigned int	getValuatorX( void );
    virtual unsigned int	getValuatorY( void);
    virtual unsigned int	getValuatorPressure( void);
    virtual unsigned int	getValuatorPenButtonBits( void);
    virtual Bool		isValuatorButton1( void );
    virtual Bool		isValuatorButton2( void );
    virtual Bool		isValuatorButton3( void );


  protected:
    XValuatorState *valuator;
    int			windowX, windowY;
    int			tabletX, tabletY;
    unsigned int	pressure;
    unsigned int	button;

};

#endif
