#include "SoDMBufferCompositeEngine.h"
#include <Inventor/fields/SoSFMatrix.h>

// System V
#include <stropts.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/prctl.h>

SO_ENGINE_ABSTRACT_SOURCE( SoDMBufferCompositeEngine );

void
SoDMBufferCompositeEngine::initClass( void ){
    // Ensure Parent is Init'd!
    if (SoDMBufferEngine::getClassTypeId().isBad())
	SoDMBufferEngine::initClass();
    SO_ENGINE_INIT_ABSTRACT_CLASS( SoDMBufferCompositeEngine, SoDMBufferEngine, "SoDMBufferEngine");
}

SoDMBufferCompositeEngine::SoDMBufferCompositeEngine():
    SoDMBufferEngine()
{
    SO_ENGINE_CONSTRUCTOR( SoDMBufferCompositeEngine );
    SO_ENGINE_ADD_INPUT( inputImage, ( NULL ) );
    firstRender = True;
    isBuiltIn = True;
};

void
SoDMBufferCompositeEngine::evaluate(){
    if ( !firstRender )
	inputImage.getValue()->finishEditing();
    else
	firstRender = False;

    SbVec2s size;
    engineDMBuffer = inputImage.startEditing(size);

    composite( size );
    SoDMBufferEngine::evaluate();
}
