#ifndef  _SO_SF_DMBUFFER_RAWDV_ENGINE_H
#define  _SO_SF_DMBUFFER_RAWDV_ENGINE_H

// Inventor
#include <Inventor/fields/SoSFString.h>

// DMUIV
#include "SoDMBufferEngine.h"

// DMU
#include "libdmu/dmuMovieInRawDV.h"
#include "libdmu/dmuICdvdecoder.h"
#include "libdmu/dmuGLPixelTrans.h"
#include "libdmu/dmuGLTex2d.h"
#include "libdmu/dmuGLCtx.h"
#include "libdmu/dmuICdvdecoder.h"

class SoDMBufferRawDVEngine : public SoDMBufferEngine {

    SO_ENGINE_HEADER( SoDMBufferRawDVEngine );

  public:

    SoSFString	filename;

    static void 	initClass();

    SoDMBufferRawDVEngine( void );

    virtual void stop( void );
    virtual void start( void );

  protected:
    dmuMovieInRawDV *movieIn;
    dmuGLPixelTrans *movieContext;
    dmuGLTex2d      *texDrain;
    dmuICdvdecoder *decoder;
    virtual void        inputChanged(SoField *whichField);

  private:

    ~SoDMBufferRawDVEngine();

};

#endif
