#ifndef  _SO_SF_DMBUFFER_SCENE_ENGINE_H
#define  _SO_SF_DMBUFFER_SCENE_ENGINE_H

// Inventor
#include <Inventor/engines/SoSubEngine.h>
#include <Inventor/SoSceneManager.h>
#include <Inventor/fields/SoSFString.h>
#include <Inventor/nodes/SoSeparator.h>

// DMUIV
#include "SoDMBufferCompositeEngine.h"

// STL
#include <list.h>

// DMU
#include "libdmu/dmuObj.h"

class SoDMBufferSceneEngine : public SoDMBufferCompositeEngine {

    SO_ENGINE_HEADER( SoDMBufferSceneEngine );

  public:

    SoSFString		filename;

    static void initClass();
    SoDMBufferSceneEngine( void );
    virtual void stop( void );
    virtual void start( void );

  protected:
    virtual void composite( SbVec2s &size);
    virtual void inputChanged(SoField *whichField);

    SoSeparator		*sceneGraph;
    SoSceneManager 	*sceneManager;

  private:
    SoSeparator		*readFile(const char *filename);

};

#endif
