#include "SoSFDMBufferImage.h"

//////////////////////////////////////////////////////////////////////////////
//
// SoSFDMBufferImage class
//
//////////////////////////////////////////////////////////////////////////////

// Use most of the standard stuff:
SO_SFIELD_SOURCE(SoSFDMBufferImage, SbDMBuffer *, SbDMBuffer *);

void
SoSFDMBufferImage::initClass( void ){
    SO_SFIELD_INIT_CLASS( SoSFDMBufferImage, SoSField );
}

SbDMBuffer *
SoSFDMBufferImage::getBuffer(SbVec2s &size)
{
    evaluate();
    if ( value ){
	value->getValue(size);
	return	value;
    } else
	return NULL;
}

const unsigned char *
SoSFDMBufferImage::getImage(SbVec2s &size)
{
    evaluate();
    if ( value ){
	unsigned char *bytes; 
	return value->getValue(size, &bytes);
    } else
	return NULL;
}

const unsigned char *
SoSFDMBufferImage::getImage( void )
{
    evaluate();
    if ( value ){
	SbVec2s size;
	unsigned char *bytes; 
	return value->getValue(size, &bytes);
    } else
	return NULL;
}

void
SoSFDMBufferImage::release( void ){
    evaluate();
    if ( value )
	value->releaseValue();
}

SbDMBuffer *
SoSFDMBufferImage::startEditing(SbVec2s &s)
{
    evaluate();
    if ( value ){
	value->startEditing(s);
	return value;
    } else
	return NULL;
}

void
SoSFDMBufferImage::finishEditing()
{
    evaluate();
    if ( value )
	value->finishEditing();
    valueChanged();
}

SbBool
SoSFDMBufferImage::readValue(SoInput *in)
{
    return True;
}

void
SoSFDMBufferImage::writeValue(SoOutput *out) const
{
}






