/*
 * Copyright (c) 1997 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef fileutils_h
#define fileutils_h

#include <sys/types.h>
#include "jinfo.h"

#define COMPRESSED_PAD 4096

typedef struct {
    int fd;
    int packing;
    int compressed;
    int uSize;
    int vSize;
    int readSize;
    int headerSize;
    int pad;
    int Nfields;
    int qf;
    off64_t dataBytes;
    off64_t indexOffset;
    char filler[16324];
}fileHeader_t;

fileHeader_t *fileCreate(char *fname, int direct);
void fileInit(char *fname, fileHeader_t *f, int direct);
off64_t fileDataBytes(fileHeader_t *f);
void writeHeader(fileHeader_t *f);
void writeIndexBuffer(fileHeader_t *f, jFieldInfo_t *indexbuffer);
void readIndexBuffer(fileHeader_t *f, jFieldInfo_t *indexbuffer);
jFieldInfo_t *createIndexBuffer(int nfields);

#endif
