//
//  dmuGLCtx.h
//
//  Author: Demo Factory
//  Date:   Oct, 1996
//

// <dmu>
//
// This class extends the dmuGLCtx class to contain a pool of a dmbuffer
// that it can allocate.  This allows you to use this class as the head
// of a chain.  With this object at the head of a chain you can render
// openGL into the pbuffer this object provides and then pass it down
// the rest of the chain.  This make rendering openGL to video out very easy.

// </dmu>
#ifndef DMU_GLPAINTBUFFER_H
#define DMU_GLPAINTBUFFER_H

#include "dmu.h"
#include "dmuGLCtx.h"

class dmuGLPaintBuffer : public dmuGLCtx{
public:
  // Basic construction and parameter initialization
  dmuGLPaintBuffer();

  // Destructor that does nothing currently
  ~dmuGLPaintBuffer();

  // This method create a pbuffer, a gl Context, and a pool of dmbuffers.  
  int init (dmuParams *params = NULL);

  // allocates a buffer from the pool and makes it the currently grab()ed
  // buffer.  You can then make it current and render into it.  From there
  // you can propagate it down the rest of the chain. 
  int grab();

  //  int release();
  //  GLXFBConfigSGIX getFBConfig() {return fbConfig;}

  //  void enableDoubleBuffer() {doDoubleBuffer = 1;}
  //  void disableDoubleBuffer() {doDoubleBuffer = 0;}

private:
  int createPool();
  
  DMparams *poolParams;
  DMbuffer paintBuffer;

  int doDoubleBuffer;
};

#endif // DMU_GLPAINTBUFFER_H
/****************************************************************************
  *                                                                          *
  *               Copyright (c) 1996-97, Silicon Graphics, Inc.              *
  *                                                                          *
  *   Permission to use,  copy, modify, distribute, and sell this software   *
  *   and its documentation for any purpose is hereby granted without fee,   *
  *   provided that the name of  Silicon  Graphics  may not be used in any   *
  *   advertising  or  publicity  relating  to  the  software  without the   *
  *   specific, prior written permission of Silicon Graphics.                *
  *                                                                          *
  *   THIS SOFTWARE IS PROVIDED "AS-IS"  AND WITHOUT WARRANTY OF ANY KIND,   *
  *   EXPRESS,  IMPLIED OR OTHERWISE,  INCLUDING  WITHOUT LIMITATION,  ANY   *
  *   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.       *
  *                                                                          *
  *   IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,   *
  *   INCIDENTAL,  INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,  OR  ANY   *
  *   DAMAGES  WHATSOEVER  RESULTING  FROM  LOSS OF USE,  DATA OR PROFITS,   *
  *   WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY   *
  *   THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR   *
  *   PERFORMANCE OF THIS SOFTWARE.                                          *
  *                                                                          *
  ****************************************************************************/
