//
//  dmuICjdecoder.h
//
//  Author: Tim Davison
//  Date:   Oct, 1996
//
//  <dmu>
//  This objects decompresses jpeg frames that are given to it.  This
//  object is a subclass of the <I>dmuIC</I> object.  The only thing
//  this object does is implement the setup method.  The setup method
//  creates an image conversion context.  
//  </dmu>
//
#ifndef _DMUICJDECODER_H
#define _DMUICJDECODER_H

#include "dmuIC.h"

class dmuICjdecoder : public dmuIC {
public:

  // Constructor:  This is the constructor that setups up some default
  // values.  If you use this constructor, you must set the image
  // width and height before you call the setup method.  
  dmuICjdecoder();

  // Constructor: You probably want to use this constructor.  It set some
  // default values and sets the image width and height.  
  dmuICjdecoder(int imageSizeX, int imageSizeY);

  // Destructor:  Right now this does nothing other than implicitly calling
  // the superclass' destructor
  virtual ~dmuICjdecoder();

protected:

private:
};

#endif // _DMUICJDECODER_H
/****************************************************************************
  *                                                                          *
  *               Copyright (c) 1996-97, Silicon Graphics, Inc.              *
  *                                                                          *
  *   Permission to use,  copy, modify, distribute, and sell this software   *
  *   and its documentation for any purpose is hereby granted without fee,   *
  *   provided that the name of  Silicon  Graphics  may not be used in any   *
  *   advertising  or  publicity  relating  to  the  software  without the   *
  *   specific, prior written permission of Silicon Graphics.                *
  *                                                                          *
  *   THIS SOFTWARE IS PROVIDED "AS-IS"  AND WITHOUT WARRANTY OF ANY KIND,   *
  *   EXPRESS,  IMPLIED OR OTHERWISE,  INCLUDING  WITHOUT LIMITATION,  ANY   *
  *   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.       *
  *                                                                          *
  *   IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,   *
  *   INCIDENTAL,  INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,  OR  ANY   *
  *   DAMAGES  WHATSOEVER  RESULTING  FROM  LOSS OF USE,  DATA OR PROFITS,   *
  *   WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY   *
  *   THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR   *
  *   PERFORMANCE OF THIS SOFTWARE.                                          *
  *                                                                          *
  ****************************************************************************/
