#ifndef _DMUCMOVIEIN_H
#define _DMUCMOVIEIN_H

#include "dmuMovieIn.h"

// <dmu> The dmuMovieInCompressed class implements the functionality
// needed to read raw, compressed JPEG frames into an DMbuffer.
// To do this, the object uses the movie library to perform
// an <i>mvReadCompressedImage(3dm)</i> operation into a DMbuffer. </P>

// <P> This object is usually used in conjunction with a dmuICjdecoder
// object which can be used to decode video frames quickly using the
// hardware acceleration of the O2.</P>

// <P> The public interface for dmuMovieInCompressed is no different
// than that of a dmuMovieIn object.  The implementation of certain
// virtual methods (both public and protected) are what provides the
// functionality described above.  See <i>dmuMovieIn</i> for more
// information on the methods available to this class.</P> </dmu>


class dmuMovieInCompressed: public dmuMovieIn{
public:
  dmuMovieInCompressed();
  ~dmuMovieInCompressed();
  int init(dmuParams *params = NULL);
  
  virtual int setup(char *newFileName) {fprintf (stderr, "hello\n"); return (dmuMovieIn::setup(newFileName)); }
protected:

  // Implements the appropriate read behavior to read a compressed
  // movie frame into a DMbuffer.
  virtual int getImageFrameTime(long long movieTime);
  virtual int getImageFrameIndex(int frameIndex);

private:
  
};

#endif

/****************************************************************************
  *                                                                          *
  *               Copyright (c) 1996-97, Silicon Graphics, Inc.              *
  *                                                                          *
  *   Permission to use,  copy, modify, distribute, and sell this software   *
  *   and its documentation for any purpose is hereby granted without fee,   *
  *   provided that the name of  Silicon  Graphics  may not be used in any   *
  *   advertising  or  publicity  relating  to  the  software  without the   *
  *   specific, prior written permission of Silicon Graphics.                *
  *                                                                          *
  *   THIS SOFTWARE IS PROVIDED "AS-IS"  AND WITHOUT WARRANTY OF ANY KIND,   *
  *   EXPRESS,  IMPLIED OR OTHERWISE,  INCLUDING  WITHOUT LIMITATION,  ANY   *
  *   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.       *
  *                                                                          *
  *   IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,   *
  *   INCIDENTAL,  INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,  OR  ANY   *
  *   DAMAGES  WHATSOEVER  RESULTING  FROM  LOSS OF USE,  DATA OR PROFITS,   *
  *   WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY   *
  *   THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR   *
  *   PERFORMANCE OF THIS SOFTWARE.                                          *
  *                                                                          *
  ****************************************************************************/
