//
//  dmuNetworkSend.h
//
//  Author: Demo Factory
//  Date:   Oct, 1996
//
// <dmu>
// This object sits at the end of a chain and it take that buffers
// passed to it and sends them across the network.  
//
// </dmu>
//
#ifndef _DMUNETWORKSEND_H
#define _DMUNETWORKSEND_H

// includes needed for this object
#include "dmuNetwork.h"

class dmuNetworkSend : public dmuNetwork {
public:
  // Constructor: This constructor sets up some default values.
  dmuNetworkSend();
  // Destructor:  Right now this does nothing.
  ~dmuNetworkSend();

  // This method calls the dmuObj::init method
  int init(dmuParams *params = NULL);

  // This object calls start on the rest of the chain.  You must have
  // set the network data object before calling start or this will
  // method will fail
  virtual int start(int propagate = DMU_PROPAGATE);

  // This is the method that actually sends the data across the network.
  // remember that this is never called directly, it is called from the
  // parent by the parent's handleEvents method
  int receive(DMbuffer inBuffer);

  // This method just returns ok.
  int handleEvents(fd_set fdSet);

  // allows the use to set a header value to go with the data across the
  // network.  
  void setHeaderValue(int val);
protected:
  int counter;
  int headerVal;
private:

};

#endif // _DMUNETWORKSEND_H

/****************************************************************************
  *                                                                          *
  *               Copyright (c) 1996-97, Silicon Graphics, Inc.              *
  *                                                                          *
  *   Permission to use,  copy, modify, distribute, and sell this software   *
  *   and its documentation for any purpose is hereby granted without fee,   *
  *   provided that the name of  Silicon  Graphics  may not be used in any   *
  *   advertising  or  publicity  relating  to  the  software  without the   *
  *   specific, prior written permission of Silicon Graphics.                *
  *                                                                          *
  *   THIS SOFTWARE IS PROVIDED "AS-IS"  AND WITHOUT WARRANTY OF ANY KIND,   *
  *   EXPRESS,  IMPLIED OR OTHERWISE,  INCLUDING  WITHOUT LIMITATION,  ANY   *
  *   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.       *
  *                                                                          *
  *   IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,   *
  *   INCIDENTAL,  INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,  OR  ANY   *
  *   DAMAGES  WHATSOEVER  RESULTING  FROM  LOSS OF USE,  DATA OR PROFITS,   *
  *   WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY   *
  *   THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR   *
  *   PERFORMANCE OF THIS SOFTWARE.                                          *
  *                                                                          *
  ****************************************************************************/
