#include "dmuGLDisplay.h"

/*static int attributeList[] = { GLX_RGBA, 
			       GLX_RED_SIZE, 8,
			       GLX_GREEN_SIZE, 8,
			       GLX_BLUE_SIZE, 8,
			       None };*/

/*static int attributeList[] = { GLX_RGBA, 
			       GLX_RED_SIZE, 5,
			       GLX_GREEN_SIZE, 5,
			       GLX_BLUE_SIZE, 5,
			       GLX_DOUBLEBUFFER,
			       None };*/


/*static Bool WaitForNotify(Display *d, XEvent *e, char *arg) {
            return (e->type == MapNotify) && (e->xmap.window == (Window)arg);
}*/

dmuGLDisplay::dmuGLDisplay() {
  packing = GL_RGBA;
  zoomX = 1;
  zoomY = 1;
  winSizeX = 0;
  winSizeY = 0;
}

dmuGLDisplay::~dmuGLDisplay() {
}

int dmuGLDisplay::setup() {
  int fakeArgc = 0;
  winSizeX = imageSizeX * zoomX;
  winSizeY = imageSizeY * zoomY;
  
  if ((xDisplay = XOpenDisplay(0)) == NULL) {
    fprintf(stderr, "XOpenDisplay failed\n");
    exit(1);
  }

  window = ScratchWindow::create(xDisplay, winSizeX, winSizeY, &fakeArgc,NULL);
  if (!window){
    fprintf (stderr, "Unable to create window for dmuGLdisplay\n");
    return DMU_GENERIC_ERROR;
  }

  glViewport(0, 0, winSizeX, winSizeY);
  glOrtho((GLdouble)0, (GLdouble)winSizeX, (GLdouble)0, (GLdouble)winSizeY,
	  (GLdouble)-1, (GLdouble)1);
  // make the yzoom negative so that the video draws bottom to top
  glPixelZoom(1.0 * (GLdouble)zoomX, -1.0 * (GLdouble)zoomY);  

  return DMU_OK;
}

dmuGLDisplay::receive(DMbuffer inBuffer) {
  char *buf = NULL;
  DEBUG2( fprintf(stderr, "  rendering GL:%s\n", getName()) );
  buf = (char *) dmBufferMapData(inBuffer);
  if (!buf){
    fprintf (stderr, "BAD BUFFER!!!\n");
    return DMU_GENERIC_ERROR;
  }

  window->setContext();
  glRasterPos2i(0, winSizeY);
  glDrawPixels(imageSizeX, imageSizeY, packing, GL_UNSIGNED_BYTE, buf);
  glXSwapBuffers(xDisplay, glXGetCurrentDrawable());

  return DMU_OK;
}
/****************************************************************************
  *                                                                          *
  *               Copyright (c) 1996-97, Silicon Graphics, Inc.              *
  *                                                                          *
  *   Permission to use,  copy, modify, distribute, and sell this software   *
  *   and its documentation for any purpose is hereby granted without fee,   *
  *   provided that the name of  Silicon  Graphics  may not be used in any   *
  *   advertising  or  publicity  relating  to  the  software  without the   *
  *   specific, prior written permission of Silicon Graphics.                *
  *                                                                          *
  *   THIS SOFTWARE IS PROVIDED "AS-IS"  AND WITHOUT WARRANTY OF ANY KIND,   *
  *   EXPRESS,  IMPLIED OR OTHERWISE,  INCLUDING  WITHOUT LIMITATION,  ANY   *
  *   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.       *
  *                                                                          *
  *   IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,   *
  *   INCIDENTAL,  INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,  OR  ANY   *
  *   DAMAGES  WHATSOEVER  RESULTING  FROM  LOSS OF USE,  DATA OR PROFITS,   *
  *   WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY   *
  *   THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR   *
  *   PERFORMANCE OF THIS SOFTWARE.                                          *
  *                                                                          *
  ****************************************************************************/
