//
//  dmuICjdecoder.c++
//
//  Author: Tim Davison
//  Date:   Oct, 1996
//
// This file implements a jpeg decoder.  It is based on the dmuIC object.
// The dmuIC superclass of this object implements all of the steady state
// functionality of this object.  This object only overrides the initialization
// methods on the dmuIC object.  
// The Hierachy looks like this:
//  dmuObj -> dmuIC ---> dmuICjencoder
//                  |
//                   --> dmuICjdecoder
//
#include "dmuICjdecoder.h"

//****************************************************************
//
//  Public dmuICjdecoder methods
//
//****************************************************************

//----------------------------------------------------------
// dmuICjdecoder
//----------------------------------------------------------
//
dmuICjdecoder::dmuICjdecoder() {
  direction = DM_IC_CODE_DIRECTION_DECODE;
  srcCompression = DM_IMAGE_JPEG;
  dstCompression = DM_IMAGE_UNCOMPRESSED;
}


//----------------------------------------------------------
// dmuICjdecoder 
//----------------------------------------------------------
//
// constructor that takes a default height and width of the
// frames it is recieving
//
dmuICjdecoder::dmuICjdecoder(int _imageSizeX, int _imageSizeY) {
  direction = DM_IC_CODE_DIRECTION_DECODE;
  srcCompression = DM_IMAGE_JPEG;
  dstCompression = DM_IMAGE_UNCOMPRESSED;
  imageSizeX = _imageSizeX;
  imageSizeY = _imageSizeY;
}


//----------------------------------------------------------
// ~dmuICjdecoder
//----------------------------------------------------------
//
dmuICjdecoder::~dmuICjdecoder() {
}
/****************************************************************************
  *                                                                          *
  *               Copyright (c) 1996-97, Silicon Graphics, Inc.              *
  *                                                                          *
  *   Permission to use,  copy, modify, distribute, and sell this software   *
  *   and its documentation for any purpose is hereby granted without fee,   *
  *   provided that the name of  Silicon  Graphics  may not be used in any   *
  *   advertising  or  publicity  relating  to  the  software  without the   *
  *   specific, prior written permission of Silicon Graphics.                *
  *                                                                          *
  *   THIS SOFTWARE IS PROVIDED "AS-IS"  AND WITHOUT WARRANTY OF ANY KIND,   *
  *   EXPRESS,  IMPLIED OR OTHERWISE,  INCLUDING  WITHOUT LIMITATION,  ANY   *
  *   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.       *
  *                                                                          *
  *   IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,   *
  *   INCIDENTAL,  INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,  OR  ANY   *
  *   DAMAGES  WHATSOEVER  RESULTING  FROM  LOSS OF USE,  DATA OR PROFITS,   *
  *   WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY   *
  *   THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR   *
  *   PERFORMANCE OF THIS SOFTWARE.                                          *
  *                                                                          *
  ****************************************************************************/
