#include "dmu.h"
#include "dmuObj.h"
#include "dmuMovieInRender.h"
#include "dmuGLDisplay.h"

#include <stropts.h>
#include <poll.h>

#define dmuCheck(dmFunc) { \
    int dmuErrID; \
    if ((dmuErrID = (dmFunc)) != DMU_OK) {\
       fprintf(stderr,"*Error:%d:%s\n", dmuErrID, \
	       getErrorString(dmuErrID) ); \
					     /*exit(-1);*/ \
    }\
    else { \
       fprintf(stderr,"No Error\n"); \
    } \
 }


int main(int argc, char *argv[]){

  int movieInFD = 0;
  int sizeX,sizeY;

  dmuMovieInRender *movieIn;
  dmuGLDisplay *display1;

  fd_set readFDSet;


  if (argc < 2){
    fprintf (stderr, "USAGE: movieTest <movie file name>\n");
    exit (-1);
  }


  movieIn = new dmuMovieInRender;
  movieIn->setName("movieIn");
  
  fprintf (stderr, "Setup:");
  dmuCheck(movieIn->setup(argv[1]));

  /*fprintf (stderr, "Getting transfer size: ");
  dmuCheck(movieIn->getBufferSize(&size));
  fprintf (stderr, "Transfer Size:%d bytes\n\n",size);*/

  fprintf (stderr, "Getting buffer dimensions: ");
  movieIn->getBufferDimensions(&sizeX,&sizeY);
  fprintf (stderr, "Buffer Dimensions: %d, %d\n\n",sizeX,sizeY);

  fprintf (stderr, "Getting image size: ");
  movieIn->getImageDimensions(&sizeX,&sizeY);
  fprintf (stderr, "Video Size: %d, %d\n\n",sizeX,sizeY);


  display1 = new dmuGLDisplay();
  display1->setName("display1");
  display1->setImageDimensions(sizeX, sizeY);
  display1->setup();
  movieIn->addObject(display1);


  fprintf (stderr, "Initializing: ");
  dmuCheck(movieIn->init());

  fprintf (stderr, "Fire it up!: ");
  dmuCheck(movieIn->start());

  fprintf (stderr, "Get FD: ");
  movieInFD = movieIn->getFD();
  if (movieInFD < 0){
    fprintf (stderr, "Invalid movieIn:%d\n",movieInFD);
    exit (-1);
  }

  fprintf (stderr, "movieIn FD = %d\n", movieInFD);
  
  //dmuCheck(movieIn->handleEvents(readFDSet/*readFDSet*/));
  
  fprintf (stderr, "entering loop\n");
  for (int i = 0; i < 200; i++){
    
    FD_ZERO(&readFDSet);
    FD_SET(movieInFD, &readFDSet);

    // Wait for something to happen on video
    select (movieInFD+1,&readFDSet, NULL, NULL, NULL);
    
    //sleep (5);
    // If something happens, handle the event.
    fprintf (stderr, "%d:", i);
    dmuCheck(movieIn->handleEvents(readFDSet));
  }


  delete (movieIn);
}

    //FD_ZERO(&readFDSet);
    //FD_SET(movieInFD, &readFDSet);

    // Wait for something to happen on video
    //select (movieInFD+1,&readFDSet, NULL, NULL, NULL);

    /*struct pollfd pfd;
    pfd.fd = movieInFD;
    pfd.events = POLLIN;
    int err = poll(&pfd,1,-1);
    if (pfd.revents & POLLIN){*/
/****************************************************************************
  *                                                                          *
  *               Copyright (c) 1996-97, Silicon Graphics, Inc.              *
  *                                                                          *
  *   Permission to use,  copy, modify, distribute, and sell this software   *
  *   and its documentation for any purpose is hereby granted without fee,   *
  *   provided that the name of  Silicon  Graphics  may not be used in any   *
  *   advertising  or  publicity  relating  to  the  software  without the   *
  *   specific, prior written permission of Silicon Graphics.                *
  *                                                                          *
  *   THIS SOFTWARE IS PROVIDED "AS-IS"  AND WITHOUT WARRANTY OF ANY KIND,   *
  *   EXPRESS,  IMPLIED OR OTHERWISE,  INCLUDING  WITHOUT LIMITATION,  ANY   *
  *   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.       *
  *                                                                          *
  *   IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,   *
  *   INCIDENTAL,  INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,  OR  ANY   *
  *   DAMAGES  WHATSOEVER  RESULTING  FROM  LOSS OF USE,  DATA OR PROFITS,   *
  *   WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY   *
  *   THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR   *
  *   PERFORMANCE OF THIS SOFTWARE.                                          *
  *                                                                          *
  ****************************************************************************/
