//
//  pentSocket.h
//
//  Author: Demo Factory
//  Date:   Oct, 1996
//
// This is the base class for sockets.  It deals with the ports.
// It also setups up some basic debugging structures.
// This class can be used as a base class, but you should never instantiate
// this class.  
//
#ifndef PENT_SOCKET_H
#define PENT_SOCKET_H

#include "pentCommon.h"
#include "pentData.h"

class pentSocket {
public:
  // Constructor: Initialize data members
  pentSocket();

  // Destructor: does nothing currently
  ~pentSocket();

  // Set the port number that the socket object will use
  int setPort(int portNum);
  // return the port number that the object is using
  int getPort(int *portNum);

  // this will create the socket and setup the address 
  virtual int setup();
  
  // we override this method to actually do the net working stuff
  virtual int handshake(pentData *dataObj);

  // debugging
  // this is for debugging purposes and for handshaking
  int setName(char *name);
  int setPrintReturnErr(int printReturnErr);

protected:
  int     portNum;
  char   *name;
  char   *localhostname;
  char   *connecthostname;
  int     printReturnErr;  
};

#endif
/****************************************************************************
  *                                                                          *
  *               Copyright (c) 1996-97, Silicon Graphics, Inc.              *
  *                                                                          *
  *   Permission to use,  copy, modify, distribute, and sell this software   *
  *   and its documentation for any purpose is hereby granted without fee,   *
  *   provided that the name of  Silicon  Graphics  may not be used in any   *
  *   advertising  or  publicity  relating  to  the  software  without the   *
  *   specific, prior written permission of Silicon Graphics.                *
  *                                                                          *
  *   THIS SOFTWARE IS PROVIDED "AS-IS"  AND WITHOUT WARRANTY OF ANY KIND,   *
  *   EXPRESS,  IMPLIED OR OTHERWISE,  INCLUDING  WITHOUT LIMITATION,  ANY   *
  *   WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.       *
  *                                                                          *
  *   IN  NO  EVENT  SHALL  SILICON  GRAPHICS  BE  LIABLE FOR ANY SPECIAL,   *
  *   INCIDENTAL,  INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,  OR  ANY   *
  *   DAMAGES  WHATSOEVER  RESULTING  FROM  LOSS OF USE,  DATA OR PROFITS,   *
  *   WHETHER OR NOT ADVISED OF  THE  POSSIBILITY  OF  DAMAGE,  AND ON ANY   *
  *   THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR   *
  *   PERFORMANCE OF THIS SOFTWARE.                                          *
  *                                                                          *
  ****************************************************************************/

