//
//  pentTCPSocketServer.c++
//
//  Author: Demo Factory
//  Date:   Oct, 1996
//
//  See header file for description of this class
// 
#include "pentTCPSocketClient.h"

//****************************************************************
//
//  Public methods
//
//****************************************************************

//----------------------------------------------------------
// pentTCPSocketServer
//----------------------------------------------------------
//
// Constructor. Does nothing beyond initaliziation of
// member variables
//
pentTCPSocketClient::pentTCPSocketClient() {
  serverName = NULL;
  serverAddr = 0;
}

//----------------------------------------------------------
// ~pentTCPSocketServer
//----------------------------------------------------------
//
// Destructor. Does nothing.
//
pentTCPSocketClient::~pentTCPSocketClient() {
}

//----------------------------------------------------------
// setAddr
//----------------------------------------------------------
//
// setup the address to send data to.  This method tweaks the
// address into something that it can actually use.
//
int pentTCPSocketClient::setAddr(char *_addr) {
  if ( (serverAddr = inet_addr(_addr)) == INADDR_NONE) {
    if ( (hostInfo = gethostbyname(_addr)) != NULL) {
      bcopy(hostInfo->h_addr, (char *) &serverAddr, hostInfo->h_length);
    } else {
      if (printReturnErr == PENT_TRUE) {
	fprintf(stderr, "PENT error:%d (line:%d file:%s)\n",
		PENT_BAD_ADDR_ERR, __LINE__, __FILE__);
      }
      return(PENT_BAD_ADDR_ERR);
    }
  }
  
  return(PENT_OK);
}

//----------------------------------------------------------
// handshake
//----------------------------------------------------------
//
int pentTCPSocketClient::handshake(pentData *_dataObj) {
  // ensure that we've got valid info...
  PENT_ERR( (portNum < 0)     , PENT_TCP_CLIENT_SETUP_ERR);
  PENT_ERR( (portNum == 0)    , PENT_TCP_CLIENT_SETUP_ERR);
  PENT_ERR( (serverAddr == 0) , PENT_TCP_CLIENT_SETUP_ERR);
  
  // open a TCP socket
  int srvSockFD = socket(AF_INET, SOCK_STREAM, 0);
  PENT_ERR( (srvSockFD < 0)   , PENT_TCP_CLIENT_CREATE_ERR);

  // load up the connect structure
  // (ensure network byte-ordering)
  struct sockaddr_in srvAddr;
  memset((char *) &srvAddr, 0, sizeof(srvAddr));
  srvAddr.sin_family      = AF_INET;
  srvAddr.sin_addr.s_addr = serverAddr;
  srvAddr.sin_port        = htons(portNum);

  // attempt the connection
  int status = connect(srvSockFD,(struct sockaddr *)&srvAddr, sizeof(srvAddr));
  PENT_ERR( (status < 0)      , PENT_TCP_CLIENT_CONNECT_ERR);

  // cool, we're connected, tell the data object...
  _dataObj->setFD(srvSockFD);
  _dataObj->setConnType(PENT_CONNECTION_TYPE_STREAM);

  return (PENT_OK);
}
