#include "pentCommon.h"
#include "pentTCPSocketClient.h"
#include "pentData.h"

#define SERVER_ADDR_2 "127.0.0.1"
#define SERVER_ADDR "ae10"

#define PENT_TEST_ERR(cond, ret) { \
    if (cond) {\
       fprintf(stderr, "PENT error:%d (line:%d file:%s) errno:%d\n", \
	       ret, __LINE__, __FILE__, errno); \
       exit(ret);\
    }}


int main (int argc, char *argv[]) {
  pentTCPSocketClient *client;
  pentData *dataObj;
  int port = atoi(argv[2]);  
  char buf[80];
  int header = 15;
  int retVal;
  
  for (int i = 0; i < 80; i ++) buf[i] = i;
  
  client = new pentTCPSocketClient();
  client->setPrintReturnErr(PENT_TRUE);
  client->setName("client");
  client->setPort(port);
  client->setAddr(argv[1]);
  client->setup();
  fprintf(stderr, "done client setup\n");
  
  dataObj = new pentData();
  dataObj->setPrintReturnErr(PENT_TRUE);
  dataObj->setName("dataObj");
  dataObj->setHeaderSize(4);
  
  
  client->handshake(dataObj);
  fprintf(stderr, "done with handshake on the server side\n");

  fprintf(stderr, "sending:\n");
  retVal = dataObj->sendData(&header, buf, header);
  PENT_TEST_ERR( (retVal != PENT_OK)        , retVal);

  fprintf(stderr, "\n");

  //while(1);
  delete(dataObj);
  delete(client);
}
