#include "pentCommon.h"
#include "pentUDPSocketClient.h"
#include "pentData.h"

#define SERVER_ADDR_2 "127.0.0.1"
#define SERVER_ADDR "ae10"

int main (int argc, char *argv[]) {
  pentUDPSocketClient *client;
  pentData *dataObj;
  int port = atoi(argv[2]);  
  char buf[80];
  int header = 15;
  int retVal;
  int dataSize;
  
  for (int i = 0; i < 80; i ++) {
    buf[i] = i;
  }
  
  client = new pentUDPSocketClient();
  client->setPrintReturnErr(PENT_TRUE);
  client->setName("client");
  client->setPort(port);
  client->setAddr(argv[1]);
  client->setup();
  fprintf(stderr, "done client setup\n");
  
  dataObj = new pentData();
  dataObj->setPrintReturnErr(PENT_TRUE);
  dataObj->setName("dataObj");
  dataObj->setHeaderSize(4);
  
  
  client->handshake(dataObj);
  fprintf(stderr, "done with handshake on the server side\n");

  fprintf(stderr, "sending:");
  fprintf(stderr, ".");
  retVal = dataObj->sendData(&header, buf, header);
  if (retVal != PENT_OK) {
    fprintf(stderr, "  PENT ERROR:\n");
    exit(1);
  }
  fprintf(stderr, "\n");

  fprintf(stderr, "getting header\n");
  retVal = dataObj->getHeader(&header);
  if (retVal != PENT_OK) {
    fprintf(stderr, "  PENT ERROR:\n");
    exit(1);
  }
  fprintf(stderr, "header:%d\n", header);

  fprintf(stderr, "getting size\n");
  retVal = dataObj->getSize(&dataSize);
  if (retVal != PENT_OK) {
    fprintf(stderr, "  PENT ERROR:\n");
    exit(1);
  }
  fprintf(stderr, "datasize:%d\n", dataSize);

  fprintf(stderr, "getting data\n");
  retVal = dataObj->getData(&buf);
  if (retVal != PENT_OK) {
    fprintf(stderr, "  PENT ERROR:\n");
    exit(1);
  }
  fprintf(stderr, "data:");
  for (i = 0; i < dataSize; i ++) fprintf(stderr, " %d", buf[i]);
  fprintf(stderr, "\ndone\n");


  while(1);
  //  delete(dataObj);
  //  delete(client);
}







