#include "pentCommon.h"
#include "pentTCPSocketServer.h"
#include "pentData.h"

#define PENT_TEST_ERR(cond, ret) { \
    if (cond) {\
       fprintf(stderr, "PENT error:%d (line:%d file:%s) errno:%d\n", \
	       ret, __LINE__, __FILE__, errno); \
       exit(ret);\
    }}

int main (int argc, char *argv[]) {
  pentTCPSocketServer *srv;
  pentData *dataObj;
  int port = atoi(argv[1]);
  char buf[80];
  int size;
  int header;
  int dataSize;
  int retVal;
  
  for (int i = 0; i < 80; i++) buf[i] = '0';
  
  srv = new pentTCPSocketServer();
  srv->setPrintReturnErr(PENT_TRUE);
  srv->setName("srv");
  srv->setPort(port);

  srv->setup();
  fprintf(stderr, "done with server setup\n");
  srv->getPort(&port);
  fprintf(stderr, "server running on port:%d\n", port);
  
  dataObj = new pentData();
  dataObj->setPrintReturnErr(PENT_TRUE);
  dataObj->setName("dataObj");
  dataObj->setHeaderSize(4);
  
  while (1) {
    srv->handshake(dataObj);
    fprintf(stderr, "done with handshake on the server side\n");    

    retVal = dataObj->getHeader(&header);
    PENT_TEST_ERR( (retVal != PENT_OK)        , retVal);
    fprintf(stderr, "header:%d\n", header);


    retVal = dataObj->getSize(&dataSize);
    PENT_TEST_ERR( (retVal != PENT_OK)        , retVal);
    fprintf(stderr, "datasize:%d\n", dataSize);


    retVal = dataObj->getData(&buf);
    PENT_TEST_ERR( (retVal != PENT_OK)        , retVal);

    fprintf(stderr, "data:");
    for (i = 0; i < dataSize; i ++) fprintf(stderr, " %d", buf[i]);
    fprintf(stderr, "\ndone\n");

    for (int i = 0; i < 80; i++) buf[i] = '0';
  }
  //  delete (dataObj);
  //  delete (srv);
}
