#include "pentCommon.h"
#include "pentUDPSocketServer.h"
#include "pentData.h"

int main (int argc, char *argv[]) {
  pentUDPSocketServer *srv;
  pentData *dataObj;
  int port = atoi(argv[1]);
  char buf[80];
  int size;
  int header;
  int dataSize;
  int retVal;
  
  for (int i = 0; i < 80; i++) buf[i] = '0';
  
  srv = new pentUDPSocketServer();
  srv->setPrintReturnErr(PENT_TRUE);
  srv->setName("srv");
  srv->setPort(port);

  srv->setup();
  fprintf(stderr, "done with server setup\n");
  srv->getPort(&port);
  fprintf(stderr, "server running on port:%d\n", port);
  
  dataObj = new pentData();
  dataObj->setPrintReturnErr(PENT_TRUE);
  dataObj->setName("dataObj");
  dataObj->setHeaderSize(4);
    
  srv->handshake(dataObj);
  fprintf(stderr, "done with handshake on the server side\n");

  while (1) {
    fprintf(stderr, "getting header\n");
    retVal = dataObj->getHeader(&header);
    if (retVal != PENT_OK) {
      fprintf(stderr, "  PENT ERROR:\n");
      exit(1);
    }
    fprintf(stderr, "header:%d\n", header);

    fprintf(stderr, "getting size\n");
    retVal = dataObj->getSize(&dataSize);
    if (retVal != PENT_OK) {
      fprintf(stderr, "  PENT ERROR:\n");
      exit(1);
    }
    fprintf(stderr, "datasize:%d\n", dataSize);

    fprintf(stderr, "getting data\n");
    retVal = dataObj->getData(&buf);
    if (retVal != PENT_OK) {
      fprintf(stderr, "  PENT ERROR:\n");
      exit(1);
    }
    fprintf(stderr, "data:");
    for (i = 0; i < dataSize; i ++) fprintf(stderr, " %d", buf[i]);
    fprintf(stderr, "\ndone\n");

    retVal = dataObj->sendData(&header, &buf, header);
    if (retVal != PENT_OK) {
      fprintf(stderr, "  PENT ERROR:\n");
      exit(1);
    }

    
    for (int i = 0; i < 80; i++) buf[i] = '0';
  }

  //  delete (dataObj);
  //  delete (srv);
}

