#ifndef PSOUND_BUFFER
#define PSOUND_BUFFER

#include "PSound.h"

#include <assert.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <math.h>
#include <strings.h>



class PSoundBuffer : public PSound {

public:

  // Constructors
  PSoundBuffer();
  ~PSoundBuffer();

  void enableLoop() {isLooping = TRUE;}
  void disableLoop() {isLooping = FALSE;}

  // getSamples - fill the buffer with n seconds worth of samples.  
  //              Do the up-sampling or downsampling needed to get to 
  //              sampleRate.  (buf must be allocated already)
  virtual int getSamples(float nSeconds,int serverRate, 
			 int serverChannels,Sample *serverBuffer);

protected:
  double curTime;  
  double totalTime;
  double timeIncr;
  
  bool   isLooping;

  unsigned int bufferSize;
  int  totalSamples;
  long sampleRate;

  Sample *sampleBuffer;

  int reSample(float nSeconds, int serverRate,
	       int serverChannels, Sample *serverBuffer);
};

#endif
