#ifndef PSOUND_CD
#define PSOUND_CD

#include "PSoundBuffer.h"

#include <sys/types.h>
#include <dmedia/cdaudio.h>


class PSoundCD : public PSoundBuffer {

public:
  // Constructors
  PSoundCD();
  ~PSoundCD();

  // Open the audio CD port and name it 'name'
  int openCD();

  // getSamples - OVERRIDDEN.fill the buffer with n seconds worth of samples.  
  //              Do the up-sampling or downsampling needed to get to 
  //              sampleRate.  (buf must be allocated already)
  int getSamples(float nSeconds,int serverRate, 
		 int serverChannels,Sample *serverBuffer);

  int setPitchShift(float val);

  int getNTracks() {return nTracks;}
  int seekToTrack(int newTrack);
  int getCurrentTrack() {return currentTrack;}

  int handleAudioCallback(short *audio);

  int setTrackCallback(void (*func)(int trackNum, void *data),void *data);
  int setAbsTimeCallback(void  (*func)(void *data),void *data);
  int setTrackTimeCallback(void  (*func)(void *data),void *data);
  
  char *getAbsTimeString();
  char *getTrackTimeString();

  void doTrackCallback(CDPROGNUM *progNum);
  void doAbsTimeCallback(cdtimecode *tc);
  void doTrackTimeCallback(cdtimecode *tc);

protected:
  char *portName;

  char absTimeStr[9];
  char trackTimeStr[9];

  ALconfig      portConfig;
  ALport        port;
  
  int readMoreSamples();
  
  CDPLAYER *cdPlayer;
  CDPARSER *cdParser;

  int nSamplesNeeded;
  int nSamplesRead;
  int nSamplesPreRead;
  Sample *preReadBuffer;

  int currentTrack;
  int nTracks;

  cdtimecode *trackTime;
  cdtimecode *absTime;

  void (*userTrackCallback)(int, void *);
  void *userTrackCBData;

  void (*userAbsTimeCallback)(void *);
  void *userAbsTimeCBData;

  void (*userTrackTimeCallback)(void *);
  void *userTrackTimeCBData;  

private:

};

#endif
