#ifndef PSOUND_FILE
#define PSOUND_FILE

#include "PSoundBuffer.h"


class PSoundFile : public PSoundBuffer {

public:
  // Constructors
  PSoundFile();
  ~PSoundFile();

  virtual int startPlaying();

  // Load an audio file by the name of 'name'.  Returns the size of the
  // file on success, or a negative value on error.
  int loadFile(char *name);

  // getSamples - OVERRIDDEN.fill the buffer with n seconds worth of samples.  
  //              Do the up-sampling or downsampling needed to get to 
  //              sampleRate.  (buf must be allocated already)
  int getSamples(float nSeconds,int serverRate, 
		 int serverChannels,Sample *serverBuffer);

protected:
  char *fileName;

private:
  // Helper method for changing the file that the sound object uses.
  void setFileName(char *name);

  // Helper method for loading the file with the current name into 
  // the sample buffer.
  int loadCurrentFile();
};

#endif
