--
-- $Header: plushelp.ctl@@/main/3 \
-- Checked in on Mon Jan 29 11:30:39 PST 1996 by ssaux \
-- Copyright (c) 1996 by Oracle Corporation. All Rights Reserved. \
-- $
--
load data
infile *
preserve blanks
into table help append
fields terminated by '^'
TRAILING NULLCOLS
(
    topic, seq, info
)
BEGINDATA
BNF SYNTAX^1^
BNF SYNTAX^2^
BNF SYNTAX^3^
BNF SYNTAX^4^                                BNF Syntax
BNF SYNTAX^5^
BNF SYNTAX^6^ {Braces} enclose required items; you MUST enter one from the list of
BNF SYNTAX^7^ items separated by vertical bars. [Brackets] enclose optional items;
BNF SYNTAX^8^ you MAY enter one from the list of items separated by vertical bars.
BNF SYNTAX^9^ Three periods mean that the preceding item may be repeated.  Do not
BNF SYNTAX^10^ enter the braces, brackets, or vertical bars.
BNF SYNTAX^11^
BNF SYNTAX^12^ Parentheses enclose parameter lists; commas separate items in a list.
BNF SYNTAX^13^ UPPERCASE indicates specific words to be used; lowercase shows names
BNF SYNTAX^14^ and expressions that vary.
BNF SYNTAX^15^
BNF SYNTAX^16^   COMMIT [WORK]
BNF SYNTAX^17^
BNF SYNTAX^18^   DELETE FROM [user.]table [alias] [WHERE condition]
BNF SYNTAX^19^
BNF SYNTAX^20^   INSERT INTO [user.]table [ (column [, column]...) ]
BNF SYNTAX^21^      { VALUES (value [, value]...) | query }
BNF SYNTAX^22^
BNF SYNTAX^23^   LOCK TABLE [user.]table [, [user.]table ]...
BNF SYNTAX^24^
BNF SYNTAX^25^   ROLLBACK [WORK] [TO [SAVEPOINT] savepoint]
BNF SYNTAX^26^
BNF SYNTAX^27^   SAVEPOINT savepoint
BNF SYNTAX^28^
BNF SYNTAX^29^   SELECT [ALL|DISTINCT] { * | table.* | expr [column_alias]}
BNF SYNTAX^30^          [, {table.* | expr [column_alias] } ]... }
BNF SYNTAX^31^     FROM [user.]table [table_alias] [,[user.]table [table_alias]]...
BNF SYNTAX^32^     [ WHERE condition ]
BNF SYNTAX^33^     [ CONNECT BY condition [START WITH condition] ]
BNF SYNTAX^34^     [ GROUP BY expr[, expr]... [HAVING condition] ]
BNF SYNTAX^35^     [ {UNION | INTERSECT | MINUS} SELECT ... ]
BNF SYNTAX^36^     [ ORDER BY {expr | position} [ASC | DESC]
BNF SYNTAX^37^          [, {expr | position} [ASC | DESC]] ]...
BNF SYNTAX^38^     [ FOR UPDATE OF column [, column]... [NOWAIT] ]
BNF SYNTAX^39^
BNF SYNTAX^40^   SET TRANSACTION [READ ONLY]
BNF SYNTAX^41^
BNF SYNTAX^42^   UPDATE [user.]table [alias]
BNF SYNTAX^43^     SET column = expr [,column = expr]...
BNF SYNTAX^44^     [WHERE condition]
BNF SYNTAX^45^
BNF SYNTAX^46^   UPDATE [user.]table [alias]
BNF SYNTAX^47^     SET (column [,column] ... ) = (query) [,...]
BNF SYNTAX^48^     [WHERE condition]
BNF SYNTAX^49^
BNF SYNTAX^50^
BNF SYNTAX^51^
BNF SYNTAX^52^ See any command listed; see also: commands.
BNF SYNTAX^53^
ACCEPT^1^
ACCEPT^2^
ACCEPT^3^
ACCEPT^4^                                   ACCEPT
ACCEPT^5^
ACCEPT^6^ ACC[EPT] variable [NUM[BER]|CHAR|DATE] [FOR[MAT] format]
ACCEPT^7^    [DEF[AULT] default] [PROMPT text|NOPR[OMPT]] [HIDE]
ACCEPT^8^
ACCEPT^9^ ACCEPT reads a line of input and stores it in a given user variable.
ACCEPT^10^
ACCEPT^11^     variable
ACCEPT^12^         is the name of the variable in which you wish to store a value.
ACCEPT^13^         If variable doesn't exist, SQL*Plus creates it.
ACCEPT^14^
ACCEPT^15^     NUM[BER]
ACCEPT^16^         makes the datatype of variable the datatype NUMBER.  If the
ACCEPT^17^         reply does not match the datatype, ACCEPT gives an error message
ACCEPT^18^         and prompts again.
ACCEPT^19^
ACCEPT^20^     CHAR
ACCEPT^21^         makes the datatype of variable the datatype CHAR.  The maximum CHAR
ACCEPT^22^         length limit is 240 bytes.  If a multi-byte character set is used,
ACCEPT^23^         one CHAR may be more than one byte in size.
ACCEPT^24^
ACCEPT^25^     DATE
ACCEPT^26^         Expects the reply to be a valid DATE format.  If the reply is not
ACCEPT^27^         a valid DATE format, ACCEPT gives an error message and prompts
ACCEPT^28^         again.  The datatype is CHAR.
ACCEPT^29^
ACCEPT^30^     FOR[MAT]
ACCEPT^31^         specifies the input format for the reply.  If the reply does not
ACCEPT^32^         match the specified format, ACCEPT gives an error message and
ACCEPT^33^         prompts again for a reply.  The format element must be a text
ACCEPT^34^         constant such as A10 or 9.999.
ACCEPT^35^
ACCEPT^36^         Oracle date formats such as 'dd/mm/yy' are valid when the
ACCEPT^37^         datatype is DATE.  DATE without a specified format defaults to
ACCEPT^38^         the Oracle NLS_DATE_FORMAT of the current session.
ACCEPT^39^
ACCEPT^40^     DEF[AULT]
ACCEPT^41^         sets the default value if a reply is not given.  The reply must
ACCEPT^42^         be in the specified format if defined.
ACCEPT^43^
ACCEPT^44^     PROMPT text
ACCEPT^45^         displays text on-screen before accepting the value of variable
ACCEPT^46^         from the user.
ACCEPT^47^
ACCEPT^48^     NOPR[OMPT]
ACCEPT^49^         skips a line and waits for input; prompt not displayed.
ACCEPT^50^
ACCEPT^51^     HIDE
ACCEPT^52^         suppresses the display as you type the reply.
ACCEPT^53^
ACCEPT^54^ To define or reference variables, use the DEFINE command.
ACCEPT^55^
ACCEPT^56^
ACCEPT^57^
ACCEPT^58^ Examples: To display the prompt, "Password:  ", place the reply in a
ACCEPT^59^           CHAR variable named PSWD, and suppress the display, enter:
ACCEPT^60^
ACCEPT^61^               SQL> ACCEPT pswd CHAR PROMPT 'Password:  ' HIDE
ACCEPT^62^
ACCEPT^63^           To display the prompt, "Enter weekly salary:  ", place the
ACCEPT^64^           reply in a NUMBER variable named SALARY with a default of
ACCEPT^65^           000.0, enter:
ACCEPT^66^
ACCEPT^67^               SQL> ACCEPT salary NUMBER FORMAT '999.99' DEFAULT '000.0' -
ACCEPT^68^               >       PROMPT 'Enter weekly salary:  '
ACCEPT^69^
ACCEPT^70^           To display the prompt, "Enter date hired:  ", place the reply
ACCEPT^71^           in a DATE variable named HIRED with the format "dd/mm/yy" and
ACCEPT^72^           a default of "01/01/94", enter:
ACCEPT^73^
ACCEPT^74^               SQL> ACCEPT hired DATE FORMAT 'dd/mm/yy' DEFAULT '01/01/94'-
ACCEPT^75^               >       PROMPT 'Enter date hired:  '
ACCEPT^76^
ACCEPT^77^           To display the prompt, "Enter employee lastname:  ", and place
ACCEPT^78^           the reply in a CHAR variable named LASTNAME, enter:
ACCEPT^79^
ACCEPT^80^               SQL> ACCEPT lastname CHAR FORMAT 'A20' -
ACCEPT^81^               >       PROMPT 'Enter employee lastname:  '
ACCEPT^82^
ACCEPT^83^
ACCEPT^84^
ACCEPT^85^ See also: define, input, prompt, parameters, commands.
ACCEPT^86^
APPEND^1^
APPEND^2^
APPEND^3^
APPEND^4^                                     APPEND
APPEND^5^
APPEND^6^ A[PPEND] text
APPEND^7^
APPEND^8^ Use APPEND to add text to the end of the current line in the SQL buffer.
APPEND^9^
APPEND^10^     text
APPEND^11^         is the text you wish to append.  To separate text from preceding
APPEND^12^         characters with a space, enter two spaces between APPEND and the
APPEND^13^         text. To APPEND text that ends with a semicolon, end the APPEND
APPEND^14^         command with two semicolons (SQL*Plus interprets one semicolon as
APPEND^15^         an optional command terminator).
APPEND^16^
APPEND^17^
APPEND^18^
APPEND^19^ Examples: To append a space and the column name DEPT to the second line
APPEND^20^           of the buffer, make that line the current line by entering:
APPEND^21^
APPEND^22^               SQL> 2
APPEND^23^                 2* FROM EMP
APPEND^24^
APPEND^25^           Now enter APPEND:
APPEND^26^
APPEND^27^               SQL> APPEND , DEPT
APPEND^28^               SQL> 2
APPEND^29^                 2* FROM EMP, DEPT
APPEND^30^
APPEND^31^           The first space between APPEND and the comma separates APPEND
APPEND^32^           from the characters to be appended; the second space is the
APPEND^33^           first appended character.  To append a semicolon to the line,
APPEND^34^           enter:
APPEND^35^
APPEND^36^               SQL> APPEND ;;
APPEND^37^
APPEND^38^           SQL*Plus appends the first semicolon to the line.  The second
APPEND^39^           semicolon terminates the command.
APPEND^40^
APPEND^41^
APPEND^42^
APPEND^43^ See also: buffer, change, del, edit, input, list, save, spool,
APPEND^44^           commands.
APPEND^45^
@^1^
@^2^
@^3^
@^4^                               @ ("at" sign)
@^5^
@^6^ @ file_name[.ext] [arg...]
@^7^
@^8^ Runs the specified command file.
@^9^
@^10^     file_name[.ext ]
@^11^         is the command file you wish to run. If you omit ext, SQL*Plus
@^12^         assumes the default command-file extension (usually SQL).  To
@^13^         change the default extension, use the SUFFIX clause of the SET
@^14^         command.  Use @file_name or @ file_name; the space is optional.
@^15^         Case may be significant in some operating environments.
@^16^
@^17^     arg...
@^18^         represent data items you wish to pass to parameters in the
@^19^         command file.  If you enter one or more arguments, SQL*Plus
@^20^         substitutes the values into the parameters (&1, &2, and so
@^21^         forth) in the command file.  The first argument replaces
@^22^         each occurrence of &1, the second replaces each occurrence
@^23^         of &2, and so forth.
@^24^
@^25^         The @ command DEFINEs the parameters with the values of the
@^26^         arguments; if you run the command file again in this session,
@^27^         you can enter new arguments or omit the arguments to use the
@^28^         current values.
@^29^
@^30^ You can include in a command file any typeable command--usually SQL or
@^31^ SQL*Plus commands or PL/SQL blocks.  EXIT or QUIT used in a command files
@^32^ terminates SQL*Plus.  The @ command functions similarly to START.
@^33^
@^34^ SQL*Plus removes the SQLTERMINATOR (a semicolon by default) before the
@^35^ @ command is issued.  A workaround for this is to add another
@^36^ SQLTERMINATOR.  See SET SQLTERMINATOR for more information on the
@^37^ SQLTERMINATOR.
@^38^
@^39^
@^40^
@^41^ Examples:
@^42^
@^43^     To run a command file named PRINTRPT.SQL, enter:
@^44^
@^45^         SQL> @PRINTRPT
@^46^
@^47^
@^48^
@^49^     To run the command file WKRPT with the extension QRY, enter:
@^50^
@^51^         SQL> @WKRPT.QRY
@^52^
@^53^
@^54^
@^55^ See also: @@, set (suffix), start, /, edit, run, get, buffer, spool,
@^56^           list, save, parameters, commands.
@^57^
@@^1^
@@^2^
@@^3^
@@^4^                               @@ (double "at" sign)
@@^5^
@@^6^ @@ file_name[.ext]
@@^7^
@@^8^ Runs a nested command file.  This command is identical to the @
@@^9^ command except that it looks for the specified command file in the
@@^10^ same path as the command file from which it was called.
@@^11^
@@^12^     file_name[.ext ]
@@^13^         is the command file you wish to run. If you omit ext, SQL*Plus
@@^14^         assumes the default command-file extension (usually SQL).  To
@@^15^         change the default extension, use the SUFFIX clause of the SET
@@^16^         command.  Use @@file_name or @@ file_name; the space is optional.
@@^17^         Case may be significant in some operating environments.
@@^18^
@@^19^ You can include in a command file any typeable command--usually SQL or
@@^20^ SQL*Plus commands.  EXIT or QUIT used in a command file terminates
@@^21^ SQL*Plus.  The @@ command functions similarly to START.
@@^22^
@@^23^ SQL*Plus removes the SQLTERMINATOR (a semicolon by default) before the
@@^24^ @@ command is issued.  A workaround for this is to add another
@@^25^ SQLTERMINATOR.  See SET SQLTERMINATOR for more information on the
@@^26^ SQLTERMINATOR.
@@^27^
@@^28^ Example:
@@^29^
@@^30^     Suppose that you have the following command file named PRINTRPT:
@@^31^       SELECT * FROM EMP
@@^32^       @EMPRPT
@@^33^       @@WKRPT
@@^34^
@@^35^     When you START PRINTRPT and it reaches the @ command, it looks for
@@^36^     the command file named EMPRPT in the current working directory
@@^37^     and runs it.  When PRINTRPT reaches the @@ command, it looks for
@@^38^     the command file named WKRPT in the same path as PRINTRPT and
@@^39^     runs it.
@@^40^
@@^41^
@@^42^
@@^43^See also: @, set (suffix), start, /, edit, run, get, buffer, spool,
@@^44^           list, save, parameters, commands.
@@^45^
BREAK^1^
BREAK^2^
BREAK^3^
BREAK^4^                                  BREAK
BREAK^5^
BREAK^6^ BRE[AK] [ON report_element [action [action]]] ...
BREAK^7^
BREAK^8^ where report_element and action require the following syntax:
BREAK^9^         report_element: {column | expression | ROW | REPORT}
BREAK^10^         action: [SKI[P] n|[SKI[P]] PAGE] [NODUP[LICATES] | DUP[LICATES]]
BREAK^11^
BREAK^12^ BREAK specifies where and how to make format changes to a report.  You use
BREAK^13^ BREAK to:
BREAK^14^
BREAK^15^     -   suppress the display of duplicate values for a given column
BREAK^16^     -   skip a line each time a given column value changes
BREAK^17^     -   COMPUTE figures when a given column value changes, or at the end
BREAK^18^             of a report (see COMPUTE)
BREAK^19^     -   list the current BREAK definition (by issuing the BREAK command
BREAK^20^             without any clauses following)
BREAK^21^
BREAK^22^ BREAK also lists the current BREAK definition.  Each new BREAK command
BREAK^23^ replaces the preceding one.  Use CLEAR BREAKS to remove the BREAK command.
BREAK^24^
BREAK^25^ BREAK report_elements:
BREAK^26^
BREAK^27^     ON column [action [action]]
BREAK^28^         specifies action(s) for SQL*Plus to take when a break occurs in
BREAK^29^         the break column.  The column cannot have a table or view
BREAK^30^         appended to it.  To achieve this, use an alias in the
BREAK^31^         SQL statement.  A break is:
BREAK^32^
BREAK^33^         -   a change in the value of a column or expression
BREAK^34^         -   the output of a row
BREAK^35^         -   the end of a report
BREAK^36^
BREAK^37^         If you omit action(s), BREAK ON column suppresses printing of
BREAK^38^         duplicate values in the column, marking in the report where
BREAK^39^         SQL*Plus will perform the computation you specify in a matching
BREAK^40^         COMPUTE command.  You can specify ON column one or more times.
BREAK^41^
BREAK^42^
BREAK^43^
BREAK^44^         Example:  If you specify multiple ON clauses, as in:
BREAK^45^
BREAK^46^                   SQL> BREAK ON DEPTNO SKIP PAGE ON JOB SKIP 1 -
BREAK^47^                      > ON SAL SKIP 1
BREAK^48^
BREAK^49^             the first ON clause is the outermost break (ON DEPTNO), and
BREAK^50^             the last ON clause is the innermost break (ON SAL).  SQL*Plus
BREAK^51^             searches each output row for the break(s), starting with the
BREAK^52^             outermost break and proceeding to the innermost in the order
BREAK^53^             you've entered the clauses.  In the example above, SQL*Plus
BREAK^54^             searches for a change in the value of DEPTNO, then JOB, then
BREAK^55^             SAL.
BREAK^56^
BREAK^57^             Next, SQL*Plus executes the actions, beginning with the action
BREAK^58^             for the innermost break and proceeding in reverse order toward
BREAK^59^             the outermost break (from SKIP 1 for ON SAL toward SKIP PAGE
BREAK^60^             for ON DEPTNO). SQL*Plus executes each action, including the
BREAK^61^             action for the first occurring break found in the initial
BREAK^62^             search.
BREAK^63^
BREAK^64^             If, for example, the value of JOB in a given row changes, but
BREAK^65^             the values of DEPTNO and SAL stay the same, SQL*Plus skips two
BREAK^66^             lines before printing the row: one as a result of SKIP 1 in
BREAK^67^             the ON SAL clause, the other as a result of SKIP 1 in the
BREAK^68^             ON JOB clause.
BREAK^69^
BREAK^70^             When you use ON column, you should also use the ORDER BY clause
BREAK^71^
BREAK^72^             in the SELECT statement.  The columns usually should appear in
BREAK^73^             the same order in ORDER BY as they do in BREAK, so that breaks
BREAK^74^             do not occur at meaningless points in the report.  All the
BREAK^75^             columns listed in ORDER BY need not appear in the BREAK command.
BREAK^76^
BREAK^77^
BREAK^78^
BREAK^79^             The following SELECT produces meaningful results with the above
BREAK^80^
BREAK^81^             BREAK:
BREAK^82^
BREAK^83^                   SQL> SELECT DEPTNO, JOB, SAL,ENAME
BREAK^84^                     2  FROM EMP
BREAK^85^                     3  ORDER BY DEPTNO, JOB, SAL, ENAME;
BREAK^86^
BREAK^87^
BREAK^88^
BREAK^89^             All rows with the same DEPTNO print together on one page, and
BREAK^90^             within that page all rows with the same JOB print in groups.
BREAK^91^             Within each group of jobs, those with the same SAL print in
BREAK^92^             groups.  Breaks in ENAME cause no action, because ENAME does
BREAK^93^             not appear in the BREAK command.
BREAK^94^
BREAK^95^     ON expr [action [action]]
BREAK^96^         specifies action(s) for SQL*Plus to take when the value of the
BREAK^97^         expression changes.  If action(s) are omitted, BREAK ON expr
BREAK^98^         suppresses printing of duplicate values of expr, marking in the
BREAK^99^         report the place where SQL*Plus will perform the computation you
BREAK^100^         specify in a matching COMPUTE command.
BREAK^101^
BREAK^102^         You can use an expression involving one or more table columns, or
BREAK^103^         an alias assigned to a report column in a SELECT statement or a
BREAK^104^         COLUMN command.  If you use an expression in a BREAK command, you
BREAK^105^         must enter expr exactly as it appears in SELECT; if the expression
BREAK^106^         in the SELECT statement is a+b, for example, you cannot use b+a or
BREAK^107^         (a+b) in a BREAK command to refer to the expression in the SELECT
BREAK^108^         statement.  The information for ON column also applies to ON expr.
BREAK^109^
BREAK^110^     ON ROW [action [action]]
BREAK^111^         specifies action(s) for SQL*Plus to take when a SELECT statement
BREAK^112^         returns a row. The ROW break becomes the innermost break no matter
BREAK^113^         where it appears in the BREAK command.  You should always specify
BREAK^114^         an action when you BREAK on a row.
BREAK^115^
BREAK^116^     ON REPORT [action]
BREAK^117^         marks in a report the place where SQL*Plus will perform the
BREAK^118^         computation specified in a matching COMPUTE command.  Use BREAK
BREAK^119^         ON REPORT with COMPUTE to print grand totals or other "grand"
BREAK^120^         computed values.  The REPORT break becomes the outermost break
BREAK^121^         regardless of where you specify it in the BREAK command.  Note
BREAK^122^         that SQL*Plus will not skip a page at the end of a report, so you
BREAK^123^         cannot use BREAK ON REPORT SKIP PAGE.
BREAK^124^
BREAK^125^ BREAK actions:
BREAK^126^
BREAK^127^     SKI[P] n
BREAK^128^         skips n lines before printing the row where the break occurred.
BREAK^129^
BREAK^130^     [SKI[P]] PAGE
BREAK^131^         skips to a new page before printing the row where break occurred.
BREAK^132^
BREAK^133^     NODUP[LICATES]
BREAK^134^         prints blanks rather than the value of a break column when the
BREAK^135^         value is a duplicate of the column's value in the preceding row.
BREAK^136^
BREAK^137^
BREAK^138^
BREAK^139^     DUP[LICATES]
BREAK^140^         prints the value of a break column in every selected row.
BREAK^141^
BREAK^142^             Example:  The example report below, produces prints duplicate
BREAK^143^             job values, prints the average of SAL, inserts one blank line
BREAK^144^             when the JOB value changes, and (when the value of DEPTNO
BREAK^145^             changes) prints the sum of SAL and inserts another blank line:
BREAK^146^
BREAK^147^                   SQL> BREAK ON DEPTNO SKIP 1 ON JOB SKIP 1 DUPLICATES
BREAK^148^                   SQL> COMPUTE SUM OF SAL ON DEPTNO
BREAK^149^                   SQL> COMPUTE AVG OF SAL ON JOB
BREAK^150^                   SQL> SELECT DEPTNO, JOB, ENAME, SAL FROM EMP
BREAK^151^                     2  WHERE JOB IN ('CLERK', 'SALESMAN')
BREAK^152^                     3  AND DEPTNO IN (10, 30)
BREAK^153^                     4  ORDER BY DEPTNO, JOB;
BREAK^154^
BREAK^155^             Output:
BREAK^156^
BREAK^157^                  DEPTNO  JOB       ENAME       SAL
BREAK^158^                  ------ --------- --------- ------
BREAK^159^                      10  CLERK     MILLER     1300
BREAK^160^                          ********           ------
BREAK^161^                          avg                  1300
BREAK^162^
BREAK^163^                  ******                     ------
BREAK^164^                  sum                          1300
BREAK^165^
BREAK^166^                      30  CLERK     JAMES      1045
BREAK^167^                          ********           ------
BREAK^168^                          avg                  1045
BREAK^169^
BREAK^170^                          SALESMAN  ALLEN      1760
BREAK^171^                          SALESMAN  MARTIN     1375
BREAK^172^                          SALESMAN  TURNER     1650
BREAK^173^                          SALESMAN  WARD       1375
BREAK^174^                          ********           ------
BREAK^175^                          avg                  1540
BREAK^176^
BREAK^177^                  ******                     ------
BREAK^178^                   sum                         7205
BREAK^179^
BREAK^180^
BREAK^181^
BREAK^182^ See also: compute, order by, select, SQL in PL/SQL, commands.
BREAK^183^
BTITLE^1^
BTITLE^2^
BTITLE^3^
BTITLE^4^                                   BTITLE
BTITLE^5^
BTITLE^6^ BTI[TLE] [printspec [text | variable] ...] | [OFF|ON]
BTITLE^7^
BTITLE^8^ BTITLE places and formats a title at the bottom of each report page, or
BTITLE^9^ lists the current BTITLE definition.  See TTITLE for a description of
BTITLE^10^ BTITLE clauses, and to learn how to print page numbers in the title. To
BTITLE^11^ list the current BTITLE definition, enter BTITLE with no clauses.
BTITLE^12^
BTITLE^13^ If you do not enter a printspec clause before the first occurrence of
BTITLE^14^ text, BTITLE left justifies the text.  SQL*Plus interprets BTITLE in
BTITLE^15^ the "new" form if a valid printspec clause (LEFT, SKIP, COL, etc)
BTITLE^16^ immediately follows BTITLE.  See OLD COMMANDS for a description of
BTITLE^17^ an alternative form of BTITLE.
BTITLE^18^
BTITLE^19^ Examples: To set a bottom title with CORPORATE PLANNING DEPARTMENT on the
BTITLE^20^           left and a date on the right, enter:
BTITLE^21^
BTITLE^22^               SQL> BTITLE LEFT 'CORPORATE PLANNING DEPARTMENT' -
BTITLE^23^               > RIGHT '11 Jan 1990'
BTITLE^24^
BTITLE^25^           To set a bottom title with CONFIDENTIAL in column 50, followed
BTITLE^26^           by six spaces and a date, enter:
BTITLE^27^
BTITLE^28^               SQL> BTITLE COL 50 'CONFIDENTIAL' TAB 6 '11 Jan 90'
BTITLE^29^
BTITLE^30^
BTITLE^31^
BTITLE^32^ See also: old commands, ttitle, repheader, repfooter, commands.
BTITLE^33^
BUFFER^1^
BUFFER^2^
BUFFER^3^
BUFFER^4^                                  Buffer
BUFFER^5^
BUFFER^6^ SQL Commands
BUFFER^7^     SQL commands you enter are stored in the SQL buffer.  You can continue
BUFFER^8^     a SQL command on one or more additional lines, ending and executing
BUFFER^9^     the command with a semicolon (;), a blank line, or a slash (/) on a
BUFFER^10^     line by itself.  SQL*Plus displays line numbers (matching the lines in
BUFFER^11^     the SQL buffer) for these additional lines.  Use SAVE to store the
BUFFER^12^     buffer's contents in a file.  Use RUN or slash (/) at the command
BUFFER^13^     prompt to execute commands in the SQL buffer.
BUFFER^14^
BUFFER^15^ PL/SQL Blocks
BUFFER^16^     SQL*Plus also stores PL/SQL programs (blocks) in the SQL buffer.
BUFFER^17^     To end a PL/SQL block, enter a . (period) by itself on a new line.
BUFFER^18^     Execute a block in the buffer with RUN or slash (/).  You can use
BUFFER^19^     REMARK and /*comments*/ with PL/SQL blocks as with SQL commands.
BUFFER^20^     In PL/SQL, you can also use "--" (two dashes) to begin a comment
BUFFER^21^     that ends with the next RETURN character.
BUFFER^22^
BUFFER^23^ SQL*Plus Commands
BUFFER^24^     Continue a long SQL*Plus command on additional lines by using a -
BUFFER^25^     (hyphen) at the end of each line; SQL*Plus prompts with a > for the
BUFFER^26^     next line.  A line not ended by a hyphen executes the command.
BUFFER^27^
BUFFER^28^
BUFFER^29^
BUFFER^30^     Example: If you enter the COLUMN command:
BUFFER^31^
BUFFER^32^               SQL> COLUMN ENAME HEADING EMPLOYEES -
BUFFER^33^                  > FORMAT A10
BUFFER^34^               SQL>
BUFFER^35^
BUFFER^36^     You can end a SQL*Plus command with ; (semicolon).  It's not required.
BUFFER^37^     SQL*Plus commands are not stored in the SQL buffer. Use EDIT to create
BUFFER^38^     command files containing SQL*Plus commands. START runs a command file.
BUFFER^39^     Use REMARK to enter comments within SQL*Plus commands.  You can also
BUFFER^40^     use /*comment delimiters*/ on a separate line before or after a
BUFFER^41^     SQL*Plus command, but not on the same line.
BUFFER^42^
BUFFER^43^
BUFFER^44^
BUFFER^45^ See also: substitution, commands.
BUFFER^46^
CHANGE^1^
CHANGE^2^
CHANGE^3^
CHANGE^4^                                   CHANGE
CHANGE^5^
CHANGE^6^ C[HANGE] sepchar old [sepchar [new[sepchar]]]
CHANGE^7^
CHANGE^8^ Use CHANGE to replace the first occurrence of the specified text on the
CHANGE^9^ current line of the buffer with the new specified text.
CHANGE^10^
CHANGE^11^     sepchar
CHANGE^12^         is any non-alphanumeric character such as "/" or "!".  You can
CHANGE^13^         use any sepchar that does not appear in "old" or "new".  The
CHANGE^14^         space between CHANGE and the first sepchar is optional.
CHANGE^15^
CHANGE^16^     old
CHANGE^17^         is the text you wish to change.  CHANGE ignores case in searching
CHANGE^18^         for old.  For example,  CHANGE /aq/aw  finds the first occurrence
CHANGE^19^         of "aq", "AQ", "aQ", or "Aq", and change it to "aw".  SQL*Plus
CHANGE^20^         inserts the new text exactly as you specify it.
CHANGE^21^
CHANGE^22^         If old is prefixed with "...", it matches everything up to and
CHANGE^23^         including the first occurrence of old.  If it is suffixed with
CHANGE^24^         "...", it matches the first occurrence of old and everything that
CHANGE^25^         follows on that line.  If it contains an embedded "...", it
CHANGE^26^         matches everything from the preceding part of old through the
CHANGE^27^         following part of old.
CHANGE^28^
CHANGE^29^     new
CHANGE^30^         is the text with which you wish to replace old.  If you omit new
CHANGE^31^         and, optionally, the second and third sepchars, CHANGE deletes old
CHANGE^32^         from the current line of the buffer.
CHANGE^33^
CHANGE^34^ CHANGE changes the first occurrence of the text you specify on the current
CHANGE^35^ line in the buffer.  The current line is marked with an asterisk (*) in
CHANGE^36^ the LIST output.  You can also use CHANGE to modify a line in the buffer
CHANGE^37^ that has caused an Oracle error; SQL*Plus makes the erroneous line, the
CHANGE^38^ current line.  To re-enter an entire line, type its number, then the new
CHANGE^39^ contents of the line. Entering a line number larger than the number of
CHANGE^40^ lines in the buffer causes SQL*Plus to add the text in a new line at the
CHANGE^41^ end of the buffer. Entering 0 for the line number causes SQL*Plus insert
CHANGE^42^ that line before the other lines (it becomes line 1).
CHANGE^43^
CHANGE^44^ Examples: The current line of the buffer contains the following text:
CHANGE^45^
CHANGE^46^               4* WHERE JOB IS IN ('CLERK','ANALYST')
CHANGE^47^
CHANGE^48^     Entering this...                  Changes the buffer text to this.
CHANGE^49^     ----------------------------------------------------------------------
CHANGE^50^     SQL> C /ANALYST/GUARD/            4* WHERE JOB IS IN ('CLERK','GUARD')
CHANGE^51^
CHANGE^52^     SQL> C /'CLERK',.../'CLERK')/     4* WHERE JOB IS IN ('CLERK')
CHANGE^53^
CHANGE^54^     SQL> C /(...)/('COOK','BUTLER')/  4* WHERE JOB IS IN ('COOK','BUTLER')
CHANGE^55^
CHANGE^56^
CHANGE^57^
CHANGE^58^         Use the line number to replace an entire line.  If you enter:
CHANGE^59^
CHANGE^60^               SQL> 2 FROM EMP e1
CHANGE^61^
CHANGE^62^         the second line of the buffer is replaced with:
CHANGE^63^
CHANGE^64^               FROM EMP e1
CHANGE^65^
CHANGE^66^
CHANGE^67^
CHANGE^68^         NOTE: Entering a line number and a string always replaces the line
CHANGE^69^         with the string, no matter what the text of the string:
CHANGE^70^
CHANGE^71^               SQL> 2  c/old/new/
CHANGE^72^
CHANGE^73^         changes the second line of the buffer to:
CHANGE^74^
CHANGE^75^               2* c/old/new/
CHANGE^76^
CHANGE^77^
CHANGE^78^
CHANGE^79^ See also: append, del, edit, input, list, save, buffer, spool,
CHANGE^80^           commands.
CHANGE^81^
CLEAR^1^
CLEAR^2^
CLEAR^3^
CLEAR^4^                                    CLEAR
CLEAR^5^
CLEAR^6^ CL[EAR] option ...
CLEAR^7^
CLEAR^8^ CLEAR resets or erases the current value or setting for the option, where
CLEAR^9^ option is one of the following clauses:
CLEAR^10^
CLEAR^11^     BRE[AKS]
CLEAR^12^         clears breaks set by the BREAK command.
CLEAR^13^
CLEAR^14^     BUFF[ER]
CLEAR^15^         clears text from the buffer.  CLEAR BUFFER works like CLEAR SQL,
CLEAR^16^         unless you are using multiple buffers.
CLEAR^17^
CLEAR^18^     COL[UMNS]
CLEAR^19^         clears options set by the COLUMN command for all columns. To clear
CLEAR^20^         settings for a single column, use the CLEAR clause of the COLUMN
CLEAR^21^         command.
CLEAR^22^
CLEAR^23^     COMP[UTES]
CLEAR^24^         clears options set by the COMPUTE command.
CLEAR^25^
CLEAR^26^     SCR[EEN]
CLEAR^27^         clears your screen.
CLEAR^28^
CLEAR^29^     SQL
CLEAR^30^         clears text from the SQL buffer.  CLEAR SQL works the same as
CLEAR^31^         CLEAR BUFFER, unless you are using multiple buffers.
CLEAR^32^
CLEAR^33^     TIMI[NG]
CLEAR^34^         deletes all timing areas created by the TIMING command.
CLEAR^35^
CLEAR^36^
CLEAR^37^
CLEAR^38^ Examples: To clear breaks, enter:
CLEAR^39^
CLEAR^40^               SQL> CLEAR BRE
CLEAR^41^
CLEAR^42^
CLEAR^43^
CLEAR^44^           To clear column elements, enter:
CLEAR^45^
CLEAR^46^               SQL> CLEAR COL
CLEAR^47^
CLEAR^48^
CLEAR^49^
CLEAR^50^ See also: break, buffer, column, compute, set (timing),
CLEAR^51^           commands.
CLEAR^52^
COLUMN^1^
COLUMN^2^
COLUMN^3^
COLUMN^4^                                   COLUMN
COLUMN^5^
COLUMN^6^ COL[UMN] [{column | expr} [option...] ]
COLUMN^7^
COLUMN^8^ where option is one of the following:
COLUMN^9^
COLUMN^10^     ALI[AS] alias
COLUMN^11^     CLE[AR] | DEF[AULT]
COLUMN^12^     FOLD_A[FTER] n
COLUMN^13^     FOLD_B[EFORE] n
COLUMN^14^     FOR[MAT] format
COLUMN^15^     HEA[DING] text
COLUMN^16^     JUS[TIFY] {L[EFT] | C[ENTER] | C[ENTRE] | R[IGHT]}
COLUMN^17^     LIKE {expr | alias}
COLUMN^18^     NEWL[INE]
COLUMN^19^     NEW_V[ALUE] variable
COLUMN^20^     NOPRI[NT] | PRI[NT]
COLUMN^21^     NUL[L] text
COLUMN^22^     OLD_V[ALUE] variable
COLUMN^23^     ON|OFF
COLUMN^24^     WRA[PPED] | WOR[D_WRAPPED] | TRU[NCATED]
COLUMN^25^
COLUMN^26^ COLUMN sets display attributes for a given column, such as:
COLUMN^27^
COLUMN^28^     -   text for the column heading
COLUMN^29^     -   alignment of the column heading
COLUMN^30^     -   format for NUMBER data
COLUMN^31^     -   wrapping of column data
COLUMN^32^
COLUMN^33^ Enter COLUMN with column or expr to list the current display attributes
COLUMN^34^ for only the column or expression specified.  Enter COLUMN with no clauses
COLUMN^35^ to list all current column display attributes.
COLUMN^36^
COLUMN^37^     {column | expr}
COLUMN^38^         identifies the data item (typically, the column name) in a SELECT
COLUMN^39^         statement to which the column command refers.  You must enter an
COLUMN^40^         expression exactly as it appears in the SQL SELECT statement if
COLUMN^41^         you use it in a COLUMN command.  For example, if the expression
COLUMN^42^         in the SELECT statement is a+b, you cannot use b+a or (a+b) in a
COLUMN^43^         COLUMN command to refer to the expression in the SELECT statement.
COLUMN^44^
COLUMN^45^         If you select columns with the same name from different tables, a
COLUMN^46^         COLUMN command for that column name will apply to both columns.
COLUMN^47^         That is, a COLUMN command for the column ENAME applies to all
COLUMN^48^         columns named ENAME that you reference in this session.  COLUMN
COLUMN^49^         ignores table name prefixes in SELECT statements.
COLUMN^50^
COLUMN^51^         To format the columns differently, assign a unique alias to each
COLUMN^52^         column within the SELECT statement itself (do not use the ALIAS
COLUMN^53^         clause of the COLUMN command) and enter a COLUMN command for each
COLUMN^54^         column's alias.
COLUMN^55^
COLUMN^56^     ALI[AS] alias
COLUMN^57^         assigns a specified alias to a column, which can be used to refer
COLUMN^58^         to the column in BREAK, COMPUTE, and other COLUMN commands.
COLUMN^59^
COLUMN^60^     CLE[AR] | DEF[AULT]
COLUMN^61^         resets the display attributes for the column to default values.
COLUMN^62^         To reset the attributes for all columns, use the CLEAR COLUMNS
COLUMN^63^         command.
COLUMN^64^
COLUMN^65^     FOLD_A[FTER] n
COLUMN^66^         inserts a carriage return after the column heading and after each
COLUMN^67^         row in the column.  You must enter n; the particular value you
COLUMN^68^         choose for n has no effect on the format.  SQL*Plus does not
COLUMN^69^         insert an extra carriage return after the last column in the
COLUMN^70^         SELECT list.
COLUMN^71^
COLUMN^72^     FOLD_B[EFORE] n
COLUMN^73^         inserts a carriage return before the column heading and before
COLUMN^74^         each row of the column.  You must enter n; the particular value
COLUMN^75^         you choose for n has no effect on the format.  FOLD_BEFORE n has
COLUMN^76^         the same effect as NEWLINE.  SQL*Plus does not insert an extra
COLUMN^77^         carriage return before the first column in the SELECT list.
COLUMN^78^
COLUMN^79^     FOR[MAT] format
COLUMN^80^         sets the display format of the column.  The format specification
COLUMN^81^         must be a text constant such as $9,999 or A10, not a variable.
COLUMN^82^
COLUMN^83^         A CHAR or VARCHAR2 (VARCHAR) column's width defaults to the
COLUMN^84^         column's width in the database.  A LONG column's
COLUMN^85^         width defaults to the value of SET LONGCHUNKSIZE or
COLUMN^86^         SET LONG, whichever is smaller.  A Trusted
COLUMN^87^         Oracle column of datatype MLSLABEL or RAW MLSLABEL defaults
COLUMN^88^         to the column's width as defined in the database or to the
COLUMN^89^         length of the column's heading, whichever is longer.
COLUMN^90^         Note: A Trusted Oracle column with a name of ROWLABEL defaults
COLUMN^91^         to a width of 15.  To change the width of a CHAR,
COLUMN^92^         VARCHAR2 (VARCHAR), LONG, or Trusted Oracle column
COLUMN^93^         to n, use FORMAT An.  If you specify a width shorter
COLUMN^94^         than the column heading, SQL*Plus truncates the heading.
COLUMN^95^
COLUMN^96^         SQL*Plus formats CHAR, VARCHAR2 (VARCHAR), or Trusted Oracle
COLUMN^97^         data left-justified.  If a value does not fit within the
COLUMN^98^         column width, SQL*Plus wraps or truncates the character
COLUMN^99^         string depending on the setting of SET WRAP.
COLUMN^100^
COLUMN^101^         In Oracle7, the default width and format of unformatted DATE
COLUMN^102^         columns in SQL*Plus is derived from the NLS parameters in
COLUMN^103^         effect.  Otherwise, the default width is A9.  In Oracle7, the
COLUMN^104^         NLS parameters may be set in your database parameter file and
COLUMN^105^         may be environment variables or an equivalent platform-
COLUMN^106^         specific mechanism.  They may also be specified for each
COLUMN^107^         session with the ALTER SESSION command.  (See the
COLUMN^108^         documentation for the Oracle7 Server for a complete
COLUMN^109^         description of the NLS parameters).
COLUMN^110^
COLUMN^111^         You can change the format of any DATE column using the SQL
COLUMN^112^         function TO_CHAR in your SQL SELECT statement.  You can also
COLUMN^113^         use an explicit COLUMN FORMAT command to adjust the column
COLUMN^114^         width.
COLUMN^115^
COLUMN^116^         When you use SQL functions like TO_CHAR, Oracle automatically
COLUMN^117^         allows for a very wide column.
COLUMN^118^
COLUMN^119^         To change the width of a DATE column to n, use the COLUMN
COLUMN^120^         command with FORMAT An.  If you specify a width shorter than
COLUMN^121^         the column heading, the heading is truncated.
COLUMN^122^
COLUMN^123^
COLUMN^124^
COLUMN^125^         Example:  To change the default format of DATE columns to
COLUMN^126^                   'YYYY-MM-DD':
COLUMN^127^
COLUMN^128^                   SQL> alter session set NLS_DATE_FORMAT = 'YYYY-MM-DD';
COLUMN^129^
COLUMN^130^                   Session altered.
COLUMN^131^
COLUMN^132^                   SQL> select hiredate
COLUMN^133^                     2  from emp
COLUMN^134^                     3  where empno = 7839;
COLUMN^135^
COLUMN^136^                   HIREDATE
COLUMN^137^                   ----------
COLUMN^138^                   1981-11-17
COLUMN^139^
COLUMN^140^         See ALTER SESSION for more information on the ALTER SESSION
COLUMN^141^         command.
COLUMN^142^
COLUMN^143^         NOTE: In a SELECT statement some SQL calculations such as
COLUMN^144^         TO_CHAR may cause a column to be very wide.  In such a case,
COLUMN^145^         use the FORMAT option to alter the column width.
COLUMN^146^
COLUMN^147^         A NUMBER column's width equals the width of the heading, or
COLUMN^148^         the width of the FORMAT plus one space for the sign,
COLUMN^149^         whichever is greater.  If you do not explicitly use FORMAT, then
COLUMN^150^         the column's width will always be at least the value of SET
COLUMN^151^         NUMWIDTH.  To change the width, use FORMAT followed by a number
COLUMN^152^         format element.  See the COLUMN command in the SQL*Plus
COLUMN^153^         User's Guide and Reference for more information on number formats.
COLUMN^154^
COLUMN^155^         SQL*Plus formats NUMBER data right-justified.  SQL*Plus never
COLUMN^156^         truncates a NUMBER column heading.  If a value does not fit
COLUMN^157^         within the column width, SQL*Plus displays a pound sign (#) in
COLUMN^158^         place of each digit the width allows to indicate overflow.
COLUMN^159^
COLUMN^160^         If a positive value is extremely large and a numeric overflow
COLUMN^161^         occurs when rounding a number, then the infinity sign (~) replaces
COLUMN^162^         the value.  Likewise, if a negative value is extremely small and a
COLUMN^163^         numeric overflow occurs when rounding a number, then the negative
COLUMN^164^         infinity sign replaces the value (-~).
COLUMN^165^
COLUMN^166^         With all number formats, SQL*Plus rounds a number to the specified
COLUMN^167^         number of significant digits.  When no format is given, a number's
COLUMN^168^         width defaults to the value of NUMWIDTH.  See the SET command.
COLUMN^169^
COLUMN^170^     HEA[DING] text
COLUMN^171^         defines a column heading.  If text contains blanks or punctuation
COLUMN^172^         characters, you must enclose it with single or double quotes.  If
COLUMN^173^         you omit a HEADING clause, the column's heading defaults to column
COLUMN^174^         or expr.  Each occurrence of the HEADSEP character (default = '|')
COLUMN^175^         begins a new line.  For example,
COLUMN^176^
COLUMN^177^               COLUMN ENAME HEADING 'Employee |Name'
COLUMN^178^
COLUMN^179^         produces a two-line column heading.  See the SET command's HEADSEP
COLUMN^180^         variable for information on changing the HEADSEP character.
COLUMN^181^
COLUMN^182^     JUS[TIFY] {L[EFT]|C[ENTER]|C[ENTRE]|R[IGHT]}
COLUMN^183^         aligns the heading.  If you do not use a JUSTIFY clause, headings
COLUMN^184^         for NUMBER columns default to RIGHT and headings for other column
COLUMN^185^         types default to LEFT.
COLUMN^186^
COLUMN^187^     LIKE {expr|alias}
COLUMN^188^         copies the display attributes of another column or expression
COLUMN^189^         (whose attributes you've defined with another COLUMN command).
COLUMN^190^         LIKE copies only attributes not defined by another clause in the
COLUMN^191^         current COLUMN command.
COLUMN^192^
COLUMN^193^     NEWL[INE]
COLUMN^194^         starts a new line before displaying the column's value. NEWLINE
COLUMN^195^         has the same effect as FOLD_BEFORE.
COLUMN^196^
COLUMN^197^     NEW_V[ALUE] variable
COLUMN^198^         specifies a variable to hold a column value, so you can reference
COLUMN^199^         the variable in TTITLE commands.  Use NEW_VALUE to display column
COLUMN^200^         values or the date in the top title.  You must include the column
COLUMN^201^         in a BREAK command with the SKIP PAGE action.
COLUMN^202^
COLUMN^203^         NEW_VALUE is useful for master/detail reports in which there is a
COLUMN^204^         new master record for each page.  For master/detail reporting, you
COLUMN^205^         must also include the column in the ORDER BY clause.
COLUMN^206^
COLUMN^207^         For information on displaying a column value in the bottom title,
COLUMN^208^         see COLUMN OLD_VALUE below.  See TTITLE for more information on
COLUMN^209^         referencing variables in titles.  See COLUMN FORMAT above for
COLUMN^210^         details on formatting and valid format models.
COLUMN^211^
COLUMN^212^     NOPRI[NT]|PRI[NT]
COLUMN^213^         controls the printing of the column (the column heading and all
COLUMN^214^         the selected values).  NOPRINT turns the printing of the column
COLUMN^215^         off; PRINT turns it on.
COLUMN^216^
COLUMN^217^     NUL[L] text
COLUMN^218^         controls the text SQL*Plus displays for null values in the given
COLUMN^219^         column.  The default is a white space.  SET NULL controls the text
COLUMN^220^         displayed for all null values for all columns, unless overridden
COLUMN^221^         for a specific column by the NULL clause of the COLUMN command.
COLUMN^222^
COLUMN^223^     OLD_V[ALUE] variable
COLUMN^224^         specifies a variable to hold a column value, so you can reference
COLUMN^225^         the variable in BTITLE commands.  Use OLD_VALUE to display column
COLUMN^226^         values in the bottom title.  You must include the column in a
COLUMN^227^         BREAK command with the SKIP PAGE action.
COLUMN^228^
COLUMN^229^         OLD_VALUE is useful for master/detail reports in which there is a
COLUMN^230^         new master record for each page.  For master/detail reporting, you
COLUMN^231^         must also include the column in the ORDER BY clause.
COLUMN^232^
COLUMN^233^         See COLUMN NEW_VALUE above for information on displaying a column
COLUMN^234^         value in the top title.  See TTITLE for more on referencing
COLUMN^235^         variables in titles.
COLUMN^236^
COLUMN^237^     ON|OFF
COLUMN^238^         controls the status of display attributes for a column.  OFF
COLUMN^239^         disables the attributes for a column without affecting the
COLUMN^240^         attributes' definition.  ON reinstates the attributes.
COLUMN^241^
COLUMN^242^     WRA[PPED]|WOR[D_WRAPPED]|TRU[NCATED]
COLUMN^243^         specifies how SQL*Plus treats a CHAR, VARCHAR2, LONG or DATE string
COLUMN^244^         that is too wide for a column.  WRAPPED wraps the string within
COLUMN^245^         the column bounds, beginning newlines when required.  WORD_WRAPPED
COLUMN^246^         left justifies each new line, skipping all leading whitespace,
COLUMN^247^         including embedded newline characters.  Embedded whitespace not
COLUMN^248^         on a line boundary is not skipped.  TRUNCATED cuts off the string
COLUMN^249^         at the end of the first display line.
COLUMN^250^
COLUMN^251^ You can enter any number of COLUMN commands for one or more columns.  All
COLUMN^252^ column attributes set for each column remain in effect for the remainder
COLUMN^253^ of the session, until you turn the column OFF, or until you use the CLEAR
COLUMN^254^ COLUMN command.  Thus, the COLUMN commands you enter can control a column's
COLUMN^255^ display attributes for multiple SQL SELECT statements.   When you enter
COLUMN^256^ multiple COLUMN commands for the same column, SQL*Plus applies their clauses
COLUMN^257^ collectively.  If several COLUMN commands apply the same clause to the same
COLUMN^258^ column, the last one entered will control the output.
COLUMN^259^
COLUMN^260^
COLUMN^261^
COLUMN^262^ Examples: To make the ENAME column 20 characters wide and display EMPLOYEE
COLUMN^263^           NAME on two lines at the top, enter:
COLUMN^264^
COLUMN^265^               SQL> COLUMN ENAME FORMAT A20 HEADING 'EMPLOYEE |NAME'
COLUMN^266^
COLUMN^267^           To format the SAL column so that it shows millions of dollars,
COLUMN^268^           rounds to cents, uses commas to separate thousands, and displays
COLUMN^269^           $0.00 when a value is zero:
COLUMN^270^
COLUMN^271^               SQL> COLUMN SAL FORMAT $9,999,990.99
COLUMN^272^
COLUMN^273^           To assign the alias NET to a column with a long expression,
COLUMN^274^           display the result in a dollar format, and display <NULL> for
COLUMN^275^           null values, enter:
COLUMN^276^
COLUMN^277^               SQL> COLUMN SAL+COMM+BONUS-EXPENSES-INS-TAX ALIAS NET
COLUMN^278^               SQL> COLUMN NET FORMAT $9,999,999.99 NULL '<NULL>'
COLUMN^279^
COLUMN^280^           This column specification is divided into two commands.  The
COLUMN^281^           first defines the alias NET, and the second uses NET to define
COLUMN^282^           the format.  In the first command, you must enter the expression
COLUMN^283^           exactly as in the SELECT statement.  Otherwise, SQL*Plus cannot
COLUMN^284^           match the COLUMN command to the appropriate column.  To wrap
COLUMN^285^           long values in a column named REMARKS, enter:
COLUMN^286^
COLUMN^287^               SQL> COLUMN REMARKS FORMAT A20 WRAP
COLUMN^288^
COLUMN^289^           Output:
COLUMN^290^
COLUMN^291^               CUSTOMER  DATE       QUANTITY   REMARKS
COLUMN^292^               --------  ---------  --------   --------------------
COLUMN^293^               123       25-AUG-89       144   This order must be s
COLUMN^294^                                               hipped by air freigh
COLUMN^295^                                               t to ORD.
COLUMN^296^
COLUMN^297^           If you replace WRAP with WORD_WRAP:
COLUMN^298^
COLUMN^299^               CUSTOMER  DATE       QUANTITY   REMARKS
COLUMN^300^               --------  ---------  --------   --------------------
COLUMN^301^               123       25-AUG-89       144   This order must be
COLUMN^302^                                               shipped by air
COLUMN^303^                                               freight to ORD.
COLUMN^304^
COLUMN^305^           If you specify TRUNCATE instead of WORD_WRAP:
COLUMN^306^
COLUMN^307^               CUSTOMER  DATE       QUANTITY   REMARKS
COLUMN^308^               --------  ---------  --------   --------------------
COLUMN^309^               123       25-AUG-89       144   This order must be s
COLUMN^310^
COLUMN^311^           To print the current date and the name of each job in the top
COLUMN^312^           title:
COLUMN^313^
COLUMN^314^               SQL> COLUMN JOB NOPRINT NEW_VALUE JOBVAR
COLUMN^315^               SQL> COLUMN TODAY NOPRINT NEW_VALUE DATEVAR
COLUMN^316^               SQL> BREAK ON JOB SKIP PAGE
COLUMN^317^               SQL> TTITLE CENTER 'Job Report' RIGHT DATEVAR  SKIP 2 -
COLUMN^318^                  > LEFT 'Job:     ' JOBVAR SKIP 2
COLUMN^319^               SQL> SELECT TO_CHAR(SYSDATE, 'MM/DD/YY') TODAY,
COLUMN^320^                 2  ENAME, JOB, MGR, HIREDATE, SAL, DEPTNO
COLUMN^321^                 3  FROM EMP WHERE JOB IN ('CLERK', 'SALESMAN')
COLUMN^322^                 4  ORDER BY JOB, ENAME;
COLUMN^323^
COLUMN^324^           Your 2-page report would look like this, with "Job Report"
COLUMN^325^           centered in your current line size:
COLUMN^326^
COLUMN^327^                                          Job Report             05/01/89
COLUMN^328^
COLUMN^329^           Job:     CLERK
COLUMN^330^
COLUMN^331^           ENAME            MGR HIREDATE          SAL     DEPTNO
COLUMN^332^           ---------- --------- --------- ----------- ----------
COLUMN^333^           ADAMS           7788 14-JAN-87        1100         20
COLUMN^334^           JAMES           7698 03-DEC-88         950         30
COLUMN^335^           MILLER          7782 23-JAN-89        1300         10
COLUMN^336^           SMITH           7902 17-DEC-88         800         20
COLUMN^337^
COLUMN^338^                                          Job Report             05/01/89
COLUMN^339^
COLUMN^340^           Job:     SALESMAN
COLUMN^341^
COLUMN^342^           ENAME            MGR HIREDATE          SAL     DEPTNO
COLUMN^343^           ---------- --------- --------- ----------- ----------
COLUMN^344^           ALLEN           7698 20-FEB-88        1600         30
COLUMN^345^           MARTIN          7698 28-SEP-86        1250         30
COLUMN^346^           TURNER          7698 08-SEP-83        1500         30
COLUMN^347^           WARD            7698 22-FEB-89        1250         30
COLUMN^348^
COLUMN^349^
COLUMN^350^
COLUMN^351^ See also: break, compute, clear, order by, set (long, numwidth, wrap),
COLUMN^352^           ttitle, commands.
COLUMN^353^
COMPUTE^1^
COMPUTE^2^
COMPUTE^3^
COMPUTE^4^                                  COMPUTE
COMPUTE^5^
COMPUTE^6^ COMP[UTE] [function [LAB[EL] text] ...
COMPUTE^7^     OF {quoted_select_expr|column|alias} ...
COMPUTE^8^     ON {quoted_select_expr|column|alias|REPORT|ROW} ...]
COMPUTE^9^
COMPUTE^10^ COMPUTE calculates and prints summary lines, using various standard
COMPUTE^11^ computations, on subsets of selected rows.  It also lists all COMPUTE
COMPUTE^12^ definitions.
COMPUTE^13^
COMPUTE^14^         Function     Computes
COMPUTE^15^         --------------------------------------------------
COMPUTE^16^         AVG          Average of non-null values
COMPUTE^17^         COU[NT]      Count of non-null values
COMPUTE^18^         MAX[IMUM]    Maximum value
COMPUTE^19^         MIN[IMUM]    Minimum value
COMPUTE^20^         NUM[BER]     Count of rows
COMPUTE^21^         STD          Standard deviation of non-null values
COMPUTE^22^         SUM          Sum of non-null values
COMPUTE^23^         VAR[IANCE]   Variance of non-null values
COMPUTE^24^
COMPUTE^25^         If you specify more than one function, use spaces between them.
COMPUTE^26^
COMPUTE^27^     LAB[EL] text
COMPUTE^28^          defines the label to be printed for the computed value.  If no
COMPUTE^29^          LABEL clause is used, text defaults to the unabbreviated function
COMPUTE^30^          keyword.  If text contains spaces or punctuation, you must
COMPUTE^31^          enclose it with single quotes.  The label prints left justified
COMPUTE^32^          and truncates to the column width or linesize, whichever is
COMPUTE^33^          smaller.  The maximum length of a label is 500 characters.
COMPUTE^34^
COMPUTE^35^          The label for the computed value appears in the break column
COMPUTE^36^          specified.  To suppress the label use the NOPRINT option of the
COMPUTE^37^          COLUMN command on the break column.
COMPUTE^38^
COMPUTE^39^          If you repeat a function in a COMPUTE command, SQL*Plus issues
COMPUTE^40^          a warning and uses the first occurrence of the function.
COMPUTE^41^
COMPUTE^42^          With ON REPORT and ON ROW computations, the label appears in the
COMPUTE^43^          first column listed in the SELECT statement.  The label can be
COMPUTE^44^          suppressed by using a NOPRINT column first in the SELECT
COMPUTE^45^          statement.  When you compute a function of the first column in
COMPUTE^46^          the SELECT statement ON REPORT or ON ROW then the computed value
COMPUTE^47^          appears in the first column and the label is not displayed.  To
COMPUTE^48^          see the label, select a dummy column first in the select list.
COMPUTE^49^
COMPUTE^50^     OF {quoted_select_expr|column|alias} ...
COMPUTE^51^          specifies the column(s) or expression(s) to be used in the
COMPUTE^52^          computation.  You must also specify these columns in the SELECT
COMPUTE^53^          statement, or SQL*Plus will ignore the COMPUTE command.
COMPUTE^54^
COMPUTE^55^          If you use a SQL SELECT list alias, you must use the SQL alias in
COMPUTE^56^          the COMPUTE command, not the column name.  If you use the
COMPUTE^57^          column name in this case, SQL*Plus will ignore the COMPUTE
COMPUTE^58^          command.
COMPUTE^59^
COMPUTE^60^          If you don't want the computed values of a given column to appear
COMPUTE^61^          in the output of a SELECT statement, use the COLUMN command with
COMPUTE^62^          a NOPRINT clause.  Use spaces between multiple expressions,
COMPUTE^63^          columns, or aliases within the OF clause.
COMPUTE^64^
COMPUTE^65^          To reference a SELECT expression or function reference in an OF
COMPUTE^66^          clause, place the expression or function reference in "quotes".
COMPUTE^67^          Column names and aliases do not need quotes.
COMPUTE^68^
COMPUTE^69^     ON {quoted_select_expr|column|alias|REPORT|ROW} ...
COMPUTE^70^          specifies the event SQL*Plus will use as a break.  COMPUTE prints
COMPUTE^71^          the computed value and restarts the computation when the event
COMPUTE^72^          occurs (that is, when the value of the expression changes, a new
COMPUTE^73^          ROW is fetched, or the end of the report is reached).
COMPUTE^74^
COMPUTE^75^          If multiple COMPUTE commands reference the same column in the ON
COMPUTE^76^          clause, only the last COMPUTE command applies.
COMPUTE^77^
COMPUTE^78^          To reference a SQL SELECT expression or function reference in
COMPUTE^79^          an ON clause, put the expression or function reference in quotes.
COMPUTE^80^          Column names and aliases do not need quotes.  Enter COMPUTE
COMPUTE^81^          without clauses to list all COMPUTE definitions.
COMPUTE^82^
COMPUTE^83^ Enter COMPUTE without clauses to list all COMPUTE definitions.
COMPUTE^84^
COMPUTE^85^ Columns cannot have tables or views appended to them.  Use aliases
COMPUTE^86^ in the SQL statement to achieve this instead.
COMPUTE^87^
COMPUTE^88^ For SQL*Plus to perform the computations:
COMPUTE^89^
COMPUTE^90^     -  One or more of the expressions, columns, or column aliases
COMPUTE^91^        referenced in the OF clause must also be in the SELECT statement.
COMPUTE^92^
COMPUTE^93^     -  The expression, column, or column alias referenced in the ON clause
COMPUTE^94^        must be in the SELECT statement and in the most recent BREAK
COMPUTE^95^        command.
COMPUTE^96^
COMPUTE^97^     -  If you reference either ROW or REPORT in the ON clause, you must
COMPUTE^98^        also reference ROW or REPORT in the most recent BREAK command.
COMPUTE^99^
COMPUTE^100^ To remove all COMPUTE definitions, use the CLEAR COMPUTES command.
COMPUTE^101^
COMPUTE^102^
COMPUTE^103^
COMPUTE^104^ Examples: To subtotal the salary for the clerk, analyst, and salesman
COMPUTE^105^           jobs with a compute label of TOTAL, enter:
COMPUTE^106^
COMPUTE^107^               SQL> BREAK ON JOB SKIP 1
COMPUTE^108^               SQL> COMPUTE SUM LABEL 'TOTAL' OF SAL ON JOB
COMPUTE^109^               SQL> SELECT JOB, ENAME, SAL
COMPUTE^110^                  2  FROM EMP
COMPUTE^111^                  3  WHERE JOB IN ('CLERK', 'ANALYST', 'SALESMAN')
COMPUTE^112^                  4  ORDER BY JOB, SAL;
COMPUTE^113^
COMPUTE^114^           Output:
COMPUTE^115^
COMPUTE^116^               JOB       ENAME             SAL
COMPUTE^117^               --------- ---------- ----------
COMPUTE^118^               ANALYST   SCOTT            3000
COMPUTE^119^                         FORD             3000
COMPUTE^120^               *********            ----------
COMPUTE^121^               TOTAL                      6000
COMPUTE^122^
COMPUTE^123^               CLERK     SMITH             800
COMPUTE^124^                         JAMES             950
COMPUTE^125^                         ADAMS            1100
COMPUTE^126^                         MILLER           1300
COMPUTE^127^               *********            ----------
COMPUTE^128^               TOTAL                      4150
COMPUTE^129^
COMPUTE^130^               SALESMAN  WARD             1250
COMPUTE^131^                         MARTIN           1250
COMPUTE^132^                         TURNER           1500
COMPUTE^133^                         ALLEN            1600
COMPUTE^134^               *********            ----------
COMPUTE^135^               TOTAL                      5600
COMPUTE^136^
COMPUTE^137^           To compute the average and maximum salary for the accounting and
COMPUTE^138^           sales departments, enter:
COMPUTE^139^
COMPUTE^140^               SQL> BREAK ON DNAME SKIP 1
COMPUTE^141^               SQL> COMPUTE AVG LABEL 'Dept Average' -
COMPUTE^142^               >            MAX LABEL 'Dept Maximum' -
COMPUTE^143^               >       OF SAL ON DNAME
COMPUTE^144^               SQL> SELECT DNAME, ENAME, SAL
COMPUTE^145^                 2  FROM DEPT, EMP
COMPUTE^146^                 3  WHERE DEPT.DEPTNO=EMP.DEPTNO
COMPUTE^147^                 4  AND DNAME IN ('ACCOUNTING', 'SALES')
COMPUTE^148^                 5  ORDER BY DNAME;
COMPUTE^149^
COMPUTE^150^           Output:
COMPUTE^151^
COMPUTE^152^               DNAME          ENAME             SAL
COMPUTE^153^               -------------- ---------- ----------
COMPUTE^154^               ACCOUNTING     CLARK            2450
COMPUTE^155^                              KING             5000
COMPUTE^156^                              MILLER           1300
COMPUTE^157^               **************            ----------
COMPUTE^158^               Dept Average              2916.66667
COMPUTE^159^               Dept Maximum                    5000
COMPUTE^160^
COMPUTE^161^               SALES          ALLEN            1600
COMPUTE^162^                              WARD             1250
COMPUTE^163^                              MARTIN           1250
COMPUTE^164^                              TURNER           1500
COMPUTE^165^                              JAMES             950
COMPUTE^166^                              BLAKE            2850
COMPUTE^167^               **************            ----------
COMPUTE^168^               Dept Average              1566.66667
COMPUTE^169^               Dept Maximum                    2850
COMPUTE^170^
COMPUTE^171^           To calculate the total of salaries less than 1,000 on a
COMPUTE^172^           report, enter:
COMPUTE^173^
COMPUTE^174^               SQL> compute sum of sal on report
COMPUTE^175^               SQL> break on report
COMPUTE^176^               SQL> column dummy heading ''
COMPUTE^177^               SQL> select '   ' dummy, sal, empno
COMPUTE^178^                 2  from emp
COMPUTE^179^                 3  where sal < 1000
COMPUTE^180^                 4  order by sal;
COMPUTE^181^
COMPUTE^182^           Output:
COMPUTE^183^
COMPUTE^184^                          SAL       EMPNO
COMPUTE^185^               --- ---------- -----------
COMPUTE^186^                          800        7369
COMPUTE^187^                          950        7900
COMPUTE^188^                   ----------
COMPUTE^189^               sum       5350
COMPUTE^190^
COMPUTE^191^           To compute the sum of salaries for departments 10 and 20
COMPUTE^192^           without printing the compute labels:
COMPUTE^193^
COMPUTE^194^               SQL> COLUMN DUMMY NOPRINT
COMPUTE^195^               SQL> COMPUTE SUM OF SAL ON DUMMY
COMPUTE^196^               SQL> BREAK ON DUMMY SKIP 1
COMPUTE^197^               SQL> SELECT DEPTNO DUMMY, DEPTNO, ENAME, SAL
COMPUTE^198^                 2  FROM EMP
COMPUTE^199^                 3  WHERE DEPTNO <= 20
COMPUTE^200^                 4  ORDER BY DEPTNO;
COMPUTE^201^
COMPUTE^202^           Output:
COMPUTE^203^
COMPUTE^204^                   DEPTNO ENAME             SAL
COMPUTE^205^               ---------- ---------- ----------
COMPUTE^206^                       10 KING             5000
COMPUTE^207^                       10 CLARK            2450
COMPUTE^208^                       10 MILLER           1300
COMPUTE^209^                                     ----------
COMPUTE^210^                                           8750
COMPUTE^211^
COMPUTE^212^                       20 JONES            2975
COMPUTE^213^                       20 FORD             3000
COMPUTE^214^                       20 SMITH             800
COMPUTE^215^                       20 SCOTT            3000
COMPUTE^216^                       20 ADAMS            1100
COMPUTE^217^                                     ----------
COMPUTE^218^                                          10875
COMPUTE^219^
COMPUTE^220^           If, instead, you do not want to print the label, only the
COMPUTE^221^           salary total at the end of the report:
COMPUTE^222^
COMPUTE^223^               SQL> COLUMN DUMMY NOPRINT
COMPUTE^224^               SQL> COMPUTE SUM OF SAL ON DUMMY
COMPUTE^225^               SQL> BREAK ON DUMMY
COMPUTE^226^               SQL> SELECT NULL DUMMY, DEPTNO, ENAME, SAL
COMPUTE^227^                 2  FROM EMP
COMPUTE^228^                 3  WHERE DEPTNO <= 20
COMPUTE^229^                 4  ORDER BY DEPTNO;
COMPUTE^230^
COMPUTE^231^           Output:
COMPUTE^232^
COMPUTE^233^                   DEPTNO ENAME             SAL
COMPUTE^234^               ---------- ---------- ----------
COMPUTE^235^                       10 KING             5000
COMPUTE^236^                       10 CLARK            2450
COMPUTE^237^                       10 MILLER           1300
COMPUTE^238^                       20 JONES            2975
COMPUTE^239^                       20 FORD             3000
COMPUTE^240^                       20 SMITH             800
COMPUTE^241^                       20 SCOTT            3000
COMPUTE^242^                       20 ADAMS            1100
COMPUTE^243^                                     ----------
COMPUTE^244^                                          19625
COMPUTE^245^
COMPUTE^246^
COMPUTE^247^
COMPUTE^248^ See also: column, break, select, commands.
COMPUTE^249^
CONNECT^1^
CONNECT^2^
CONNECT^3^
CONNECT^4^                                   CONNECT
CONNECT^5^
CONNECT^6^ CONN[ECT] username[/password][@database_specification]|/
CONNECT^7^
CONNECT^8^ CONNECT establishes a connection to an Oracle database.
CONNECT^9^
CONNECT^10^     username[/password]
CONNECT^11^         are the username and password connecting to Oracle.  If you omit
CONNECT^12^         the username or password, SQL*Plus prompts you for them.  If you
CONNECT^13^         enter a slash (/) or enter RETURN to the prompt for username,
CONNECT^14^         SQL*Plus logs you in with a default logon.
CONNECT^15^
CONNECT^16^     @database_specification
CONNECT^17^         is a SQL*Net connection string.  The syntax depends on the SQL*Net
CONNECT^18^         communications protocol of your Oracle installation.  SQL*Plus
CONNECT^19^         does not prompt you for a database_specification, but uses your
CONNECT^20^         default database if you omit a specification.
CONNECT^21^
CONNECT^22^     /   is a default logon using operating system authentication.  You
CONNECT^23^         can't use a database_specification if you use a default logon.  In
CONNECT^24^         a default logon, SQL*Plus tries to log in with OPS$ name; name is
CONNECT^25^         the operating system username.
CONNECT^26^
CONNECT^27^ CONNECT commits the current transaction to the database, disconnects the
CONNECT^28^ current username from Oracle, and reconnects with the specified username.
CONNECT^29^
CONNECT^30^
CONNECT^31^
CONNECT^32^ Examples: To connect across SQL*Net using username SCOTT and password TIGER
CONNECT^33^           to the database known by the SQL*Net alias as FLEETDB, enter:
CONNECT^34^
CONNECT^35^               SQL> CONNECT SCOTT/TIGER@FLEETDB
CONNECT^36^
CONNECT^37^           To connect with username SCOTT, letting SQL*Plus prompt you for
CONNECT^38^           the password, enter:
CONNECT^39^
CONNECT^40^               SQL> CONNECT SCOTT
CONNECT^41^
CONNECT^42^
CONNECT^43^
CONNECT^44^ See also: disconnect, exit, host, quit, commands.
CONNECT^45^
COPY^1^
COPY^2^
COPY^3^
COPY^4^                                 COPY
COPY^5^
COPY^6^ COPY [FROM username [/password] [@database_specification]|
COPY^7^       TO username [/password] [@database_specification]]
COPY^8^       {APPEND|CREATE|INSERT|REPLACE} destination_table
COPY^9^       [(column, column, column, ...)] USING query
COPY^10^
COPY^11^       COPY copies data from a query to a table in a local or remote database.
COPY^12^
COPY^13^     username [/password]
COPY^14^         are the Oracle username/password  you wish to COPY FROM and TO.
COPY^15^         In the FROM clause, username/password identifies the data source;
COPY^16^         in the TO clause, username/password identifies the destination.
COPY^17^         If you do not specify password in either the FROM or TO clause,
COPY^18^         SQL*Plus prompts you for it.
COPY^19^
COPY^20^     @database_specification
COPY^21^         is a database link name or a SQL*Net connection string.  In the
COPY^22^         FROM clause, database_specification is the database at the source;
COPY^23^         in the TO clause, database_specification is the database at the
COPY^24^         destination.  The syntax depends upon the SQL*Net communications
COPY^25^         protocol of your Oracle installation.  SQL*Plus does not prompt
COPY^26^         you for a database specification, but uses your default database
COPY^27^         if you omit a specification.
COPY^28^
COPY^29^     destination_table
COPY^30^         is the table to be created or to which you wish to add data.
COPY^31^
COPY^32^     (column, column, column, ...)
COPY^33^         specifies the names of the columns in destination_table.  You must
COPY^34^         enclose a name in "double quotes" if it contains lowercase letters
COPY^35^         or spaces.  The number of columns you specify must equal the
COPY^36^         number of columns selected by the query.  If you don't specify any
COPY^37^         columns, they will have the same names in the destination table as
COPY^38^         they had in the source, if COPY creates destination_table.
COPY^39^
COPY^40^     USING query
COPY^41^          specifies a SQL query (SELECT statement) to determine which rows
COPY^42^          and columns to copy.
COPY^43^
COPY^44^     FROM username [/password] [@database_specification]
COPY^45^          specifies the username, password, and database with the data to be
COPY^46^          copied.  If the FROM clause is omitted, the source defaults to the
COPY^47^          database to which SQL*Plus is connected.  You must include this
COPY^48^          clause to specify a source database other than the default.
COPY^49^
COPY^50^     TO username [/password] [@database_specification]
COPY^51^          specifies the database containing the destination table.  If you
COPY^52^          omit the TO clause, the destination defaults to the database
COPY^53^          to which SQL*Plus is connected.  You must include this clause to
COPY^54^          specify a destination database other than the default.
COPY^55^
COPY^56^     APPEND
COPY^57^         inserts the rows from query into destination_table if the table
COPY^58^         exists.  If destination_table does not exist, COPY creates it.
COPY^59^
COPY^60^     CREATE
COPY^61^         inserts the rows from query into destination_table after creating
COPY^62^         the table.  If destination_table exists, COPY returns an error.
COPY^63^
COPY^64^     INSERT
COPY^65^         inserts the rows from query into destination_table. If
COPY^66^         destination_table doesn't exist, COPY returns an error.
COPY^67^
COPY^68^     REPLACE
COPY^69^         replaces destination_table and its contents with the rows from
COPY^70^         query.  If destination_table does not exist, COPY creates it.
COPY^71^         Otherwise, COPY drops the table and replaces it with a
COPY^72^         table containing the copied data.
COPY^73^
COPY^74^
COPY^75^
COPY^76^ To enable the copying of data between Oracle and non-Oracle databases,
COPY^77^ NUMBER columns are changed to DECIMAL columns in the destination table.
COPY^78^ Hence, if you are copying between Oracle databases, a NUMBER column
COPY^79^ with no precision will be changed to a DECIMAL(38) column.  When
COPY^80^ copying between Oracle databases, you should use SQL commands
COPY^81^ (CREATE TABLE AS and INSERT) or you should ensure that your columns
COPY^82^ have a precision specified.
COPY^83^
COPY^84^ The SQL*Plus SET system_variable LONG clause limits the length of LONG
COPY^85^ columns that are copied.  If any LONG columns have data longer than the
COPY^86^ LONG value, COPY truncates the data.  SQL*Plus performs a commit at the
COPY^87^ end of each successful COPY.  If you set the SQL*Plus SET system_variable
COPY^88^ COPYCOMMIT to a positive value n, SQL*Plus performs a commit after copying
COPY^89^ every n batches of records; the SET system_variable ARRAYSIZE clause
COPY^90^ determines the size of a batch.
COPY^91^
COPY^92^
COPY^93^
COPY^94^ Examples: The command below copies the entire EMP table from database HQ
COPY^95^           to a table named WESTEMP in database WEST.  If WESTEMP already
COPY^96^           exists, SQL*Plus replaces its contents.  Columns in WESTEMP have
COPY^97^           the same names as the columns in the source table, EMP:
COPY^98^
COPY^99^               SQL> COPY FROM SCOTT/TIGER@HQ TO JOHN/CHROME@WEST -
COPY^100^               > REPLACE WESTEMP -
COPY^101^               > USING SELECT * FROM EMP
COPY^102^
COPY^103^           The following command copies selected records from EMP in
COPY^104^           database HQ to the database to which SQL*Plus is connected:
COPY^105^           SQL*Plus creates SALESMEN through the copy.  SQL*Plus copies
COPY^106^           only the columns EMPNO and ENAME and at the destination names
COPY^107^           them EMPNO and SALESMAN.
COPY^108^
COPY^109^               SQL> COPY FROM SCOTT/TIGER@HQ -
COPY^110^               > CREATE SALESMEN (EMPNO,SALESMAN) -
COPY^111^               > USING SELECT EMPNO, ENAME FROM EMP -
COPY^112^               > WHERE JOB='SALES'
COPY^113^
COPY^114^
COPY^115^
COPY^116^           SQL*Plus creates SALESMEN through the copy, copies columns EMPNO
COPY^117^           and ENAME, and names them EMPNO and SALESMAN at the destination.
COPY^118^
COPY^119^
COPY^120^
COPY^121^ See also: connect, disconnect, describe, edit, set (arraysize, copycommit,
COPY^122^           long), commands.
COPY^123^
DBA^1^
DBA^2^
DBA^3^
DBA^4^                                     DBA
DBA^5^
DBA^6^ DBA username SYSTEM owns and has all privileges on PRODUCT_USER_PROFILE.
DBA^7^ Other users should have only SELECT access to this table.  Command file
DBA^8^ PUPBLD, when run, grants SELECT access on PRODUCT_USER_PROFILE to PUBLIC.
DBA^9^
DBA^10^ To disable a SQL or SQL*Plus command for a given user, the DBA inserts a
DBA^11^ row with the username in the USERID column, the command in the ATTRIBUTE
DBA^12^ column, and DISABLED in the CHAR_VALUE column.  The SCOPE, NUMERIC_VALUE,
DBA^13^ and DATE_VALUE columns should contain null.  For example:
DBA^14^
DBA^15^                                             NUMERIC   CHAR      DATE
DBA^16^      PRODUCT    USERID   ATTRIBUTE   SCOPE  VALUE     VALUE     VALUE
DBA^17^      --------   ------   ---------   -----  -------   --------  -----
DBA^18^      SQL*Plus   SCOTT    HOST                         DISABLED
DBA^19^      SQL*Plus   %        INSERT                       DISABLED
DBA^20^      SQL*Plus   %        UPDATE                       DISABLED
DBA^21^      SQL*Plus   %        DELETE                       DISABLED
DBA^22^
DBA^23^ To re-enable a command, the DBA deletes the row with the restriction.
DBA^24^
DBA^25^ The DBA can use the PRODUCT_USER_PROFILE table to disable the following:
DBA^26^
DBA^27^      SQL*Plus Commands     SQL Commands
DBA^28^      -----------------     -------------------------------------------
DBA^29^      CONNECT    QUIT       ALTER    DELETE    NOAUDIT  SET TRANSACTION
DBA^30^      EDIT       RUN        ANALYZE  DROP      RENAME   TRUNCATE
DBA^31^      EXECUTE    SAVE       AUDIT    GRANT     REVOKE   UPDATE
DBA^32^      EXIT       SET        CONNECT  INSERT    SELECT   VALIDATE
DBA^33^      GET        SPOOL      CREATE   LOCK      SET ROLE
DBA^34^      HOST       START
DBA^35^
DBA^36^      PL/SQL Commands
DBA^37^      ---------------
DBA^38^      BEGIN
DBA^39^      DECLARE
DBA^40^
DBA^41^ Note that ANALYZE, SET ROLE, and TRUNCATE require Oracle7.
DBA^42^ Columns in the PRODUCT_USER_PROFILE table:
DBA^43^
DBA^44^     PRODUCT contains the product name (SQL*Plus in this case).  Wildcards
DBA^45^         and nulls are not permitted.
DBA^46^
DBA^47^     USERID contains the username (in CAPITALS) for whom the command is
DBA^48^         being disabled.  To disable the command for more than one user,
DBA^49^         use the % SQL wildcard or make multiple entries.
DBA^50^
DBA^51^     ATTRIBUTE contains the command (in CAPITALS) being disabled or
DBA^52^         the character string "ROLES".  Wildcards are not permitted.
DBA^53^
DBA^54^     SCOPE is ignored for SQL*Plus.  We recommend a NULL here.
DBA^55^
DBA^56^     NUMERIC_VALUE is ignored for SQL*Plus.  We recommend a NULL here.
DBA^57^
DBA^58^     CHAR_VALUE must contain "DISABLED" or the name of the role being
DBA^59^         disabled.  Wildcards are not permitted.
DBA^60^
DBA^61^     DATE_VALUE is ignored for SQL*Plus.  We recommend a NULL here.
DBA^62^
DBA^63^     LONG_VALUE is ignored for SQL*Plus.  We recommend a NULL here.
DBA^64^
DBA^65^
DBA^66^
DBA^67^     See also:  commands.
DBA^68^
DEFINE^1^
DEFINE^2^
DEFINE^3^
DEFINE^4^                                   DEFINE
DEFINE^5^
DEFINE^6^ DEF[INE] [variable]|[variable = text]
DEFINE^7^
DEFINE^8^ DEFINE specifies a user variable and assigns it a CHAR value, or lists
DEFINE^9^ the value and variable type of a single variable or all variables.
DEFINE^10^
DEFINE^11^     variable
DEFINE^12^         is the user variable whose value you wish to assign or list.
DEFINE^13^         Enter DEFINE followed by variable to list the value and type of
DEFINE^14^         variable.  Enter DEFINE with no clauses to list the values and
DEFINE^15^         types of all user variables.
DEFINE^16^
DEFINE^17^     variable = text
DEFINE^18^         defines (names) a user variable and assigns it a CHAR value.
DEFINE^19^
DEFINE^20^     text
DEFINE^21^         is the CHAR value you wish to assign to variable.  Enclose text in
DEFINE^22^         'single quotes' if it contains punctuation or blanks.
DEFINE^23^
DEFINE^24^ DEFINEd variables retain their values until you:
DEFINE^25^
DEFINE^26^     -   enter a new DEFINE command referencing the variable, or
DEFINE^27^     -   enter an UNDEFINE command referencing the variable, or
DEFINE^28^     -   enter an ACCEPT command referencing the variable, or
DEFINE^29^     -   reference the variable in the NEW_VALUE or OLD_VALUE clause of
DEFINE^30^           the COLUMN command, and reference the column in a subsequent SQL
DEFINE^31^           SELECT statement, or
DEFINE^32^     -   EXIT SQL*Plus.
DEFINE^33^
DEFINE^34^ When you run a stored query or a command file, SQL*Plus substitutes the
DEFINE^35^ value of variable for each substitution variable referencing &variable or
DEFINE^36^ &&variable.  SQL*Plus will not prompt you for the value of variable in
DEFINE^37^ the session until you UNDEFINE variable.  Note that you can use DEFINE to
DEFINE^38^ define the _EDITOR variable, which establishes the host system editor
DEFINE^39^ invoked by the EDIT command.
DEFINE^40^
DEFINE^41^ If you continue the value of a DEFINEd variable on multiple lines with the
DEFINE^42^ SQL*Plus command continuation character, each continuation character and
DEFINE^43^ carriage return you enter are replaced with a space in the resulting
DEFINE^44^ variable.  For example, SQL*Plus interprets
DEFINE^45^
DEFINE^46^     SQL> DEFINE TEXT = 'ONE-
DEFINE^47^     > TWO-
DEFINE^48^     > THREE'
DEFINE^49^
DEFINE^50^ as:  SQL> DEFINE TEXT = 'ONE TWO THREE'
DEFINE^51^
DEFINE^52^
DEFINE^53^
DEFINE^54^ Examples: To assign the value MANAGER to the variable POS, enter:
DEFINE^55^
DEFINE^56^               SQL> DEFINE POS = MANAGER
DEFINE^57^
DEFINE^58^           If you execute a command with a reference to &POS, SQL*Plus
DEFINE^59^           substitutes the value MANAGER for &POS, and will not prompt you
DEFINE^60^           for a POS value.  To assign the CHAR value 20 to the variable
DEFINE^61^           DEPTNO, enter:
DEFINE^62^
DEFINE^63^               SQL> DEFINE DEPTNO = 20
DEFINE^64^
DEFINE^65^           Even though you enter the number 20, SQL*Plus assigns a CHAR
DEFINE^66^           value to DEPTNO consisting of two characters, 2 and 0.  To see
DEFINE^67^           the definition of DEPTNO, enter:
DEFINE^68^
DEFINE^69^               SQL> DEFINE DEPTNO
DEFINE^70^
DEFINE^71^           Result:
DEFINE^72^
DEFINE^73^               DEFINE DEPTNO = "20" (CHAR)
DEFINE^74^
DEFINE^75^
DEFINE^76^
DEFINE^77^ See also: accept, column, edit, parameters, undefine, commands.
DEFINE^78^
DEL^1^
DEL^2^
DEL^3^
DEL^4^                                     DEL
DEL^5^
DEL^6^ DEL [n|n m|n *|n LAST|*|* n|* LAST|LAST]
DEL^7^
DEL^8^
DEL^9^
DEL^10^     Clause    Deletes
DEL^11^     -----------------------------------------
DEL^12^     n         line n.
DEL^13^     n m       lines n through m.
DEL^14^     n *       line n through the current line.
DEL^15^     n LAST    line n through the last line.
DEL^16^     *         the current line.
DEL^17^     * n       the current line through line n.
DEL^18^     * LAST    the current line through the last line.
DEL^19^     LAST      the last line.
DEL^20^
DEL^21^ DEL deletes one or more lines of the buffer.  DEL makes the
DEL^22^ following line of the buffer (if any) the current line. You can
DEL^23^ enter DEL several times to delete several consecutive lines.
DEL^24^
DEL^25^
DEL^26^
DEL^27^ Examples: The SQL buffer contains the following query:
DEL^28^
DEL^29^               SQL> LIST
DEL^30^                 1  SELECT ENAME, DEPTNO
DEL^31^                 2  FROM EMP
DEL^32^                 3  WHERE JOB = 'SALESMAN'
DEL^33^                 4* ORDER BY DEPTNO
DEL^34^
DEL^35^           To make the line with the WHERE clause the current line, enter:
DEL^36^
DEL^37^               SQL> LIST 3
DEL^38^                 3* WHERE JOB = 'SALESMAN'
DEL^39^
DEL^40^           followed by:
DEL^41^
DEL^42^               SQL> DEL
DEL^43^
DEL^44^           The SQL buffer now contains:
DEL^45^
DEL^46^               SQL> LIST
DEL^47^                 1  SELECT ENAME, DEPTNO
DEL^48^                 2  FROM EMP
DEL^49^                 3* ORDER BY DEPTNO
DEL^50^
DEL^51^           To delete the second line of the buffer, enter:
DEL^52^
DEL^53^               SQL> DEL 2
DEL^54^
DEL^55^           The SQL buffer now contains:
DEL^56^
DEL^57^               SQL> LIST
DEL^58^                 1  SELECT ENAME, DEPTNO
DEL^59^                 2* ORDER BY DEPTNO
DEL^60^
DEL^61^
DEL^62^
DEL^63^ See also: append, change, edit, input, list, save, commands.
DEL^64^
DESCRIBE^1^
DESCRIBE^2^
DESCRIBE^3^
DESCRIBE^4^                                  DESCRIBE
DESCRIBE^5^
DESCRIBE^6^ DESC[RIBE] {[user.]table[@database_link_name] [column]|
DESCRIBE^7^    [user.] object[.subobject]}
DESCRIBE^8^
DESCRIBE^9^ DESCRIBE lists the column definitions for a table, view, or synonym,
DESCRIBE^10^ or the specifications for a function or procedure.
DESCRIBE^11^
DESCRIBE^12^     user
DESCRIBE^13^         is the owner of the object.  Omit user if you own the object.
DESCRIBE^14^
DESCRIBE^15^     table
DESCRIBE^16^         is a table, view, or synonym.
DESCRIBE^17^
DESCRIBE^18^     database_link_name
DESCRIBE^19^         is the node name and database where object exists.  The syntax
DESCRIBE^20^         depends on the SQL*Net your computer uses.  See LINKS for more
DESCRIBE^21^         information on database links.
DESCRIBE^22^
DESCRIBE^23^     column
DESCRIBE^24^         is the column in table you wish to describe.
DESCRIBE^25^
DESCRIBE^26^     object
DESCRIBE^27^         is the function or procedure you wish to describe.  If you want
DESCRIBE^28^         to describe a procedure in a package, object is the name of the
DESCRIBE^29^         package.
DESCRIBE^30^
DESCRIBE^31^     subobject
DESCRIBE^32^         is the function or procedure in a package that you wish
DESCRIBE^33^         to describe.
DESCRIBE^34^
DESCRIBE^35^ For each column, the description lists:
DESCRIBE^36^
DESCRIBE^37^     -   the column's name
DESCRIBE^38^     -   whether null values are allowed (NULL or NOT NULL) for the column
DESCRIBE^39^     -   the column's datatype, for example, NUMBER, CHAR, VARCHAR2
DESCRIBE^40^         (VARCHAR), LONG, DATE, MLSLABEL, RAW MLSLABEL, RAW, LONGRAW,
DESCRIBE^41^         ROWID.
DESCRIBE^42^     -   the column's precision (and scale, if any, for a numeric column)
DESCRIBE^43^
DESCRIBE^44^ For each function or procedure the description lists:
DESCRIBE^45^
DESCRIBE^46^     -   the type of PL/SQL object (function or procedure)
DESCRIBE^47^     -   the name of the function or procedure
DESCRIBE^48^     -   the arguments, their type, input/output, and default values
DESCRIBE^49^
DESCRIBE^50^
DESCRIBE^51^
DESCRIBE^52^ Example:  To describe the EMP table, enter:
DESCRIBE^53^
DESCRIBE^54^           SQL> DESCRIBE EMP
DESCRIBE^55^
DESCRIBE^56^       Output:  Name       Null?     Type
DESCRIBE^57^                ---------- --------  -----------
DESCRIBE^58^                EMPNO      NOT NULL  NUMBER(4)
DESCRIBE^59^                ENAME                CHAR(10)
DESCRIBE^60^                JOB                  CHAR(9)
DESCRIBE^61^                MGR                  NUMBER(4)
DESCRIBE^62^                HIREDATE             DATE
DESCRIBE^63^                SAL                  NUMBER(7,2)
DESCRIBE^64^                COMM                 NUMBER(7,2)
DESCRIBE^65^                DEPTNO               NUMBER(2)
DESCRIBE^66^
DESCRIBE^67^ To describe a procedure called CUSTOMER_LOOKUP, enter:
DESCRIBE^68^
DESCRIBE^69^       SQL> DESCRIBE customer_lookup
DESCRIBE^70^
DESCRIBE^71^       PROCEDURE customer_lookup
DESCRIBE^72^       Argument Name Type     In/Out Default?
DESCRIBE^73^       ------------- -------- ------ -------------
DESCRIBE^74^       CUST_ID       NUMBER   IN
DESCRIBE^75^       CUST_NAME     VARCHAR2 OUT
DESCRIBE^76^
DESCRIBE^77^ To describe the procedure APROC in the package APACK, enter
DESCRIBE^78^
DESCRIBE^79^       SQL> DESCRIBE apack.aproc
DESCRIBE^80^
DESCRIBE^81^       PROCEDURE apack.aproc
DESCRIBE^82^       Argument Name Type     In/Out Default?
DESCRIBE^83^       ------------- -------- ------ -------------
DESCRIBE^84^       P1            CHAR     IN
DESCRIBE^85^       P2            NUMBER   IN
DESCRIBE^86^
DESCRIBE^87^
DESCRIBE^88^
DESCRIBE^89^ See also: links, tables, views (and indexes), commands.
DESCRIBE^90^
DISCONNECT^1^
DISCONNECT^2^
DISCONNECT^3^
DISCONNECT^4^                                 DISCONNECT
DISCONNECT^5^
DISCONNECT^6^ DISC[ONNECT]
DISCONNECT^7^
DISCONNECT^8^ DISCONNECT commits pending changes to the database and logs the current
DISCONNECT^9^ user out of Oracle, but does not exit SQL*Plus.  Use EXIT or QUIT to log
DISCONNECT^10^ out of Oracle and return control to your host computer's operating system.
DISCONNECT^11^
DISCONNECT^12^
DISCONNECT^13^
DISCONNECT^14^ Example:  Your command file might begin with a CONNECT command and end
DISCONNECT^15^           with a DISCONNECT:
DISCONNECT^16^
DISCONNECT^17^               SQL> GET MYFILE
DISCONNECT^18^                 1  CONNECT ...
DISCONNECT^19^                    .
DISCONNECT^20^                    .
DISCONNECT^21^                    .
DISCONNECT^22^                15* DISCONNECT
DISCONNECT^23^
DISCONNECT^24^
DISCONNECT^25^
DISCONNECT^26^ See also: connect, exit, host, quit, SQLPlus, commands.
DISCONNECT^27^
EDIT^1^
EDIT^2^
EDIT^3^
EDIT^4^                                EDIT
EDIT^5^
EDIT^6^ ED[IT] [file_name[.ext]]
EDIT^7^
EDIT^8^ EDIT invokes a host operating system text editor on the contents of the
EDIT^9^ specified file or on the contents of the buffer.
EDIT^10^
EDIT^11^     file_name[.ext]
EDIT^12^         is the file to edit (typically a command file)
EDIT^13^
EDIT^14^ Enter EDIT with no file_name to edit the SQL buffer's contents with the
EDIT^15^ host operating system editor.
EDIT^16^
EDIT^17^ If you omit the file extension, the default command file extension
EDIT^18^ (normally SQL) is assumed.  See the SET command's SUFFIX variable for
EDIT^19^ information on changing the default extension.
EDIT^20^
EDIT^21^ If you specify a filename, SQL*Plus searches for the file in the current
EDIT^22^ working directory.  If SQL*Plus cannot find the file in the current
EDIT^23^ working directory, it creates a file with the specified name.
EDIT^24^
EDIT^25^ The user variable _EDITOR contains the name of the text editor invoked by
EDIT^26^ EDIT; to change the text editor, change the _EDITOR name.  See DEFINE for
EDIT^27^ information on changing the value of a user variable.  If _EDITOR is
EDIT^28^ undefined, EDIT tries to use the default host operating system editor.
EDIT^29^
EDIT^30^ EDIT alone places the SQL buffer's contents in a file by default named
EDIT^31^ AFIEDT.BUF in your current working directory, then invokes the text
EDIT^32^ editor on the contents of that file.  You can change the default file
EDIT^33^ name by using the SET EDITFILE command.  See the SET command's EDITFILE
EDIT^34^ variable for information on changing the default filename.
EDIT^35^
EDIT^36^ EDIT returns an error message if you don't specify a filename and the
EDIT^37^ buffer is empty.
EDIT^38^
EDIT^39^ To leave the editing session and return to SQL*Plus, terminate the editing
EDIT^40^ session in the way customary for the text editor.  When you exit your
EDIT^41^ editor, SQL*Plus loads the contents of the file into the buffer.
EDIT^42^
EDIT^43^
EDIT^44^
EDIT^45^ Example:  To edit the file REPORT with the extension SQL using your host
EDIT^46^           operating system text editor, enter:
EDIT^47^
EDIT^48^               SQL> EDIT REPORT
EDIT^49^
EDIT^50^
EDIT^51^
EDIT^52^ See also: append, change, del, define, input, list, save, spool, undefine,
EDIT^53^           commands.
EDIT^54^
EXECUTE^1^
EXECUTE^2^
EXECUTE^3^
EXECUTE^4^                                    EXECUTE
EXECUTE^5^
EXECUTE^6^ EXEC[UTE] statement
EXECUTE^7^
EXECUTE^8^ EXECUTE executes a single PL/SQL statement.  The EXECUTE command is
EXECUTE^9^ often useful when you want to execute a PL/SQL statement that
EXECUTE^10^  references a stored procedure.
EXECUTE^11^
EXECUTE^12^     statement
EXECUTE^13^         Represents a PL/SQL statement.
EXECUTE^14^
EXECUTE^15^
EXECUTE^16^
EXECUTE^17^ If your EXECUTE command cannot fit on one line because of the
EXECUTE^18^ length of the PL/SQL statement, use the SQL*Plus continuation
EXECUTE^19^ character (a hyphen).
EXECUTE^20^ The length of the command and the PL/SQL statement cannot exceed
EXECUTE^21^ the length defined by LINESIZE.
EXECUTE^22^
EXECUTE^23^
EXECUTE^24^
EXECUTE^25^ Examples:  The following EXECUTE command assigns a value to a bind
EXECUTE^26^ variable:
EXECUTE^27^
EXECUTE^28^      SQL> EXECUTE :n := 1
EXECUTE^29^
EXECUTE^30^ The following EXECUTE command runs a PL/SQL statement that
EXECUTE^31^ references a stored procedure:
EXECUTE^32^
EXECUTE^33^      SQL> EXECUTE -
EXECUTE^34^      :ID := EMP_MANAGEMENT.HIRE('BLAKE','MANAGER','KING',2990,'SALES')
EXECUTE^35^
EXIT^1^
EXIT^2^
EXIT^3^
EXIT^4^                                    EXIT
EXIT^5^
EXIT^6^ {EXIT|QUIT} [SUCCESS|FAILURE|WARNING|n|variable] [COMMIT|ROLLBACK]
EXIT^7^
EXIT^8^ EXIT terminates SQL*Plus, and returns control to the operating system.
EXIT^9^
EXIT^10^     {EXIT|QUIT}
EXIT^11^         can be used interchangeably.
EXIT^12^
EXIT^13^     SUCCESS
EXIT^14^         exits normally.
EXIT^15^
EXIT^16^     FAILURE
EXIT^17^         exits with a return code indicating failure.
EXIT^18^
EXIT^19^     WARNING
EXIT^20^         exits with a return code indicating warning.  EXIT with no clauses
EXIT^21^         exits with a value of SUCCESS.
EXIT^22^
EXIT^23^     n
EXIT^24^         is an integer you can specify as the return code.
EXIT^25^
EXIT^26^     variable
EXIT^27^         is a user-defined or system variable (not a bind variable), like
EXIT^28^         SQL.SQLCODE. EXIT variable exits with the value of variable as the
EXIT^29^         return code.
EXIT^30^
EXIT^31^     COMMIT
EXIT^32^         saves pending changes to the database before exiting.
EXIT^33^
EXIT^34^     ROLLBACK
EXIT^35^         executes a ROLLBACK statement and abandons pending changes to the
EXIT^36^         database before exiting.
EXIT^37^
EXIT^38^ EXIT with no clauses commits and exits with a value of SUCCESS.
EXIT^39^
EXIT^40^ EXIT enables you to specify an operating system return code so you can run
EXIT^41^ SQL*Plus command files in batch mode and detect an unexpected event.  The
EXIT^42^ manner of detection is operating-system-specific.  SUCCESS, WARNING, and
EXIT^43^ FAILURE represent operating system dependent values; on some systems,
EXIT^44^ WARNING and FAILURE are not distinguishable.  The range of operating system
EXIT^45^ return codes is also restricted on some operating systems.  This limits the
EXIT^46^ portability of EXIT n and EXIT variable between platforms.  For example, on
EXIT^47^ UNIX there is no meaningful way to return an Oracle error code.  Since
EXIT^48^ there is only one byte of storage for return codes, the range for return
EXIT^49^ codes is limited to zero to 255.
EXIT^50^
EXIT^51^ To exit conditionally, use WHENEVER SQLERROR or WHENEVER OSERROR.
EXIT^52^
EXIT^53^ If you make a syntax error in the EXIT options, or use a non-numeric
EXIT^54^ variable, SQL*Plus performs an EXIT FAILURE COMMIT.
EXIT^55^
EXIT^56^
EXIT^57^
EXIT^58^ Example:  The following commits all uncommitted transactions and returns
EXIT^59^           the error code of the last executed SQL command or PL/SQL block:
EXIT^60^
EXIT^61^               SQL> EXIT SQL.SQLCODE
EXIT^62^
EXIT^63^           The location of the return code depends on your system.  See
EXIT^64^           TTITLE for more information on SQL.SQLCODE.
EXIT^65^
EXIT^66^
EXIT^67^
EXIT^68^ See also: connect, disconnect, host, quit, save, spool, SQLPlus,
EXIT^69^           whenever sqlerror, commands.
EXIT^70^
FILES^1^
FILES^2^
FILES^3^
FILES^4^                                 Files
FILES^5^
FILES^6^ Files Used by SQL*Plus
FILES^7^
FILES^8^ Through SQL*Plus, you can store commands in a command file.  You can
FILES^9^ also create output files (spool files) to save your query results.
FILES^10^ Command files and spool files are operating system files and follow
FILES^11^ standard naming conventions.  Edit with your system's file commands.
FILES^12^
FILES^13^
FILES^14^
FILES^15^ Command Entry and Execution
FILES^16^
FILES^17^     Enter SQL, PL/SQL, and SQL*Plus commands at the command prompt: SQL>.
FILES^18^     SQL*Plus stores the SQL commands and PL/SQL blocks you enter in the
FILES^19^     SQL buffer.
FILES^20^
FILES^21^
FILES^22^
FILES^23^ See also: buffer, commands.
FILES^24^
GET^1^
GET^2^
GET^3^
GET^4^                                    GET
GET^5^
GET^6^ GET file_name[.ext] [LIS[T]|NOL[IST]]
GET^7^
GET^8^ GET loads a host operating system file into the SQL buffer.
GET^9^
GET^10^     file_name[.ext]
GET^11^         is the file to load (typically a command file).
GET^12^     LIS[T]
GET^13^         lists the contents of the file.  This is the default.
GET^14^
GET^15^     NOL[IST]
GET^16^         suppresses the listing of the file's contents.
GET^17^
GET^18^ If you omit .ext, SQL*Plus uses the default command-file extension
GET^19^ (normally SQL).
GET^20^
GET^21^
GET^22^
GET^23^ Example:  To load a file called YEARENDRPT with the extension SQL into
GET^24^           the buffer, type:
GET^25^
GET^26^               SQL> GET YEARENDRPT
GET^27^
GET^28^
GET^29^
GET^30^ See also: @, /, accept, input, list, run, save, set, spool,
GET^31^           commands.
GET^32^
HELP^1^
HELP^2^
HELP^3^
HELP^4^                                    HELP
HELP^5^
HELP^6^ HELP [topic] | help
HELP^7^
HELP^8^ HELP displays information on the commands and conventions of SQL*Plus,
HELP^9^ SQL, and PL/SQL.  Type "help", a space, all or part of any topic, and
HELP^10^ then press Enter.
HELP^11^
HELP^12^ Typing only part of a topic (for example, HELP SE) will cause all help
HELP^13^ topics that match the string (SE) to be displayed on your screen in
HELP^14^ alphabetical order (for example, HELP SE will retrieve help on the
HELP^15^ SELECT statement, the SET command, and the Set Operators--in that order).
HELP^16^
HELP^17^     ENTER THIS...     TO DISPLAY THIS...
HELP^18^     --------------------------------------------------------------
HELP^19^     help commands     a list of SQL*Plus, SQL, and PL/SQL commands
HELP^20^     help comm         information on commands, comments, and commit
HELP^21^     help help         this screen
HELP^22^
HOST^1^
HOST^2^
HOST^3^
HOST^4^                                    HOST
HOST^5^
HOST^6^ HO[ST] [ command ]
HOST^7^
HOST^8^ HOST executes a host operating system command without leaving SQL*Plus.
HOST^9^
HOST^10^     command
HOST^11^         is a host operating system command.  Enter HOST without command to
HOST^12^         display an operating system prompt.  You can then enter multiple
HOST^13^         operating system commands.  To return to SQL*Plus, type LOGOFF,
HOST^14^         EXIT, QUIT, or other command applicable to your operating system.
HOST^15^
HOST^16^ With some operating systems, you can use $ (VMS), ! (UNIX) or another
HOST^17^ character instead of HOST.  You may or may not have access to the HOST
HOST^18^ command, depending on your operating system, and privileges assigned by
HOST^19^ your system administrator.
HOST^20^
HOST^21^ SQL*Plus removes the SQLTERMINATOR (a semicolon by default) before the
HOST^22^ HOST command is issued.  A workaround for this is to add another
HOST^23^ SQLTERMINATOR.  See SET SQLTERMINATOR for more information on the
HOST^24^ SQLTERMINATOR.
HOST^25^
HOST^26^
HOST^27^
HOST^28^ Example:  To execute an operating system command, ls *.sql, enter:
HOST^29^
HOST^30^               SQL> HOST ls *.sql
HOST^31^
HOST^32^
HOST^33^
HOST^34^ See also: change, del, edit, exit, commands.
HOST^35^
INDEX^1^
INDEX^2^
INDEX^3^
INDEX^4^                                  Index
INDEX^5^
INDEX^6^
INDEX^7^
INDEX^8^Enter help, a space and part or all of the help topic you want:
INDEX^9^
INDEX^10^
INDEX^11^%FOUND Attribute                       INITCAP
INDEX^12^%ISOPEN Attribute                      INPUT
INDEX^13^%NOTFOUND Attribute                    INSERT
INDEX^14^%ROWCOUNT Attribute                    INSTR
INDEX^15^%ROWTYPE Attribute                     INSTRB
INDEX^16^%TYPE Attribute                        INTEGER
INDEX^17^/                                      INTERSECT OPERATOR
INDEX^18^@                                      ISO Standard Date Format Elements
INDEX^19^@@                                     LAST_DAY
INDEX^20^ABS                                    LEAST
INDEX^21^ACCEPT                                 LEAST_UB
INDEX^22^ACOS                                   LENGTH
INDEX^23^Actual vs Formal Parameters            LENGTHB
INDEX^24^ADD_MONTHS                             LEVEL
INDEX^25^ALTER CLUSTER                          Lexical Units
INDEX^26^ALTER DATABASE                         LIKE OPERATOR
INDEX^27^ALTER FUNCTION                         LIMITS
INDEX^28^ALTER INDEX                            LIST
INDEX^29^ALTER PACKAGE                          LIST OF EXPRESSIONS
INDEX^30^ALTER PROCEDURE                        LITERALS
INDEX^31^ALTER PROFILE                          LN
INDEX^32^ALTER RESOURCE COST                    LOCK TABLE
INDEX^33^ALTER ROLE                             LOG
INDEX^34^ALTER ROLLBACK SEGMENT                 LOGICAL OPERATORS
INDEX^35^ALTER SEQUENCE                         LONG DATATYPE
INDEX^36^ALTER SESSION                          Loop Label
INDEX^37^ALTER SNAPSHOT                         LOOP Statement
INDEX^38^ALTER SNAPSHOT LOG                     LOWER
INDEX^39^ALTER SYSTEM                           LPAD
INDEX^40^ALTER TABLE                            LTRIM
INDEX^41^ALTER TABLESPACE                       LUB
INDEX^42^ALTER TRIGGER                          MAX
INDEX^43^ALTER USER                             MENU
INDEX^44^ALTER VIEW                             MIN
INDEX^45^ANALYZE                                MINUS OPERATOR
INDEX^46^AND OPERATOR                           MLSLABEL DATATYPE
INDEX^47^ANSI, DB2, AND SQL/DS DATATYPES        MOD
INDEX^48^APPEND                                 MONTHS_BETWEEN
INDEX^49^ARCHIVE LOG                            Mutual Recursion
INDEX^50^ARITHMETIC OPERATORS                   Naming Conventions
INDEX^51^ASCII                                  NEW_TIME
INDEX^52^ASIN                                   NEXT_DAY
INDEX^53^Assignments                            NLSSORT
INDEX^54^ATAN                                   NLS_INITCAP
INDEX^55^ATAN2                                  NLS_LOWER
INDEX^56^AUDIT (Schema Objects)                 NLS_UPPER
INDEX^57^AUDIT (SQL Statements)                 NOAUDIT (Schema Objects)
INDEX^58^AVG                                    NOAUDIT (SQL Statements)
INDEX^59^Block Label                            NOT IN OPERATOR
INDEX^60^BNF SYNTAX                             NOT OPERATOR
INDEX^61^Boolean Expressions                    NULL Statement
INDEX^62^BREAK                                  NULLS
INDEX^63^BTITLE                                 NUMBER
INDEX^64^BUFFER                                 NUMBER DATATYPE
INDEX^65^Built-in Functions                     Number Format Elements
INDEX^66^Calling Packaged Subprograms           Number Format Models
INDEX^67^Calling Stored Functions from SQL      NUMBER FUNCTIONS
INDEX^68^Calling Stored Subprograms             NVL
INDEX^69^Capitalization of Date Format          OLD COMMANDS
INDEX^70^CEIL                                   OPEN Statement
INDEX^71^CHANGE                                 Opening a Cursor Variable
INDEX^72^Changing the Return Format             Operator Precedence
INDEX^73^CHAR DATATYPE                          OPERATORS
INDEX^74^CHARACTER DATATYPES                    OR OPERATOR
INDEX^75^Character Functions                    Other Functions
INDEX^76^Character Functions Returning          OTHER OPERATORS
INDEX^77^Character Functions Returning Number   Overloading
INDEX^78^CHARACTER OPERATORS                    OVERVIEW
INDEX^79^Character Set                          Package Body
INDEX^80^CHARTOROWID                            Package Specification
INDEX^81^CHR                                    Package STANDARD
INDEX^82^CLEAR                                  Packaged Cursors
INDEX^83^CLOSE Statement                        Packaged Subprograms
INDEX^84^Closing a Cursor Variable              Packages
INDEX^85^COLUMN                                 PARALLEL
INDEX^86^COMMANDS                               Parameter Aliasing
INDEX^87^COMMENT                                Parameter Default Values
INDEX^88^Comments                               Parameter Modes
INDEX^89^COMMENTS (SQL)                         PARAMETERS
INDEX^90^COMMIT                                 PAUSE
INDEX^91^COMPARISON OPERATORS                   PL/SQL Blocks
INDEX^92^COMPUTE                                PL/SQL Language
INDEX^93^CONCAT                                 PL/SQL Table Attributes
INDEX^94^Concatenation Operator                 PL/SQL Tables
INDEX^95^Condition                              PL/SQL Wrapper
INDEX^96^CONNECT                                Positional and Named Notation
INDEX^97^CONSTRAINT                             POWER
INDEX^98^Conversion Functions                   PRECEDENCE
INDEX^99^CONVERT                                Predefined Exceptions
INDEX^100^COPY                                   PRINT
INDEX^101^COS                                    Private vs Public Objects
INDEX^102^COSH                                   Procedures
INDEX^103^COUNT                                  Product-specific Packages
INDEX^104^CREATE CLUSTER                         PROMPT
INDEX^105^CREATE CONTROLFILE                     PSEUDOCOLUMNS
INDEX^106^CREATE DATABASE                        Punctuation and Text in Date Format
INDEX^107^CREATE DATABASE LINK                   QUIT
INDEX^108^CREATE FUNCTION                        RAISE Statement
INDEX^109^CREATE INDEX                           raise_application_error Procedure
INDEX^110^CREATE PACKAGE                         RAW AND LONG RAW DATATYPES
INDEX^111^CREATE PACKAGE BODY                    RAWTOHEX
INDEX^112^CREATE PROCEDURE                       Records
INDEX^113^CREATE PROFILE                         RECOVER
INDEX^114^CREATE ROLE                            Recursion
INDEX^115^CREATE ROLLBACK SEGMENT                Recursion vs Iteration
INDEX^116^CREATE SCHEMA                          Referencing Package Contents
INDEX^117^CREATE SEQUENCE                        Referencing PL/SQL Tables
INDEX^118^CREATE SNAPSHOT                        Referencing Records
INDEX^119^CREATE SNAPSHOT LOG                    REMARK
INDEX^120^CREATE SYNONYM                         RENAME
INDEX^121^CREATE TABLE                           REPFOOTER
INDEX^122^CREATE TABLESPACE                      REPHEADER
INDEX^123^CREATE TRIGGER                         REPLACE
INDEX^124^CREATE USER                            Reraising an Exception
INDEX^125^CREATE VIEW                            Reserved Words
INDEX^126^CURRVAL AND NEXTVAL                    RESERVED WORDS (SQL)
INDEX^127^Cursor Attributes                      Restrictions on Cursor Variables
INDEX^128^Cursor FOR Loop                        RETURN Statement
INDEX^129^Cursor Variables                       REVOKE (Object Privileges)
INDEX^130^Cursors                                REVOKE (System Privileges and Roles)
INDEX^131^DATA CONVERSION                        ROLLBACK
INDEX^132^DATATYPE COMPARISON RULES              ROUND (DATE)
INDEX^133^Datatype Conversion                    ROUND (NUMBER)
INDEX^134^Datatypes                              ROUND and TRUNC
INDEX^135^DATATYPES (ORACLE)                     ROWID
INDEX^136^DATE DATATYPE                          ROWID DATATYPE
INDEX^137^Date Format Element Suffixes           ROWIDTOCHAR
INDEX^138^Date Format Elements                   ROWNUM
INDEX^139^Date Format Elements and National      RPAD
INDEX^140^Date Format Models                     RR Date Format Element
INDEX^141^DATE FUNCTIONS                         RTRIM
INDEX^142^DBA                                    RUN
INDEX^143^DDL and Dynamic SQL                    RUNFORM
INDEX^144^DEALLOCATE                             SAVE
INDEX^145^Declaring Cursor Variables             SAVEPOINT
INDEX^146^Declaring PL/SQL Tables                Scope and Visibility
INDEX^147^Declaring Records                      SELECT
INDEX^148^Decoded Expression                     SET
INDEX^149^DEFAULT DATE FORMAT                    SET OPERATORS
INDEX^150^DEFINE                                 SET ROLE
INDEX^151^Defining RECORD Types                  SET TRANSACTION
INDEX^152^Defining REF CURSOR Types              SHOW
INDEX^153^Defining TABLE Types                   SIGN
INDEX^154^DEL                                    SIN
INDEX^155^DELETE                                 SINGLE ROW FUNCTIONS
INDEX^156^Delimiters                             SINH
INDEX^157^DESCRIBE                               SOUNDEX
INDEX^158^DISABLE                                SPOOL
INDEX^159^DISCONNECT                             SQL FUNCTIONS
INDEX^160^DROP                                   SQL Support
INDEX^161^DROP CLUSTER                           SQL92 Conformance
INDEX^162^DROP DATABASE LINK                     SQLCODE and SQLERRM Functions
INDEX^163^DROP FUNCTION                          SQLPLUS
INDEX^164^DROP INDEX                             SQRT
INDEX^165^DROP PACKAGE                           START
INDEX^166^DROP PROCEDURE                         STDDEV
INDEX^167^DROP PROFILE                           STORAGE
INDEX^168^DROP ROLE                              STORE
INDEX^169^DROP ROLLBACK SEGMENT                  Stored Subprograms
INDEX^170^DROP SEQUENCE                          Structure Theorem
INDEX^171^DROP SNAPSHOT                          Subprograms
INDEX^172^DROP SNAPSHOT LOG                      SUBSTITUTION
INDEX^173^DROP SYNONYM                           SUBSTR
INDEX^174^DROP TABLE                             SUBSTRB
INDEX^175^DROP TABLESPACE                        Subtypes
INDEX^176^DROP TRIGGER                           SUM
INDEX^177^DROP USER                              Supplying the Correct Format
INDEX^178^DROP VIEW                              Syntax Notation
INDEX^179^DUMP                                   SYSDATE
INDEX^180^EDIT                                   TAN
INDEX^181^ENABLE                                 TANH
INDEX^182^Ending Transactions                    TEXT
INDEX^183^Exception Handlers                     TIMING
INDEX^184^Exception Propagation                  TO_CHAR (date conversion)
INDEX^185^Exceptions                             TO_CHAR (label conversion)
INDEX^186^EXCEPTION_INIT Pragma                  TO_CHAR (number conversion)
INDEX^187^EXECUTE                                TO_DATE
INDEX^188^EXIT                                   TO_LABEL
INDEX^189^EXIT Statement                         TO_MULTI_BYTE
INDEX^190^EXP                                    TO_NUMBER
INDEX^191^EXPLAIN PLAN                           TO_SINGLE_BYTE
INDEX^192^Expr                                   Transaction Processing
INDEX^193^Expressions                            TRANSLATE
INDEX^194^FETCH Statement                        TRUNC (DATE)
INDEX^195^Fetching from a Cursor Variable        TRUNC (NUMBER)
INDEX^196^FILES                                  TRUNCATE
INDEX^197^Filespec                               TTITLE
INDEX^198^FLOOR                                  UID
INDEX^199^FM                                     UNDEFINE
INDEX^200^FOR UPDATE Clause                      Unhandled Exceptions
INDEX^201^Format Model Modifiers                 UNION ALL OPERATOR
INDEX^202^FORMAT MODELS                          UNION OPERATOR
INDEX^203^Forward Declarations                   UPDATE
INDEX^204^Functions                              UPPER
INDEX^205^FX                                     USER
INDEX^206^GET                                    USERENV
INDEX^207^GLB                                    Using COMMIT
INDEX^208^GOTO Statement                         Using LOCK TABLE
INDEX^209^GRANT (Object Privileges)              Using PL/SQL Tables
INDEX^210^GRANT (System Privileges and Roles)    Using ROLLBACK
INDEX^211^GREATEST                               Using SAVEPOINT
INDEX^212^GREATEST_LB                            Using SET TRANSACTION
INDEX^213^GROUP FUNCTIONS                        VARCHAR DATATYPE
INDEX^214^Handling Nulls                         VARCHAR2 DATATYPE
INDEX^215^HELP                                   VARIABLE
INDEX^216^HEXTORAW                               VARIABLES
INDEX^217^HOST                                   Variables and Constants
INDEX^218^Identifiers                            VARIANCE
INDEX^219^IF Statement                           VSIZE
INDEX^220^Implicit Rollbacks                     WHENEVER OSERROR
INDEX^221^                                       WHENEVER SQLERROR
INDEX^222^
INDEX^223^
INDEX^224^
INPUT^1^
INPUT^2^
INPUT^3^
INPUT^4^                                  INPUT
INPUT^5^
INPUT^6^ I[NPUT] [ text ]
INPUT^7^
INPUT^8^ INPUT adds one or more lines of text after the current line in the buffer.
INPUT^9^
INPUT^10^     text
INPUT^11^         is the text to add.  To add one line, enter INPUT, a space, and
INPUT^12^         the text. (To begin the line with one or more spaces, enter two
INPUT^13^         or more spaces after INPUT.)  To add several lines, enter INPUT
INPUT^14^         without text; INPUT prompts you for each line.  To leave INPUT,
INPUT^15^         enter an empty line.
INPUT^16^
INPUT^17^ At the command prompt, if you enter a line number larger than the number
INPUT^18^ of lines in the buffer, and follow the number with text, SQL*Plus adds
INPUT^19^ the text in a new line at the end of the buffer.  If you specify zero (0)
INPUT^20^ for the line number and follow the zero with text, SQL*Plus inserts the
INPUT^21^ line at the beginning of the buffer; that line becomes line 1.
INPUT^22^
INPUT^23^
INPUT^24^
INPUT^25^ Examples: The SQL buffer contains the following command:
INPUT^26^
INPUT^27^               1  SELECT ENAME, DEPTNO, SAL, COMM
INPUT^28^               2  FROM EMP
INPUT^29^
INPUT^30^           To add an ORDER BY clause to the query, enter:
INPUT^31^
INPUT^32^               SQL> LIST 2
INPUT^33^                 2* FROM EMP
INPUT^34^
INPUT^35^               SQL> INPUT ORDER BY ENAME
INPUT^36^
INPUT^37^           LIST 2 ensures that line 2 is the current line.  INPUT adds a
INPUT^38^           line with the ORDER BY clause after the current line. The SQL
INPUT^39^           buffer now contains:
INPUT^40^
INPUT^41^               1  SELECT ENAME, DEPTNO, SAL, COMM
INPUT^42^               2  FROM EMP
INPUT^43^               3* ORDER BY ENAME
INPUT^44^
INPUT^45^           To add a two-line WHERE clause, enter:
INPUT^46^
INPUT^47^               SQL> LIST 2
INPUT^48^                 2* FROM EMP
INPUT^49^               SQL> INPUT
INPUT^50^                 3  WHERE JOB = 'SALESMAN'
INPUT^51^                 4  AND COMM  500
INPUT^52^                 5
INPUT^53^
INPUT^54^           INPUT continues to prompt you for new lines until you enter an
INPUT^55^           empty line.  The SQL buffer now contains the following lines:
INPUT^56^
INPUT^57^               1  SELECT ENAME, DEPTNO, SAL, COMM
INPUT^58^               2  FROM EMP
INPUT^59^               3  WHERE JOB = 'SALESMAN'
INPUT^60^               4  AND COMM 500
INPUT^61^               5  ORDER BY ENAME
INPUT^62^
INPUT^63^
INPUT^64^
INPUT^65^ See also: change, del, edit, list, save, spool, get, input,
INPUT^66^           set, prompt, commands.
INPUT^67^
LIMITS^1^
LIMITS^2^
LIMITS^3^
LIMITS^4^                                Limits
LIMITS^5^
LIMITS^6^ Item                               SQL*Plus Limit
LIMITS^7^ --------------------------------------------------------
LIMITS^8^ filename length                    system dependent
LIMITS^9^ username length                    30  characters
LIMITS^10^ user variable name length          30  characters
LIMITS^11^ user variable value length         240 characters
LIMITS^12^ command-line length                2,500 characters
LIMITS^13^ length of LONG value in SQL*Plus   LINESIZE value
LIMITS^14^ LINESIZE                           system dependent
LIMITS^15^ LONGCHUNKSIZE value (Oracle7)      MAXDATA value
LIMITS^16^ MAXDATA value                      system dependent
LIMITS^17^ output line size                   system dependent
LIMITS^18^ characters in COMPUTE label        500 characters
LIMITS^19^ line after variable substitution   3,000 characters (internal only)
LIMITS^20^ number of lines per command        500 (assuming 80 characters per line)
LIMITS^21^ maximum PAGESIZE                   50,000 lines
LIMITS^22^ total row width                    60,000 characters in VMS; else, 32,767
LIMITS^23^ maximum ARRAYSIZE                  5000 rows
LIMITS^24^ maximum nested command files       20 for VMS, CMS, Unix; otherwise, 5
LIMITS^25^ maximum page numbers               99,999 pages
LIMITS^26^ maximum PL/SQL error message size  2K (Oracle7) 512 Bytes (Oracle Version
LIMITS^27^6)
LIMITS^28^ maximum ACCEPT character string    240 bytes
LIMITS^29^
LIMITS^30^
LIMITS^31^
LIMITS^32^ See also:  commands.
LIMITS^33^
LIST^1^
LIST^2^
LIST^3^
LIST^4^                                    LIST
LIST^5^
LIST^6^ L[IST] [n|n m|n  *|n LAST|*|* n|* LAST|LAST]
LIST^7^
LIST^8^
LIST^9^
LIST^10^ LIST displays one or more lines of the SQL buffer. Enter LIST by
LIST^11^ itself to list all lines.
LIST^12^
LIST^13^     Clause    Lists
LIST^14^     -----------------------------------------
LIST^15^     n         line n.
LIST^16^     n m       lines n through m.
LIST^17^     n *       line n through the current line.
LIST^18^     n LAST    line n through the last line.
LIST^19^     *         the current line.
LIST^20^     * n       the current line through line n.
LIST^21^     * LAST    the current line through the last line.
LIST^22^     LAST      the last line.
LIST^23^
LIST^24^ The last line listed is the new current line (with an asterisk).
LIST^25^
LIST^26^
LIST^27^
LIST^28^ Example:  To list the contents of the buffer, enter:
LIST^29^
LIST^30^               SQL> LIST
LIST^31^
LIST^32^           You will see a listing of all lines in the buffer, like this:
LIST^33^
LIST^34^                 1  SELECT ENAME, DEPTNO, JOB
LIST^35^                 2  FROM EMP
LIST^36^                 3  WHERE JOB = 'CLERK'
LIST^37^                 4* ORDER BY DEPTNO
LIST^38^
LIST^39^           The asterisk shows line 4 to be the current line.  To list the
LIST^40^           second line only, enter:
LIST^41^
LIST^42^               SQL> LIST 2
LIST^43^                 2* FROM EMP
LIST^44^
LIST^45^           To list the current line (now line 2) to the last line, enter:
LIST^46^
LIST^47^               SQL> LIST * LAST
LIST^48^                 2  FROM EMP
LIST^49^                 3  WHERE JOB = 'CLERK'
LIST^50^                 4* ORDER BY DEPTNO
LIST^51^
LIST^52^
LIST^53^
LIST^54^ See also: change, del, edit, get, input, save, spool, set,
LIST^55^           commands.
LIST^56^
MENU^1^
MENU^2^
MENU^3^
MENU^4^                                     Menu
MENU^5^
MENU^6^ Enter TOPIC or INDEX for a list of help topics.
MENU^7^
OLD COMMANDS^1^
OLD COMMANDS^2^
OLD COMMANDS^3^
OLD COMMANDS^4^                                Old Commands
OLD COMMANDS^5^
OLD COMMANDS^6^ These old SQL*Plus commands still work, although SQL*Plus provides newer
OLD COMMANDS^7^ commands with better functionality.
OLD COMMANDS^8^
OLD COMMANDS^9^ BTI[TLE] text
OLD COMMANDS^10^     BTITLE displays a title at the bottom of each report page.  The old
OLD COMMANDS^11^     form of BTITLE offers more limited formatting than the new form, but
OLD COMMANDS^12^     provides compatibility with UFI (a predecessor of SQL*Plus). The old
OLD COMMANDS^13^     form defines the bottom title as an empty line followed by a line with
OLD COMMANDS^14^     centered text.  See OLD TTITLE for details.
OLD COMMANDS^15^
OLD COMMANDS^16^ COL[UMN] {column|expr} DEF[AULT]               Replaced by: COLUMN CLEAR
OLD COMMANDS^17^      COLUMN DEFAULT resets the display attributes for a given column to
OLD COMMANDS^18^      default values.  It has the same effect as COLUMN CLEAR.
OLD COMMANDS^19^
OLD COMMANDS^20^ DOC[UMENT]                                           Replaced by: REMARK
OLD COMMANDS^21^     DOCUMENT begins a block of documentation in a command file.
OLD COMMANDS^22^     When you type DOCUMENT and press RETURN, SQL*Plus displays DOC> in
OLD COMMANDS^23^     place of SQL> until you end the documentation.  Enter # (pound) on a
OLD COMMANDS^24^     line by itself to end the documentation.  If DOCUMENT is OFF, SQL*Plus
OLD COMMANDS^25^     reads further lines of documentation as commands.  See SET DOCUMENT.
OLD COMMANDS^26^
OLD COMMANDS^27^ NEWPAGE [1|n]                         Replaced by: SET command's NEWPAGE
OLD COMMANDS^28^     NEWPAGE advances spooled output n lines beyond the beginning of the
OLD COMMANDS^29^     next page.
OLD COMMANDS^30^
OLD COMMANDS^31^ SET BUF[FER] {buffer|SQL}
OLD COMMANDS^32^     SET BUFFER makes the specified buffer the current buffer.  Initially,
OLD COMMANDS^33^     the SQL buffer is the current buffer.  SQL*Plus doesn't use multiple
OLD COMMANDS^34^     buffers; the SQL buffer should meet your needs.  If the buffer name
OLD COMMANDS^35^     you enter does not already exist, SET BUFFER creates and names the
OLD COMMANDS^36^     buffer.  The buffer is erased when you exit SQL*Plus.
OLD COMMANDS^37^
OLD COMMANDS^38^     Running a query automatically makes the SQL buffer the current one.
OLD COMMANDS^39^     GET and SAVE copy text from one buffer to another.  CLEAR BUFFER
OLD COMMANDS^40^     erases text from the current buffer.  CLEAR SQL erases text from the
OLD COMMANDS^41^     SQL buffer when you're using another one.
OLD COMMANDS^42^
OLD COMMANDS^43^ SET DOC[UMENT] {OFF|ON}
OLD COMMANDS^44^     SET DOCUMENT ON enables the DOCUMENT command, and SET DOCUMENT OFF
OLD COMMANDS^45^     disables it.  If you disable DOCUMENT, SQL*Plus reads any lines after
OLD COMMANDS^46^     a DOCUMENT command as commands.  See DOCUMENT for details.
OLD COMMANDS^47^
OLD COMMANDS^48^ SET SCAN {OFF|ON}                                Replaced by: SET DEFINE
OLD COMMANDS^49^     controls scanning for substitution variables and parameters.
OLD COMMANDS^50^     OFF suppresses their processing; ON allows normal processing.  ON
OLD COMMANDS^51^     functions in the same manner as SET DEFINE ON.
OLD COMMANDS^52^
OLD COMMANDS^53^ SET SPA[CE] {1|n}                                Replaced by: SET COLSEP
OLD COMMANDS^54^     sets the number of spaces between output columns (Maximum = 10).
OLD COMMANDS^55^     This command is obsoleted by SET COLSEP, but you can still use it
OLD COMMANDS^56^     for backward compatibility.
OLD COMMANDS^57^
OLD COMMANDS^58^ SET TRU[NCATE] {OFF|ON}
OLD COMMANDS^59^     SET TRUNCATE controls whether SQL*Plus truncates or wraps a data item
OLD COMMANDS^60^     that is too long for the current line width.  ON and SET WRAP OFF work
OLD COMMANDS^61^     the same way.  You may prefer to use WRAP, because the SHOW command
OLD COMMANDS^62^     recognizes WRAP and does not recognize TRUNCATE.
OLD COMMANDS^63^
OLD COMMANDS^64^ TTI[TLE] text
OLD COMMANDS^65^     TTITLE displays a title at the top of each report page.  The old form
OLD COMMANDS^66^     of TTITLE has more limited formatting than the new form, but is
OLD COMMANDS^67^     compatible with UFI, a SQL*Plus predecessor.  The old form defines the
OLD COMMANDS^68^     top title as a line with the date left-aligned and the page number
OLD COMMANDS^69^     right-aligned, a line with centered text, and then a blank line.  Text
OLD COMMANDS^70^     is the title displayed.
OLD COMMANDS^71^
OLD COMMANDS^72^     SQL*Plus centers text based on the SET LINESIZE setting.  A separator
OLD COMMANDS^73^     character (|) begins a new line; two line separator characters (||)
OLD COMMANDS^74^     insert a blank line.  Use SET HEADSEP to change the line separator
OLD COMMANDS^75^     character.  Control the formatting of page numbers in the old forms of
OLD COMMANDS^76^     TTITLE and BTITLE by defining the variable "_page".  The default _page
OLD COMMANDS^77^     value is the formatting string, "page &P4".  To alter it, DEFINE _page
OLD COMMANDS^78^     with a new string:
OLD COMMANDS^79^
OLD COMMANDS^80^           SQL> SET ESCAPE /SQL> DEFINE _page = 'Page /&P2'
OLD COMMANDS^81^
OLD COMMANDS^82^     The string prints "Page" and formats the page number to a width of 2.
OLD COMMANDS^83^     You can substitute any text for "Page" and any number for the width.
OLD COMMANDS^84^     You must set Escape so SQL*Plus doesn't read the ampersand (&) as a
OLD COMMANDS^85^     substitution variable.  The SET command's ESCAPE variable sets the
OLD COMMANDS^86^     escape character.
OLD COMMANDS^87^
OLD COMMANDS^88^     SQL*Plus interprets TTITLE in the old form if a valid new-form clause
OLD COMMANDS^89^     does not immediately follow the command name.
OLD COMMANDS^90^
OLD COMMANDS^91^     If you want to use CENTER with TTITLE and put more than one word on
OLD COMMANDS^92^     a line, you should use the new form of TTITLE.
OLD COMMANDS^93^
OLD COMMANDS^94^
OLD COMMANDS^95^
OLD COMMANDS^96^     Example:  To use the old TTITLE to set a top title with a left-aligned
OLD COMMANDS^97^               date and a right-aligned page number on one line, MARKETING
OLD COMMANDS^98^               on the next line, and PERSONNEL REPORT on the third, enter:
OLD COMMANDS^99^
OLD COMMANDS^100^               SQL> TTITLE 'MARKETING | PERSONNEL REPORT'
OLD COMMANDS^101^
OLD COMMANDS^102^
OLD COMMANDS^103^
OLD COMMANDS^104^     See also:  commands.
OLD COMMANDS^105^
OVERVIEW^1^
OVERVIEW^2^
OVERVIEW^3^
OVERVIEW^4^                             Overview (SQL*Plus)
OVERVIEW^5^
OVERVIEW^6^ You can use SQL*Plus with SQL and its procedural extension, PL/SQL.  SQL
OVERVIEW^7^ enables you to store and retrieve data in the Oracle relational database
OVERVIEW^8^ management system.  SQL*Plus enables you to manipulate SQL commands and
OVERVIEW^9^ PL/SQL blocks, and to perform many other tasks.  With SQL*Plus, you can:
OVERVIEW^10^
OVERVIEW^11^  -  enter, edit, store, retrieve, and run SQL commands and PL/SQL blocks
OVERVIEW^12^  -  format, perform calculations on, store, and print query results
OVERVIEW^13^  -  list column definitions for any table
OVERVIEW^14^  -  access and copy data between SQL databases
OVERVIEW^15^  -  send messages to and accept responses from an end user
OVERVIEW^16^
OVERVIEW^17^
OVERVIEW^18^
OVERVIEW^19^ Basic SQL*Plus Concepts
OVERVIEW^20^
OVERVIEW^21^     Command         An instruction you give SQL*Plus or the Oracle Server.
OVERVIEW^22^
OVERVIEW^23^     Block           A group of SQL and PL/SQL commands related to one
OVERVIEW^24^                     another through procedural logic.
OVERVIEW^25^
OVERVIEW^26^     Table           The basic unit of storage in the Oracle Server.
OVERVIEW^27^
OVERVIEW^28^     Query           A SELECT statement that retrieves information from
OVERVIEW^29^                     one or more tables.
OVERVIEW^30^
OVERVIEW^31^     Query results   The data retrieved by a query.
OVERVIEW^32^
OVERVIEW^33^     Report          Query results formatted by you with SQL*Plus commands.
OVERVIEW^34^
OVERVIEW^35^
OVERVIEW^36^
OVERVIEW^37^ Entering and Executing Commands
OVERVIEW^38^
OVERVIEW^39^ Your computer's cursor (usually an underline, rectangular block, or slash)
OVERVIEW^40^ appears after the command prompt.  The cursor is where the next character
OVERVIEW^41^ you type appears on the screen.  You can enter commands in uppercase or
OVERVIEW^42^ lowercase in SQL*Plus.  As you type SQL*Plus, SQL, and PL/SQL commands,
OVERVIEW^43^ use at least one space, tab, or RETURN between words.  You can use extra
OVERVIEW^44^ spaces, tabs, and RETURNs between words to make the code easier to read.
OVERVIEW^45^
OVERVIEW^46^ You can enter three kinds of commands at the command prompt:
OVERVIEW^47^
OVERVIEW^48^      -  SQL commands, for working with information in the database
OVERVIEW^49^      -  PL/SQL blocks, also for working with information in the database
OVERVIEW^50^      -  SQL*Plus commands for formatting query results, setting options,
OVERVIEW^51^         and editing and storing SQL and PL/SQL commands
OVERVIEW^52^
OVERVIEW^53^ End a SQL command with a semicolon (;) at the end of a line
OVERVIEW^54^                        a slash (/) on a line by itself
OVERVIEW^55^                        a blank line
OVERVIEW^56^
OVERVIEW^57^ A semicolon (;) tells SQL*Plus to run the command.  Type ; at the end of
OVERVIEW^58^ the last line and press RETURN to execute it.  If you press RETURN without
OVERVIEW^59^ a semicolon, SQL*Plus displays the next line number.  Type ; and press
OVERVIEW^60^ RETURN again to run the command.  A slash (/) on a line by itself also
OVERVIEW^61^ tells SQL*Plus to run the command.  Press RETURN after the last command
OVERVIEW^62^ line.  At the next line number, type / and press RETURN again.
OVERVIEW^63^
OVERVIEW^64^
OVERVIEW^65^
OVERVIEW^66^ Running PL/SQL Blocks
OVERVIEW^67^
OVERVIEW^68^ PL/SQL blocks begin with DECLARE, BEGIN, or a block name.  SQL*Plus treats
OVERVIEW^69^ PL/SQL blocks the same as SQL commands, except that a semicolon (;) or a
OVERVIEW^70^ blank line does not terminate and execute a block; terminate PL/SQL blocks
OVERVIEW^71^ by entering a period (.) by itself on a new line.  To execute the block
OVERVIEW^72^ currently in the SQL buffer, use the RUN or slash (/) command.
OVERVIEW^73^
OVERVIEW^74^
OVERVIEW^75^
OVERVIEW^76^ Example: You might enter and run the following PL/SQL block:
OVERVIEW^77^
OVERVIEW^78^     SQL> DECLARE
OVERVIEW^79^        2     x   NUMBER := 100;
OVERVIEW^80^        3  BEGIN
OVERVIEW^81^        4     FOR i IN 1..10 LOOP
OVERVIEW^82^        5        IF MOD(i, 2) = 0 THEN    --i is even
OVERVIEW^83^        6          INSERT INTO temp VALUES (i, x, 'i is even');
OVERVIEW^84^        7          ELSE
OVERVIEW^85^        8             INSERT INTO temp VALUES (i, x, 'i is odd');
OVERVIEW^86^        9          END IF;
OVERVIEW^87^       10          x := x + 100;
OVERVIEW^88^       11     END LOOP;
OVERVIEW^89^       12  END;
OVERVIEW^90^       13  .
OVERVIEW^91^
OVERVIEW^92^     SQL> PL/SQL procedure successfully completed.
OVERVIEW^93^
OVERVIEW^94^           When you run a block, SQL commands within the block may behave
OVERVIEW^95^           somewhat differently than they would outside of the block.
OVERVIEW^96^
OVERVIEW^97^
OVERVIEW^98^
OVERVIEW^99^ Running SQL*Plus Commands
OVERVIEW^100^
OVERVIEW^101^ Use SQL*Plus commands to manipulate SQL commands and PL/SQL blocks, and
OVERVIEW^102^ format and print query results.  To speed up command entry, you can
OVERVIEW^103^ abbreviate many SQL*Plus commands to one or a few letters.
OVERVIEW^104^
OVERVIEW^105^
OVERVIEW^106^
OVERVIEW^107^ Running Host Operating System Commands
OVERVIEW^108^
OVERVIEW^109^ You can execute a host operating system command from the SQL*Plus command
OVERVIEW^110^ prompt, useful when you want to perform a task like listing host operating
OVERVIEW^111^ system files.  To run a host operating system command, enter HOST followed
OVERVIEW^112^ by the host operating system command.  For example, this SQL*Plus command
OVERVIEW^113^ runs a host command, DIRECTORY *.SQL:
OVERVIEW^114^
OVERVIEW^115^               SQL> HOST DIRECTORY *.SQL
OVERVIEW^116^
OVERVIEW^117^
OVERVIEW^118^
OVERVIEW^119^ See also:  commands.
OVERVIEW^120^
PARAMETERS^1^
PARAMETERS^2^
PARAMETERS^3^
PARAMETERS^4^                               Parameters
PARAMETERS^5^
PARAMETERS^6^ A parameter is a substitution variable with & (ampersand) followed by a
PARAMETERS^7^ number (for example, "&1").  Parameters are used only in command files.
PARAMETERS^8^ You pass values to the parameters as arguments to the START command.  If a
PARAMETERS^9^ parameter represents a char or date value, enclose the parameter in
PARAMETERS^10^ apostrophes as if it were a constant:
PARAMETERS^11^
PARAMETERS^12^               SELECT * FROM EMP
PARAMETERS^13^               WHERE JOB='&1'  /* char value */
PARAMETERS^14^               AND SAL=&2;  /* number value */
PARAMETERS^15^
PARAMETERS^16^ Then, when you run the command file, enter parameter values as arguments
PARAMETERS^17^ of the START command.   The first argument after the filename represents
PARAMETERS^18^ the first parameter (&1), the second represents the second parameter (&2),
PARAMETERS^19^ and so on.  In the following command, SQL*Plus substitutes CLERK for &1
PARAMETERS^20^ and 7900 for &2:
PARAMETERS^21^
PARAMETERS^22^               SQL> START MYFILE CLERK 7900
PARAMETERS^23^
PARAMETERS^24^ When you use arguments with the START command, SQL*Plus DEFINEs each
PARAMETERS^25^ parameter in the command file with the value of the appropriate argument.
PARAMETERS^26^
PARAMETERS^27^
PARAMETERS^28^
PARAMETERS^29^ See also: substitution, commands.
PARAMETERS^30^
PAUSE^1^
PAUSE^2^
PAUSE^3^
PAUSE^4^                                   PAUSE
PAUSE^5^
PAUSE^6^ PAU[SE] [text]
PAUSE^7^
PAUSE^8^ PAUSE displays an empty line followed by a line with text, then waits for
PAUSE^9^ the user to press RETURN.  Or it displays two empty lines, and waits for
PAUSE^10^ the user's response.
PAUSE^11^
PAUSE^12^     text
PAUSE^13^         is the text you wish to display.  Enter PAUSE with no text to
PAUSE^14^         display two empty lines.
PAUSE^15^
PAUSE^16^ Since PAUSE waits for the user's response, it's wise to include a message
PAUSE^17^ to press RETURN.  PAUSE reads input from the terminal (if available) even
PAUSE^18^ when you specify a file as the source of the input.  The SET command's
PAUSE^19^ PAUSE clause controls pausing between pages of a report.
PAUSE^20^
PAUSE^21^
PAUSE^22^
PAUSE^23^ Example:  To display "Adjust paper and press RETURN to continue." then
PAUSE^24^           wait for the user to press RETURN, include the following PAUSE
PAUSE^25^           command in a command file:
PAUSE^26^
PAUSE^27^                 SET PAUSE ON
PAUSE^28^                 PAUSE Adjust paper and press RETURN to continue.
PAUSE^29^                 SELECT ...
PAUSE^30^
PAUSE^31^
PAUSE^32^
PAUSE^33^ See also: /, @, get, prompt, run, set (pause), start, commands.
PAUSE^34^
PRINT^1^
PRINT^2^
PRINT^3^
PRINT^4^                                   PRINT
PRINT^5^
PRINT^6^ PRI[NT] [variable ...]
PRINT^7^
PRINT^8^ PRINT displays the current values of bind variables.
PRINT^9^
PRINT^10^     variable ...
PRINT^11^         Represents the names of the bind variables you wish to
PRINT^12^         display.
PRINT^13^
PRINT^14^ Enter PRINT with no variables to print all bind variables.
PRINT^15^
PRINT^16^ Bind variables are created using the VARIABLE command.  You can
PRINT^17^ control the formatting of the PRINT output just as you would
PRINT^18^ query output.
PRINT^19^
PRINT^20^ To automatically display bind variables, use the AUTOPRINT clause
PRINT^21^ of the SET command.
PRINT^22^
PRINT^23^
PRINT^24^
PRINT^25^ Example:  The following is an example of a PRINT command:
PRINT^26^
PRINT^27^                     SQL> VARIABLE id NUMBER
PRINT^28^                     SQL> BEGIN
PRINT^29^                        1    :id := 1;
PRINT^30^                       2  END;
PRINT^31^                     SQL> PRINT id
PRINT^32^                                ID
PRINT^33^                      ------------
PRINT^34^                                1
PRINT^35^
PRINT^36^
PRINT^37^
PRINT^38^ See also: variable, set.
PRINT^39^
PROMPT^1^
PROMPT^2^
PROMPT^3^
PROMPT^4^                                   PROMPT
PROMPT^5^
PROMPT^6^ PROMPT [text]
PROMPT^7^
PROMPT^8^ PROMPT sends the specified message or a blank line to the user's screen.
PROMPT^9^
PROMPT^10^     text
PROMPT^11^         is the text of the message you wish to display. If you omit text,
PROMPT^12^         PROMPT displays a blank line on the user's screen.
PROMPT^13^
PROMPT^14^ Use this command in command files to give information to the user.
PROMPT^15^
PROMPT^16^
PROMPT^17^
PROMPT^18^ Example:  Here is PROMPT used with ACCEPT in command file ASKFORDEPT:
PROMPT^19^
PROMPT^20^               SQL> GET ASKFORDEPT
PROMPT^21^                 1  PROMPT
PROMPT^22^                 2  PROMPT Please enter a department
PROMPT^23^                 3  PROMPT For example: 10, 20, 30, 40
PROMPT^24^                 4  ACCEPT NEWDEPT NUMBER PROMPT 'DEPT:>'
PROMPT^25^                 5* SELECT DNAME FROM DEPT WHERE DEPTNO = &NEWDEPT
PROMPT^26^
PROMPT^27^           If you run the file using @ASKFORDEPT, SQL*Plus displays:
PROMPT^28^
PROMPT^29^               Please enter a department
PROMPT^30^               For example: 10, 20, 30, 40
PROMPT^31^               DEPT:>
PROMPT^32^
PROMPT^33^           You can enter a department number at the DEPT:> prompt.
PROMPT^34^           By default, SQL*Plus lists the line containing &NEWDEPT before
PROMPT^35^           and after substitution, and then displays the department name
PROMPT^36^           matching the number entered at the DEPT:> prompt.
PROMPT^37^
PROMPT^38^
PROMPT^39^
PROMPT^40^ See also: /, @, accept, get, input, pause, run, start, commands.
PROMPT^41^
QUIT^1^
QUIT^2^
QUIT^3^
QUIT^4^                                   QUIT
QUIT^5^
QUIT^6^ {QUIT|EXIT} [SUCCESS|FAILURE|WARNING|n|variable] [COMMIT|ROLLBACK]
QUIT^7^
QUIT^8^ QUIT commits all pending database changes, leaves SQL*Plus, and returns
QUIT^9^ control to the operating system.
QUIT^10^
QUIT^11^     {QUIT|EXIT}
QUIT^12^         can be used interchangeably.
QUIT^13^
QUIT^14^     SUCCESS
QUIT^15^         exits normally.
QUIT^16^
QUIT^17^     FAILURE
QUIT^18^         exits with a return code indicating failure.
QUIT^19^
QUIT^20^     WARNING
QUIT^21^         exits with a return code indicating warning.  QUIT with no clauses
QUIT^22^         exits with a value of SUCCESS.
QUIT^23^
QUIT^24^     n
QUIT^25^         is an integer you can specify as the return code.
QUIT^26^
QUIT^27^     variable
QUIT^28^         is a user-defined or system variable, like SQL.SQLCODE.
QUIT^29^         QUIT variable exits with the value of variable as the return code.
QUIT^30^
QUIT^31^     COMMIT
QUIT^32^         saves pending changes to the database before exiting.
QUIT^33^
QUIT^34^     ROLLBACK
QUIT^35^         executes a ROLLBACK statement and abandons pending changes to the
QUIT^36^         database before exiting.
QUIT^37^
QUIT^38^ QUIT enables you to specify an operating system return code so you can run
QUIT^39^ SQL*Plus command files in batch mode and detect an unexpected event.  The
QUIT^40^ manner of detection is operating-system specific.  SUCCESS, WARNING, and
QUIT^41^ FAILURE represent operating system dependent values; on some systems,
QUIT^42^ WARNING and FAILURE are not distinguishable.  The range of operating system
QUIT^43^ return codes is also restricted on some operating systems.  This limits the
QUIT^44^ portability of QUIT n and QUIT variable between platforms.  For example, on
QUIT^45^ UNIX there is no meaningful way to return an Oracle error code.  Since
QUIT^46^ there is only one byte of storage for return codes, the range for return
QUIT^47^ codes is limited to zero to 250.
QUIT^48^
QUIT^49^ To exit conditionally, use WHENEVER SQLERROR or WHENEVER OSERROR.
QUIT^50^
QUIT^51^ If you make a syntax error in the QUIT options, or use a non-numeric
QUIT^52^ variable, SQL*Plus performs a QUIT FAILURE COMMIT.
QUIT^53^
QUIT^54^
QUIT^55^
QUIT^56^ Example:  The following returns the error code of the last executed SQL
QUIT^57^           command or PL/SQL block:
QUIT^58^
QUIT^59^               SQL> QUIT SQL.SQLCODE
QUIT^60^
QUIT^61^           The location of the return code depends on your system.  See
QUIT^62^           TTITLE for more information on SQL.SQLCODE.
QUIT^63^
QUIT^64^
QUIT^65^
QUIT^66^ See also: connect, disconnect, host, exit, save, spool, SQLPlus,
QUIT^67^           whenever sqlerror, commands.
QUIT^68^
REMARK^1^
REMARK^2^
REMARK^3^
REMARK^4^                                   REMARK
REMARK^5^
REMARK^6^ REM[ARK]
REMARK^7^
REMARK^8^ REMARK at the beginning of a line signifies a comment in a command file.
REMARK^9^ The comment ends at the end of the line.  A line cannot contain both a
REMARK^10^ comment and a command.  See /* for information on entering comments in
REMARK^11^ statements.
REMARK^12^
REMARK^13^
REMARK^14^
REMARK^15^ Example:  Here are some typical comments in command files:
REMARK^16^
REMARK^17^               REM Uses BREAK ON REPORT to break on end of table.
REMARK^18^               BREAK ON REPORT
REMARK^19^               COMPUTE SUM OF "DEPARTMENT 10" "DEPARTMENT 20" -
REMARK^20^               "DEPARTMENT 30" "TOTAL BY JOB" ON REPORT
REMARK^21^               REM Each column displays the sums of salaries by job
REMARK^22^               REM for one of the departments 10, 20, 30.
REMARK^23^               SELECT JOB,
REMARK^24^                      SUM( DECODE( DEPTNO, 10, SAL, 0)) "DEPARTMENT 10",
REMARK^25^                      SUM( DECODE( DEPTNO, 20, SAL, 0)) "DEPARTMENT 20",
REMARK^26^                      SUM( DECODE( DEPTNO, 30, SAL, 0)) "DEPARTMENT 30",
REMARK^27^                      SUM(SAL) "TOTAL BY JOB"
REMARK^28^               FROM EMP
REMARK^29^               GROUP BY JOB
REMARK^30^
REMARK^31^
REMARK^32^
REMARK^33^ See also: /, @, comments, edit, get, start, run, whenever sqlerror,
REMARK^34^           commands.
REMARK^35^
REPFOOTER^1^
REPFOOTER^2^
REPFOOTER^3^
REPFOOTER^4^                              REPFOOTER
REPFOOTER^5^
REPFOOTER^6^ REPF[OOTER] [PAGE] [printspec [text|variable] ...] | [OFF|ON]
REPFOOTER^7^
REPFOOTER^8^ Places and formats a footer at the bottom of a report, or lists the
REPFOOTER^9^ REPFOOTER definition.
REPFOOTER^10^
REPFOOTER^11^ Refer to the REPHEADER command for information on terms and clauses
REPFOOTER^12^ in the REPFOOTER command syntax. Enter REPFOOTER with no clauses to
REPFOOTER^13^ list the current REPFOOTER definition.
REPFOOTER^14^
REPFOOTER^15^ If you do not enter a printspec clause before the text or variables,
REPFOOTER^16^ REPFOOTER left justifies the text or variables.  You can use any
REPFOOTER^17^ number of of constants and variables in a printspec.  SQL*Plus
REPFOOTER^18^ displays the constants and variables in the order you specify,
REPFOOTER^19^ positioning and formatting each constant or variable as specified by
REPFOOTER^20^ the printspec clauses that precede it.  Note: If SET EMBEDDED is ON,
REPFOOTER^21^ the report footer is suppressed.
REPFOOTER^22^
REPFOOTER^23^
REPFOOTER^24^
REPFOOTER^25^ Examples:  To define "END EMPLOYEE LISTING REPORT" as a report footer
REPFOOTER^26^            on a separate page, and to center it, enter:
REPFOOTER^27^
REPFOOTER^28^                SQL> REPFOOTER PAGE CENTER 'END EMPLOYEE LISTING REPORT'
REPFOOTER^29^                SQL> TTITLE RIGHT 'Page: ' FORMAT 999 SQL.PNO
REPFOOTER^30^                SQL> SELECT ENAME, SAL
REPFOOTER^31^                  2  FROM EMP
REPFOOTER^32^                  3  WHERE SAL > 2000;
REPFOOTER^33^                                                                Page: 1
REPFOOTER^34^                ENAME             SAL
REPFOOTER^35^                ---------- ----------
REPFOOTER^36^                JONES            2975
REPFOOTER^37^                BLAKE            2850
REPFOOTER^38^                CLARK            2450
REPFOOTER^39^                SCOTT            3000
REPFOOTER^40^                KING             5000
REPFOOTER^41^                FORD             3000
REPFOOTER^42^                                                                Page: 2
REPFOOTER^43^                              END EMPLOYEE LISTING REPORT
REPFOOTER^44^
REPFOOTER^45^            To suppress the report footer without changing its definition,
REPFOOTER^46^            enter:
REPFOOTER^47^
REPFOOTER^48^                SQL> REPFOOTER OFF
REPFOOTER^49^
REPFOOTER^50^
REPFOOTER^51^
REPFOOTER^52^ See also: repheader, ttitle, btitle
REPFOOTER^53^
REPHEADER^1^
REPHEADER^2^
REPHEADER^3^
REPHEADER^4^                              REPHEADER
REPHEADER^5^
REPHEADER^6^ REPH[EADER] [PAGE] [printspec [text|variable] ...] | [OFF|ON]
REPHEADER^7^
REPHEADER^8^ where printspec is one or more of the clauses:
REPHEADER^9^
REPHEADER^10^         COL n          LE[FT]        BOLD
REPHEADER^11^         S[KIP] [n]     CE[NTER]      FORMAT text
REPHEADER^12^         TAB n          R[IGHT]
REPHEADER^13^
REPHEADER^14^ Places and formats a header at the top of a report, or lists the
REPHEADER^15^ REPHEADER definition.
REPHEADER^16^
REPHEADER^17^     PAGE
REPHEADER^18^         Begins a new page after printing the header or before
REPHEADER^19^         printing the footer. You must specify SET NEWPAGE 0 to
REPHEADER^20^         create a physical page break when using this command.
REPHEADER^21^
REPHEADER^22^     text
REPHEADER^23^         is the header or footer text.  Enter text in single quotes
REPHEADER^24^         if you want to place more than one word on a single line.
REPHEADER^25^         The default is NULL.
REPHEADER^26^
REPHEADER^27^     variable
REPHEADER^28^         is a user variable or any of these system maintained values:
REPHEADER^29^
REPHEADER^30^              SQL.LNO       current line number
REPHEADER^31^              SQL.PNO       current page number
REPHEADER^32^              SQL.RELEASE   current Oracle release number
REPHEADER^33^              SQL.SQLCODE   current error code
REPHEADER^34^              SQL.USER      current username
REPHEADER^35^
REPHEADER^36^         To print one of these values, reference the appropriate variable
REPHEADER^37^         in the header or footer.  You can format variable with the
REPHEADER^38^         FORMAT clause.
REPHEADER^39^
REPHEADER^40^     OFF turns the header or footer off (suppresses its display) without
REPHEADER^41^         affecting its definition.
REPHEADER^42^
REPHEADER^43^     ON  turns the header or footer on (restores its display).  When you
REPHEADER^44^         define a header or footer, SQL*Plus automatically sets REPHEADER
REPHEADER^45^         or REPFOOTER to ON.
REPHEADER^46^
REPHEADER^47^     COL n
REPHEADER^48^         indents to column n of the current line (backward if column n has
REPHEADER^49^         been passed).  "Column" here is print position, not table column.
REPHEADER^50^
REPHEADER^51^     S[KIP] [n]
REPHEADER^52^         skips to the start of a new line n times; if n omitted, one time.
REPHEADER^53^         If n = 0, skips backward to the start of the current line.
REPHEADER^54^
REPHEADER^55^     TAB n
REPHEADER^56^         skips forward n columns (backward if you enter a negative value
REPHEADER^57^         for n).  "Column" here is print position, not table column.
REPHEADER^58^
REPHEADER^59^     LE[FT], CE[NTER], and R[IGHT]
REPHEADER^60^         aligns data left, center, or right on the current line.  SQL*Plus
REPHEADER^61^         aligns the following data items as a group, up to the end of the
REPHEADER^62^         printspec or the next LEFT, CENTER, RIGHT, or COL command.  CENTER
REPHEADER^63^         and RIGHT use the SET LINESIZE value to calculate the position of
REPHEADER^64^         the data item that follows.
REPHEADER^65^
REPHEADER^66^     BOLD
REPHEADER^67^         prints data in bold print.  SQL*Plus represents bold print on your
REPHEADER^68^         terminal by repeating the data on three consecutive lines.  On
REPHEADER^69^         some operating systems, SQL*Plus may instruct your printer to
REPHEADER^70^         print bolded text on three consecutive lines, instead of bold.
REPHEADER^71^
REPHEADER^72^     FORMAT text
REPHEADER^73^         specifies a format model that determines the format data items to
REPHEADER^74^         the next FORMAT clause or the end of the command.  The format
REPHEADER^75^         model must be a text constant like A10 or $999.  See COLUMN
REPHEADER^76^         FORMAT for more information on formatting.
REPHEADER^77^
REPHEADER^78^         If the datatype of the format model does not match the datatype of
REPHEADER^79^         a given data item, the FORMAT clause has no effect on that item.
REPHEADER^80^
REPHEADER^81^         If no FORMAT model precedes a given data item, SQL*Plus prints
REPHEADER^82^         NUMBER values in the format specified by SET NUMFORMAT or, if you
REPHEADER^83^         have not used SET NUMFORMAT, the default format.  SQL*Plus prints
REPHEADER^84^         DATE values in the default format.
REPHEADER^85^
REPHEADER^86^ Enter REPHEADER with no clauses to list the current definition.
REPHEADER^87^ If you do not enter a printspec clause before the text or variables,
REPHEADER^88^ REPHEADER left justifies the text or variables.  You can use any
REPHEADER^89^ number of of constants and variables in a printspec.  SQL*Plus
REPHEADER^90^ displays the constants and variables in the order you specify,
REPHEADER^91^ positioning and formatting each constant or variable as specified by
REPHEADER^92^ the printspec clauses that precede it.
REPHEADER^93^
REPHEADER^94^
REPHEADER^95^
REPHEADER^96^ Examples:  To define "EMPLOYEE LISTING REPORT" as a report header on a
REPHEADER^97^            separate page, and to center it, enter:
REPHEADER^98^
REPHEADER^99^                SQL> REPHEADER PAGE CENTER 'EMPLOYEE LISTING REPORT'
REPHEADER^100^                SQL> TTITLE RIGHT 'Page: ' FORMAT 999 SQL.PNO
REPHEADER^101^                SQL> SELECT ENAME, SAL
REPHEADER^102^                  2  FROM EMP
REPHEADER^103^                  3  WHERE SAL > 2000;
REPHEADER^104^                                                                     Page:
REPHEADER^105^1
REPHEADER^106^                                  EMPLOYEE LISTING REPORT
REPHEADER^107^                                                                     Page:
REPHEADER^108^2
REPHEADER^109^                ENAME             SAL
REPHEADER^110^                ---------- ----------
REPHEADER^111^                JONES            2975
REPHEADER^112^                BLAKE            2850
REPHEADER^113^                CLARK            2450
REPHEADER^114^                SCOTT            3000
REPHEADER^115^                KING             5000
REPHEADER^116^                FORD             3000
REPHEADER^117^                6 rows selected.
REPHEADER^118^
REPHEADER^119^            To suppress the report header without changing its definition,
REPHEADER^120^            enter:
REPHEADER^121^
REPHEADER^122^                SQL> REPHEADER OFF
REPHEADER^123^
REPHEADER^124^
REPHEADER^125^
REPHEADER^126^ See also: repfooter, ttitle, btitle
REPHEADER^127^
RESERVED WORDS^1^
RESERVED WORDS^2^
RESERVED WORDS^3^
RESERVED WORDS^4^                            Reserved Words
RESERVED WORDS^5^
RESERVED WORDS^6^ The following words have special meaning in SQL and PL/SQL, and may
RESERVED WORDS^7^ not be used for identifier names (unless enclosed in "quotes"):
RESERVED WORDS^8^
RESERVED WORDS^9^ ABORT      AUDIT           CLUSTERS     DATA_BASE      DISPOSE
RESERVED WORDS^10^ ACCEPT     AUTHORIZATION   COLAUTH      DATE           DISTINCT
RESERVED WORDS^11^ ACCESS     AVG             COLUMN       DBA            DO
RESERVED WORDS^12^ ADD        BEGIN           COMMENT      DEBUGOFF       DROP
RESERVED WORDS^13^ ALL        BETWEEN         COMMIT       DEBUGON        ELSE
RESERVED WORDS^14^ ALTER      BODY            COMPRESS     DECIMAL        ELSIF
RESERVED WORDS^15^ AND        BOOLEAN         CONNECT      DECLARE        END
RESERVED WORDS^16^ ANY        BY              CONSTANT     DEFAULT        ENTRY
RESERVED WORDS^17^ ARRAY      CASE            COUNT        DEFINITION     EXCEPTION
RESERVED WORDS^18^ AS         CHAR            CRASH        DELAY          EXCEPTION_INIT
RESERVED WORDS^19^ ASC        CHAR_BASE       CREATE       DELETE         EXCLUSIVE
RESERVED WORDS^20^ ASSERT     CHECK           CURRENT      DELTA          EXISTS
RESERVED WORDS^21^ ASSIGN     CLOSE           CURSOR       DESC           EXIT
RESERVED WORDS^22^ AT         CLUSTER         DATABASE     DIGITS         FALSE
RESERVED WORDS^23^
RESERVED WORDS^24^ FETCH        IF            LIKE         NOCOMPRESS     OTHERS
RESERVED WORDS^25^ FILE         IMMEDIATE     LIMITED      NOT            OUT
RESERVED WORDS^26^ FLOAT        IN            LOCK         NOWAIT         PACKAGE
RESERVED WORDS^27^ FOR          INCREMENT     LONG         NULL           PARTITION
RESERVED WORDS^28^ FORM         INDEX         LOOP         NUMBER         PCTFREE
RESERVED WORDS^29^ FROM         INDEXES       MAX          NUMBER_BASE    PRAGMA
RESERVED WORDS^30^ FUNCTION     INDICATOR     MAXEXTENTS   OF             PRIOR
RESERVED WORDS^31^ GENERIC      INITIAL       MIN          OFFLINE        PRIVATE
RESERVED WORDS^32^ GOTO         INSERT        MINUS        ON             PRIVILEGES
RESERVED WORDS^33^ GRANT        INTEGER       MOD          ONLINE         PROCEDURE
RESERVED WORDS^34^ GRAPHIC      INTERSECT     MODE         OPEN           PUBLIC
RESERVED WORDS^35^ GROUP        INTO          MODIFY       OPTION         RAISE
RESERVED WORDS^36^ HAVING       IS            NEW          OR             RANGE
RESERVED WORDS^37^ IDENTIFIED   LEVEL         NOAUDIT      ORDER          RAW
RESERVED WORDS^38^
RESERVED WORDS^39^ RECORD       ROWTYPE       SQLERRM      THEN           VARGRAPH
RESERVED WORDS^40^ RELEASE      RUN           START        TO             VARIANCE
RESERVED WORDS^41^ REM          SAVEPOINT     STATEMENT    TRIGGER        VIEW
RESERVED WORDS^42^ REMARK       SCHEMA        STDDEV       TRUE           VIEWS
RESERVED WORDS^43^ RENAME       SELECT        SUBTYPE      TYPE           WHEN
RESERVED WORDS^44^ RESOURCE     SEPARATE      SUCCESSFUL   UID            WHENEVER
RESERVED WORDS^45^ RETURN       SESSION       SUM          UNION          WHERE
RESERVED WORDS^46^ REVERSE      SET           SYNONYM      UNIQUE         WHILE
RESERVED WORDS^47^ REVOKE       SHARE         SYSDATE      UPDATE         WITH
RESERVED WORDS^48^ ROLLBACK     SIZE          TABAUTH      USE            WORK
RESERVED WORDS^49^ ROW          SMALLINT      TABLE        USER           XOR
RESERVED WORDS^50^ ROWID        SPACE         TABLES       VALIDATE
RESERVED WORDS^51^ ROWNUM       SQL           TASK         VALUES
RESERVED WORDS^52^ ROWS         SQLCODE       TERMINATE    VARCHAR
RESERVED WORDS^53^
RESERVED WORDS^54^
RESERVED WORDS^55^
RESERVED WORDS^56^ See also: commands.
RESERVED WORDS^57^
RUN^1^
RUN^2^
RUN^3^
RUN^4^                                     RUN
RUN^5^
RUN^6^ R[UN]
RUN^7^
RUN^8^ RUN lists and executes the SQL command or PL/SQL block currently in the
RUN^9^ SQL buffer.  RUN makes the last line of the SQL buffer the current line.
RUN^10^ The slash command (/) works like RUN, but doesn't list the command.
RUN^11^
RUN^12^
RUN^13^
RUN^14^    Example:  The SQL buffer contains the query:
RUN^15^
RUN^16^               SELECT DEPTNO FROM DEPT
RUN^17^
RUN^18^           To RUN the query, enter:
RUN^19^
RUN^20^               SQL> RUN
RUN^21^
RUN^22^           Output:  1* SELECT DEPTNO FROM DEPT
RUN^23^
RUN^24^                    DEPTNO
RUN^25^                    ------
RUN^26^                        10
RUN^27^                        20
RUN^28^                        30
RUN^29^                        40
RUN^30^
RUN^31^
RUN^32^
RUN^33^ See also: /, @, edit, get, list, parameters, save, spool, start,
RUN^34^           SQL in PL/SQL, commands.
RUN^35^
RUNFORM^1^
RUNFORM^2^
RUNFORM^3^
RUNFORM^4^                                   RUNFORM
RUNFORM^5^
RUNFORM^6^ RUNFORM [options]  form_name
RUNFORM^7^
RUNFORM^8^ RUNFORM invokes a SQL*Forms application from within SQL*Plus.  Note: You
RUNFORM^9^ have access to this command only if your site chose this option while
RUNFORM^10^ installing SQL*Plus.
RUNFORM^11^
RUNFORM^12^     [options]
RUNFORM^13^         See your SQL*Forms Designer's Reference Manual for details.
RUNFORM^14^
RUNFORM^15^     form_name
RUNFORM^16^         See your SQL*Forms Designer's Reference Manual for details.
RUNFORM^17^
RUNFORM^18^ The RUNFORM syntax is the same in both SQL*Plus and SQL*Forms.  You can
RUNFORM^19^ invoke a form more quickly in SQL*Plus than you can from the system prompt
RUNFORM^20^ because you avoid a separate Oracle logon.
RUNFORM^21^
RUNFORM^22^ When you invoke a form in SQL*Plus (by using RUNFORM), do not specify a
RUNFORM^23^ username/password (you retain your current connection to Oracle).  To use
RUNFORM^24^ another username/password, use the CONNECT command to connect to the
RUNFORM^25^ username before issuing the RUNFORM command.
RUNFORM^26^
RUNFORM^27^
RUNFORM^28^
RUNFORM^29^ Example:  To run a form named MYFORM, enter:
RUNFORM^30^
RUNFORM^31^               SQL> RUNFORM MYFORM
RUNFORM^32^
RUNFORM^33^
RUNFORM^34^
RUNFORM^35^ See also:  commands.
RUNFORM^36^
SAVE^1^
SAVE^2^
SAVE^3^
SAVE^4^                                         SAVE
SAVE^5^
SAVE^6^ SAV[E] file_name[.ext] [CRE[ATE]|REP[LACE]|APP[END]]
SAVE^7^
SAVE^8^ SAVE stores the SQL buffer's contents in a host operating system command
SAVE^9^ file.
SAVE^10^
SAVE^11^     file_name[.ext ]
SAVE^12^         specifies the command file in which to save the buffer's
SAVE^13^         contents.
SAVE^14^
SAVE^15^     CRE[ATE]
SAVE^16^         creates the file if the file does not exist.
SAVE^17^
SAVE^18^     REP[LACE]
SAVE^19^         replaces the contents of an existing file.  If the file does not
SAVE^20^         exist, REPLACE creates the file.
SAVE^21^
SAVE^22^     APP[END]
SAVE^23^         adds the contents of the buffer to the end of the specified file.
SAVE^24^
SAVE^25^
SAVE^26^
SAVE^27^ When you SAVE the contents of the SQL buffer, SAVE adds a line containing
SAVE^28^ a slash (/) to the end of the file.  If you don't specify an extension,
SAVE^29^ SQL*Plus assumes the default extension (normally SQL).
SAVE^30^
SAVE^31^ To SAVE a file under a name identical to a SAVE command clause (CREATE,
SAVE^32^ REPLACE, or APPEND), you must specify a file extension.
SAVE^33^
SAVE^34^
SAVE^35^
SAVE^36^ Example:  To save the buffer's contents in file DEPTSALRPT.SQL, enter:
SAVE^37^
SAVE^38^               SQL> SAVE DEPTSALRPT
SAVE^39^
SAVE^40^           To save the buffer's contents in file DEPTSALRPT.OLD, enter:
SAVE^41^
SAVE^42^               SQL> SAVE DEPTSALRPT.OLD
SAVE^43^
SAVE^44^
SAVE^45^
SAVE^46^ See also:  commands.
SAVE^47^
SET^1^
SET^2^
SET^3^
SET^4^                                     SET
SET^5^
SET^6^ SET system_variable value
SET^7^
SET^8^   APPI[NFO]{ON|OFF|text}
SET^9^   ARRAY[SIZE] {20|n}                       NEWP[AGE] {1|n}
SET^10^   AUTO[COMMIT] {OFF|ON|IMM[EDIATE|n]}      NULL text
SET^11^   AUTOP[RINT] {OFF|ON}                     NUMF[ORMAT] format
SET^12^   AUTOT[RACE] {OFF|ON|TRACE[ONLY]}         NUM[WIDTH] {10|n}
SET^13^     [EXP[LAIN]] [STAT[ISTICS]]             PAGES[IZE] {24|n}
SET^14^   BLO[CKTERMINATOR] {.|c}                  PAU[SE] {OFF|ON|text}
SET^15^   CLOSECUR[SOR] {OFF|ON}                   RECSEP {WR[APPED]|EA[CH]|OFF}
SET^16^   CMDS[EP] {;|c|OFF|ON}                    RECSEPCHAR { |c}
SET^17^   COLSEP { |text}                          SERVEROUT[PUT] {OFF|ON} [SIZE n]
SET^18^   COM[PATIBILITY] {V6|V7|NATIVE}             [FOR[MAT] {WRA[PPED]|
SET^19^   CON[CAT] {.|c|OFF|ON}                      WOR[D_WRAPPED]|TRU[NCATED]}]
SET^20^   COPYC[OMMIT] {0|n}                       SHOW[MODE] {OFF|ON}
SET^21^   COPYTYPECHECK {OFF|ON}                   SQLC[ASE] {MIX[ED]|LO[WER]|UP[PER]}
SET^22^   CRT crt                                  SQLCO[NTINUE] {> | text}
SET^23^   DEF[INE] {&|c|OFF|ON}                    SQLN[UMBER] {OFF|ON}
SET^24^   ECHO {OFF|ON}                            SQLPRE[FIX] {#|c}
SET^25^   EDITF[ILE] file_name[.ext]               SQLP[ROMPT] {SQL>|text}
SET^26^   EMBEDDED {OFF|ON}                        SQLT[ERMINATOR] {;|c|OFF|ON}
SET^27^   ESC[APE] {\|c|OFF|ON}                    SUF[FIX] {SQL|text}
SET^28^   FEED[BACK] {6|n|OFF|ON}                  TAB {OFF|ON}
SET^29^   FLAGGER {OFF|ENTRY|INTERMED[IATE]|FULL}  TERM[OUT] {OFF|ON}
SET^30^   FLU[SH] {OFF|ON}                         TI[ME] {OFF|ON}
SET^31^   HEA[DING] {OFF|ON}                       TIMI[NG] {OFF|ON}
SET^32^   HEADS[EP] {||c|OFF|ON}                   TRIM[OUT] {OFF|ON}
SET^33^   LIN[ESIZE] {80|n}                        TRIMS[POOL] {ON|OFF}
SET^34^   LONG {80|n}                              UND[ERLINE] {-|c|ON|OFF}
SET^35^   LONGC[HUNKSIZE] {80|n}                   VER[IFY] {OFF|ON}
SET^36^   MAXD[ATA] n                              WRA[P] {OFF|ON}
SET^37^
SET^38^ Use SET to control SQL*Plus environment settings for the current session;
SET^39^ for example:
SET^40^                -   the display width for NUMBER data
SET^41^                -   the display width for LONG data
SET^42^                -   enabling or disabling the printing of column headings
SET^43^                -   the number of lines per page
SET^44^
SET^45^     APPI[NFO]{ON|OFF|text}
SET^46^         Sets automatic registering of command files through the
SET^47^         DBMS_APPLICATION_INFO package.  This enables the performance and
SET^48^         resource usage of each command file to be monitored by your DBA.
SET^49^         The registered name appears in the MODULE column of the V$SESSION
SET^50^         and V$SQLAREA virtual tables.  You can also read the registered
SET^51^         name using the DBMS_APPLICATION_INFO.READ_MODULE procedure.
SET^52^
SET^53^         ON registers command files invoked by the @, @@ or START commands.
SET^54^         OFF disables registering of command files.  Instead, the current
SET^55^         value of text is registered.  text specifies the text to register
SET^56^         when no command file is being run or when APPINFO is OFF.  The
SET^57^         default for text is "SQL*Plus."  If you enter multiple words for
SET^58^         text, you must enclose them in quotes. The maximum length for text
SET^59^         is limited by the DBMS_APPLICATION_INFO package.
SET^60^
SET^61^         The registered name has the format nn@xfilename where:  nn is the
SET^62^         depth level of command file; x is '<' when the command file name
SET^63^         is truncated, otherwise, it is blank; and filename is the command
SET^64^         file name, possibly truncated to the limit allowed by the
SET^65^         DBMS_APPLICATION_INFO package.
SET^66^
SET^67^         Note: To use this feature, you must have access to the
SET^68^         DBMS_APLICATION_INFO package.  Run DBMSUTIL.SQL (this name may
SET^69^         vary depending on your operating system) as SYS to create the
SET^70^         DBMS_APPLICATION_INFO package.  DBMSUTIL.SQL is part of the
SET^71^         Oracle7 Server product.
SET^72^
SET^73^         For more information on the DBMS_APPLICATION_INFO package,
SET^74^         see "Registering Applications" in the Oracle7 Server Tuning
SET^75^         manual.
SET^76^
SET^77^         Note: APPINFO is not available with TRUSTED Oracle.
SET^78^
SET^79^     ARRAY[SIZE] {20|n}
SET^80^         sets the number of rows called a batch that SQL*Plus will fetch from
SET^81^         the database at one time (Range: 1 - 5000). A large value increases
SET^82^         the efficiency of queries and subqueries that fetch many rows, but
SET^83^         requires more memory; values over 100 or so provide little added
SET^84^         performance.  ARRAYSIZE only improves the efficiency of SQL*Plus
SET^85^         operations; it has no other effect.
SET^86^
SET^87^     AUTO[COMMIT] {OFF|ON|IMM[EDIATE]|n}
SET^88^         controls when Oracle commits pending changes to the database.  ON
SET^89^         commits pending changes to the database after Oracle executes each
SET^90^         SQL command or PL/SQL block.  OFF suppresses automatic committing,
SET^91^         so changes must be committed manually (with COMMIT, for example).
SET^92^         IMMEDIATE works just like ON.  n commits pending changes to the
SET^93^         database after Oracle executes n INSERT, UPDATE or DELETE commands
SET^94^         or PL/SQL blocks.  The statement counter is reset to zero after
SET^95^         successful completion of:  n INSERT, UPDATE or DELETE commands or
SET^96^         PL/SQL blocks; a commit; a rollback; or a SET AUTOCOMMIT command.
SET^97^         A PL/SQL block is regarded as one transaction, regardless of the
SET^98^         number of SQL commands in it.
SET^99^
SET^100^     AUTOP[RINT] {OFF|ON}
SET^101^         sets the automatic PRINTing of bind variables.  ON or OFF controls
SET^102^         whether SQL*Plus automatically displays bind variables (referenced
SET^103^         in a successful PL/SQL block, or used in an EXECUTE command).  See
SET^104^         the PRINT command for more information about displaying bind
SET^105^         variables.
SET^106^
SET^107^     AUTOT[RACE] {OFF|ON|TRACE[ONLY]} [EXP[LAIN]] [STAT[ISTICS]]
SET^108^         Displays a report on the execution of successful SQL DML statements
SET^109^         (SELECT, INSERT, UPDATE or DELETE).  The report can include execution
SET^110^         statistics and the query execution path.
SET^111^
SET^112^         OFF does not display a trace report.  ON displays a trace report.
SET^113^         TRACEONLY displays a trace report, but does not print any query data.
SET^114^         EXPLAIN shows the query execution path.  STATISTICS displays SQL
SET^115^         statement statistics.
SET^116^
SET^117^         Using ON or TRACEONLY with no options defaults to EXPLAIN STATISTICS.
SET^118^
SET^119^         TRACEONLY is useful to suppress the query data of large queries.
SET^120^         If STATISTICS is specified, SQL*Plus still fetches the query data
SET^121^         from the server, but the data is not displayed. The AUTOTRACE report
SET^122^         is printed after the query has successfully completed.
SET^123^
SET^124^         To use the EXPLAIN option, you must first create the table PLAN_TABLE
SET^125^         in your schema. The description of this table is specific to the
SET^126^         version of the database to which you are connected.  Use UTLXPLAN.SQL
SET^127^         (part of the Oracle7 Server product) to create PLAN_TABLE.
SET^128^
SET^129^         To access STATISTICS data, you must have access to several Dynamic
SET^130^         Performance tables.  Access can be granted using the role created
SET^131^in
SET^132^         PLUSTRCE.SQL.  Run PLUSTRCE.SQL as SYS and grant the role to users
SET^133^         who will use SET AUTOTRACE.
SET^134^
SET^135^         When SQL*Plus produces a STATISTICS report, a second connection to
SET^136^         the database is automatically created.  This connection is closed
SET^137^         when the STATISTICS option is set to OFF, or you log out of SQL*Plus.
SET^138^
SET^139^         The formatting of the AUTOTRACE report may vary, depending on the
SET^140^         server release, the configuration of the server and whether you
SET^141^         are using the cost based or rule based optimizer.
SET^142^
SET^143^         AUTOTRACE is not available when FIPS flagging is enabled, or with
SET^144^         TRUSTED Oracle.
SET^145^
SET^146^     BLO[CKTERMINATOR] {.|c}
SET^147^         sets the non-alphanumeric character that ends PL/SQL blocks to c.
SET^148^         To execute the block, issue a RUN or slash (/) command.
SET^149^
SET^150^     CLOSECUR[SOR] {OFF|ON}
SET^151^         sets the cursor usage behavior.  ON or OFF sets whether or not
SET^152^         the cursor will close and reopen after each SQL statement.
SET^153^         This feature may be useful in some environments to release
SET^154^         resources in the database server.
SET^155^
SET^156^     CMDS[EP] {;|c|ON|OFF}
SET^157^         sets the non-alphanumeric character used between multiple SQL*Plus
SET^158^         commands entered on one line to c.  ON or OFF sets whether or not
SET^159^         multiple commands can be entered on a line; ON automatically makes
SET^160^         ; (a semicolon) the command separator character.
SET^161^
SET^162^     COLSEP { |text}
SET^163^         sets the text to be printed between SELECTed columns. If the
SET^164^         COLSEP variable contains blanks or punctuation characters, you
SET^165^         must enclose it with single quotes. The default is a space.
SET^166^         In multi-line rows, the column separator does not print between
SET^167^         columns that begin on different lines.  The column separator
SET^168^         does not appear on blank lines produced by BREAK ... SKIP n and
SET^169^         does not overwrite the record separator.
SET^170^
SET^171^     COM[PATIBILITY] {V6|V7|NATIVE}
SET^172^         specifies the version of Oracle to which you are connected.
SET^173^         Set COMPATIBILITY to V6 for Version 6 or V7 for Oracle7. Set
SET^174^         COMPATABILITY to NATIVE if you wish the database to determine the
SET^175^         setting (for example, if connected to Oracle7, COMPATIBILITY would
SET^176^         default to V7).  Note that you can set COMPATIBILITY to V6 when
SET^177^         connected to Oracle7.  This enables you to run Version 6 SQL
SET^178^         against Oracle7.
SET^179^
SET^180^         Setting COMPATIBILITY to V6 causes SQL*Plus to treat CHAR
SET^181^         column values as variable length character strings.
SET^182^         Setting COMPATIBILITY to V7 causes SQL*Plus to treat CHAR
SET^183^         COLUMN VALUES as fixed length character strings and
SET^184^         VARCHAR2 (VARCHAR) column values as variable length
SET^185^         character strings.
SET^186^
SET^187^         See the Oracle7 Server documentation for a list of changes
SET^188^         from Version 6 to Oracle7.
SET^189^
SET^190^     CON[CAT] {.|c|OFF|ON}
SET^191^         sets the character you can use to end a substitution variable name
SET^192^         when you want to use a character after the variable that SQL*Plus
SET^193^         would otherwise see as a part of the variable's name.  SQL*Plus
SET^194^         resets the value of CONCAT to a period when you switch CONCAT on.
SET^195^
SET^196^     COPYC[OMMIT] {0|n}
SET^197^         controls the number of batches processed before the COPY command
SET^198^         commits database changes (Range: 0 - 5000).  Set the size of a
SET^199^         batch with the ARRAYSIZE variable.  If you set COPYCOMMIT to zero,
SET^200^         COPY commits changes only at the end of a copy operation.
SET^201^
SET^202^     COPYTYPECHECK {OFF|ON}
SET^203^         sets the suppression of the comparison of datatypes whilst
SET^204^         inserting or appending to tables with the COPY command.  This is
SET^205^         to facilitate copying to DB2 which requires that a CHAR be copied
SET^206^         to a DB2 DATE.
SET^207^
SET^208^     CRT crt
SET^209^         changes the default CRT file used in the SQL*Plus RUNFORM command.
SET^210^         To return to the original default (before CRT was set), set CRT to
SET^211^         nothing by entering two double quotes ("") for crt.
SET^212^
SET^213^         To use NEW.CRT during a form invocation on a system where the
SET^214^         default CRT is OLD.CRT, invoke the form with either:
SET^215^
SET^216^               SQL> RUNFORM -c NEW form_name
SET^217^         or    SQL> SET CRT NEWSQL> RUNFORM form_name
SET^218^
SET^219^         The second method stores the CRT option; you don't have to
SET^220^         re-specify it for additional RUNFORM commands during the same
SET^221^         SQL*Plus session.
SET^222^
SET^223^     DEF[INE] {&|c|OFF|ON}
SET^224^         sets c to be the character in front of substitution variables.
SET^225^         ON or OFF sets whether or not SQL*Plus will scan commands for
SET^226^         substitution variables and replace them with their values.
SET^227^         ON changes the value of c back to the default '&' and not
SET^228^         the most recently used character.
SET^229^
SET^230^     ECHO {OFF|ON}
SET^231^         sets whether START lists each command in a command file as the
SET^232^         command is executed.  ON lists the commands; OFF does not.
SET^233^
SET^234^     EDITF[ILE] file_name[.ext]
SET^235^         sets the default filename for the EDIT command.  You can include
SET^236^         a path and/or extension.
SET^237^
SET^238^     EMBEDDED {OFF|ON}
SET^239^         controls each report begins on a page.  OFF starts each report at
SET^240^         the top of a new page; ON allows a report to begin anywhere.  Set
SET^241^         EMBEDDED to ON to start printing a report immediately after the
SET^242^         previous one.
SET^243^
SET^244^         Note:  When you use SET EMBEDDED ON and change the pagesize with
SET^245^         SET PAGESIZE n, SQL*Plus finishes the current page using the
SET^246^         existing pagesize setting and, if required, begins a new page
SET^247^         with the new pagesize setting.
SET^248^
SET^249^         Note:  When using a BTITLE with SET EMBEDDED ON, the second and
SET^250^         subsequent SELECTs will always begin on a new page.  This is
SET^251^         because SQL*Plus has no input read ahead.  Since SQL*Plus cannot
SET^252^         tell whether you will enter another SELECT, or, for example,
SET^253^         EXIT, SQL*Plus has to complete processing all output from the
SET^254^         first SELECT before it reads the next command.  This
SET^255^         processing includes printing the BTITLE.  Hence, given two
SET^256^         SELECTs, SQL*Plus prints the final BTITLE of the first SELECT
SET^257^         before it processes the second.  The second SELECT will then
SET^258^         begin at the top of a new page.
SET^259^
SET^260^         Note: When you use a REPFOOTER with SET EMBEDDED ON, no footer
SET^261^         will be displayed.
SET^262^
SET^263^     ESC[APE] {\|c|OFF|ON}
SET^264^         defines the character you enter as the escape character.  OFF
SET^265^         undefines the escape character.  ON enables the escape character.
SET^266^         ON changes the value of c back to the default "\".
SET^267^
SET^268^         Use the escape character before the substitution character (set
SET^269^         with SET DEFINE) to have SQL*Plus treat the substitution character
SET^270^         as an ordinary character, not a request for variable substitution.
SET^271^
SET^272^     FEED[BACK] {6|n|OFF|ON}
SET^273^         shows the number of records returned by a query when at n or more
SET^274^         records are selected.  ON sets n to 1.  Zero is the same as OFF.
SET^275^
SET^276^     FLAGGER {OFF|ENTRY|INTERMED[IATE]|FULL}
SET^277^         checks to make sure that SQL statements conform to the ANSI/ISO
SET^278^         SQL92 standard.  If any non-standard constructs are found, the
SET^279^         Oracle server flags them as errors and displays the violating
SET^280^         syntax.  This is the equivalent of the SQL language ALTER SESSION
SET^281^         SET FLAGGER command.  However, you may execute SET FLAGGER even if
SET^282^         you are not connected to a database. FIPS flagging will remain in
SET^283^         effect across SQL*Plus sessions until a SET FLAGGER OFF (or ALTER
SET^284^         SESSION SET FLAGGER = OFF) command is successful or you exit
SET^285^         SQL*Plus.
SET^286^
SET^287^         When FIPS flagging is enabled, SQL*Plus will display a warning for
SET^288^         the following three commands, even if they are successful:
SET^289^
SET^290^               CONNECT
SET^291^               DISCONNECT
SET^292^               ALTER SESSION SET FLAGGER
SET^293^
SET^294^     FLU[SH] {OFF|ON}
SET^295^         controls when output goes to the display device.  OFF allows the
SET^296^         host operating system to buffer output.  ON disables buffering.
SET^297^
SET^298^         Use FLUSH OFF only when running a command file non-interactively
SET^299^         to suppress output and prompts until the run is over.  FLUSH OFF
SET^300^         may improve performance by reducing the amount of program I/O.
SET^301^
SET^302^     HEA[DING] {OFF|ON}
SET^303^         controls printing of column headings in reports.  ON prints column
SET^304^         headings in reports; OFF suppresses column headings.
SET^305^
SET^306^     HEADS[EP] {||c|OFF|ON}
SET^307^         sets the character you enter as the heading separator character.
SET^308^         The heading separator character cannot be alphanumeric or white
SET^309^         space.  You can use the heading separator character in the COLUMN
SET^310^         command and in the old forms of BTITLE and TTITLE to divide a
SET^311^         column heading or title onto more than one line.  Set HEADSEP OFF
SET^312^         to print a heading separator character like any other character.
SET^313^         ON changes the value of c back to the default "|".
SET^314^
SET^315^     LIN[ESIZE] {80|n}
SET^316^         sets the total number of characters displayed on a line before
SET^317^         starting a new line, and controls the position of centered and
SET^318^         right-aligned text in TTITLE, BTITLE, REPHEADER and REPFOOTER.
SET^319^         The range is 1 to a system dependent maximum.
SET^320^
SET^321^     LONG {80|n}
SET^322^         sets the maximum width for displaying and copying LONG values; the
SET^323^         maximum value of n is two gigabytes.
SET^324^
SET^325^     LONGC[HUNKSIZE] {80|n}
SET^326^         sets the size, in characters, of the increments in which SQL*Plus
SET^327^         retrieves a LONG value.  When retrieving a LONG value you may
SET^328^         want to retrieve it in increments rather than all at once
SET^329^         because of memory restrictions.  Valid values are 1 to whatever
SET^330^         has been set with MAXDATA.  Note that the value may not
SET^331^         exceed the value set with LONG.  Applies only to Oracle7.
SET^332^
SET^333^     MAXD[ATA] n
SET^334^         sets the maximum size, in bytes, of all ARRAYSIZE rows.  The
SET^335^         default and maximum values of n are system dependent.
SET^336^
SET^337^     NEWP[AGE] {1|n}
SET^338^         Sets the number of blank lines to be printed from the top of each
SET^339^         page to the top title. A value of zero places a formfeed at the
SET^340^         beginning of each page (including the first page) and clears the
SET^341^
SET^342^         screen on most terminals.
SET^343^
SET^344^     NULL text
SET^345^         sets the text to represent a null value in the result of a SELECT
SET^346^         statement.  Use the NULL clause of the COLUMN command to override
SET^347^         the setting of the NULL variable for a given column.
SET^348^
SET^349^     NUMF[ORMAT] format
SET^350^         sets the default format for displaying numbers.  Enter a number
SET^351^         format for format.  See FORMAT NUMBERS for format descriptions.
SET^352^
SET^353^     NUM[WIDTH] {10|n}
SET^354^         sets the default width for displaying numbers.
SET^355^
SET^356^     PAGES[IZE] {24|n}
SET^357^         sets the number of lines in each page.  Set PAGESIZE to zero to
SET^358^         suppress headings, page breaks, titles, the initial blank line,
SET^359^         and other formatting information.
SET^360^
SET^361^     PAU[SE] {OFF|ON|text}
SET^362^         controls scrolling on the terminal when running reports.  ON
SET^363^         pauses at the beginning of each page of report output.  Press
SET^364^         RETURN or [Clear] after each pause.  text specifies the text
SET^365^         displayed whenever SQL*Plus pauses.  To enter multiple words,
SET^366^         enclose text in single quotes.
SET^367^
SET^368^         You can embed terminal-dependent escape sequences in PAUSE to
SET^369^         create inverse video messages and other effects, where supported.
SET^370^
SET^371^     RECSEP {WR[APPED]|EA[CH]|OFF}
SET^372^     RECSEPCHAR { |c}
SET^373^         displays or prints record separators.  A record separator is the
SET^374^         RECSEPCHAR (character) repeated LINESIZE times on a single line.
SET^375^
SET^376^         RECSEPCHAR is the record separating character.  Default = space.
SET^377^
SET^378^         RECSEP sets where the record separation occurs.  WRAPPED prints a
SET^379^         record separator only after wrapped lines.  EACH prints a record
SET^380^         separator after every row.  OFF does not print a record separator.
SET^381^
SET^382^     SERVEROUT[PUT] {OFF|ON}  [SIZE n] [FOR[MAT] {WRA[PPED]|WOR[D_WRAPPED]|
SET^383^       TRU[NCATED]}]
SET^384^         Controls whether to display the output (DBMS_OUTPUT.PUT_LINE) of
SET^385^         stored procedures or PL/SQL blocks in SQL*Plus.  OFF suppresses
SET^386^         the output of DBMS_OUTPUT.PUT_LINE; ON displays the output.
SET^387^
SET^388^         SIZE sets the number of bytes of the output buffered within the
SET^389^         Oracle7 Server.  The default for n is 2000. n cannot be less than
SET^390^         2000 or greater than 1,000,000.
SET^391^
SET^392^         WRAPPED wraps the server output within the line size specified by
SET^393^         SET LINESIZE, beginning new lines when required.
SET^394^
SET^395^         WORD_WRAPPED wraps each line of server output within the line size
SET^396^         specified by SET LINESIZE. Lines are broken on word boundaries.
SET^397^         SQL*Plus left justifies each line, skipping all leading whitespace.
SET^398^
SET^399^         TRUNCATED truncates each line of server output the line size specified
SET^400^         by SET LINESIZE.
SET^401^
SET^402^         For each FORMAT, every server output line begins on a new output line.
SET^403^
SET^404^         The output is displayed synchronously after the stored procedure or
SET^405^         PL/SQL block has been executed by the Oracle7 Server.
SET^406^
SET^407^     SHOW[MODE] {OFF|ON}
SET^408^         controls whether or not SQL*Plus lists the old and new settings of
SET^409^         a SQL*Plus system variable when you change the setting with SET.
SET^410^         ON lists the settings; OFF does not.  SHOWMODE ON has the same
SET^411^         behavior as the obsolete SHOWMODE BOTH.
SET^412^
SET^413^     SQLC[ASE] {MIX[ED]|LO[WER]|UP[PER]}
SET^414^         changes the case of SQL commands and PL/SQL blocks just prior to
SET^415^         execution.  SQL*Plus converts all text in the command, including
SET^416^         quoted literals and identifiers, as follows:
SET^417^
SET^418^               uppercase if SQLCASE equals UPPER
SET^419^               lowercase if SQLCASE equals LOWER
SET^420^               unchanged if SQLCASE equals MIXED
SET^421^
SET^422^         SQLCASE does not change the SQL buffer itself.
SET^423^
SET^424^     SQLCO[NTINUE] {>|text}
SET^425^         sets the character sequence SQL*Plus displays as a prompt after
SET^426^         you use - (hyphen) to continue a SQL*Plus command on a new line.
SET^427^
SET^428^     SQLN[UMBER] {OFF|ON}
SET^429^         sets the prompt for the second and subsequent lines of a SQL
SET^430^         command or PL/SQL block.  ON sets the prompt to be the line
SET^431^         number.  OFF sets the prompt to the value of SQLPROMPT.
SET^432^
SET^433^     SQLPRE[FIX] {#|c}
SET^434^         sets the SQL*Plus prefix character.  While entering a SQL command
SET^435^         or PL/SQL block, you can enter a SQL*Plus command on a separate
SET^436^         line, prefixed by the SQL*Plus prefix character, to execute the
SET^437^         command immediately without affecting the SQL command or PL/SQL
SET^438^         block. The prefix character must be non-alphanumeric.
SET^439^
SET^440^     SQLP[ROMPT] {SQL>|text}
SET^441^         sets the SQL*Plus command prompt.
SET^442^
SET^443^     SQLT[ERMINATOR] {;|c|OFF|ON}
SET^444^         sets to c the character used to end and execute SQL command.  OFF
SET^445^         recognizes no command terminator; you terminate a SQL command by
SET^446^         entering an empty line. ON resets the terminator to ; (semicolon).
SET^447^
SET^448^     SUF[FIX] {SQL|text}
SET^449^         sets the default file extension that SQL*Plus uses in commands
SET^450^         that refer to command files.  SUFFIX does not control extensions
SET^451^         for spool files.
SET^452^
SET^453^     TAB {OFF|ON}
SET^454^         controls how SQL*Plus formats white space in the output.  OFF uses
SET^455^         spaces to add white space in the output.  ON uses TAB characters.
SET^456^         TAB settings are every eight characters.  The default value is
SET^457^         system dependent.
SET^458^
SET^459^     TERM[OUT] {OFF|ON}
SET^460^         controls the display of output generated by commands executed from
SET^461^         a command file.  OFF suppresses the display so you can spool output
SET^462^         from a command file without displaying the output.  ON shows the
SET^463^         output.  TERMOUT OFF doesn't affect interactively-entered command
SET^464^         output.
SET^465^
SET^466^     TI[ME] {OFF|ON}
SET^467^         controls the display of the current time.  ON displays the current
SET^468^         time before each command prompt.  OFF suppresses the time display.
SET^469^
SET^470^     TIMI[NG] {OFF|ON}
SET^471^         sets the display of timing statistics.  ON shows timing statistics
SET^472^         for each SQL command or PL/SQL block run.  OFF suppresses timing.
SET^473^         Use the TIMING command to control the timing of multiple commands.
SET^474^
SET^475^     TRIM[OUT] {OFF|ON}
SET^476^         determines whether SQL*Plus allows trailing blanks at the end of
SET^477^         each displayed line.  ON removes blanks at the end of each line,
SET^478^         improving performance especially when using a slow communications
SET^479^         device.  OFF displays trailing blanks.  TRIMOUT ON does not affect
SET^480^         spooled output.
SET^481^
SET^482^     TRIMS[POOL] {ON|OFF}
SET^483^         determines whether SQL*Plus allows trailing blanks at the end of
SET^484^         each spooled line.  ON removes blanks at the end of each line.
SET^485^         OFF allows SQL*Plus to include trailing blanks.  TRIMSPOOL ON
SET^486^         does not affect terminal output.
SET^487^
SET^488^     UND[ERLINE] {-|c|ON|OFF}
SET^489^         sets the character used to underline column headings in SQL*Plus
SET^490^         reports to c.  c cannot be an alphanumeric character or a white
SET^491^         space.  ON or OFF turns underlining on or off.  ON changes
SET^492^         the value of c back to the default "-".
SET^493^
SET^494^     VER[IFY] {OFF|ON}
SET^495^         controls whether SQL*Plus lists the text of a SQL statement or
SET^496^         PL/SQL command before and after SQL*Plus replaces substitution
SET^497^         variables with values.  ON lists the text; OFF suppresses the
SET^498^         listing.
SET^499^
SET^500^     WRA[P] {OFF|ON}
SET^501^         controls whether SQL*Plus truncates the display of a SELECTed row
SET^502^         if it is longer than the current line width.  OFF truncates it; ON
SET^503^         allows it to wrap to the next line.  The COLUMN command's WRAPPED
SET^504^         and TRUNCATED override the WRAP setting for specific columns.
SET^505^
SET^506^ SQL*Plus maintains system variables (SET command variables) so you can
SET^507^ tailor the environment for a SQL*Plus session.  You change these system
SET^508^ variables with the SET command and list them with the SHOW command.
SET^509^
SET^510^ SET ROLE and SET TRANSACTION are SQL commands.
SET^511^
SET^512^
SET^513^
SET^514^ Examples: Here are some uses of SET command variables:
SET^515^
SET^516^           APPINFO - To display the setting of APPINFO, enter:
SET^517^
SET^518^               SQL> SHOW APPINFO
SET^519^               SQL> appinfo is ON and set to "SQL*Plus"
SET^520^
SET^521^           To change the default text, enter:
SET^522^
SET^523^               SQL> SET APPI 'This is SQL*Plus'
SET^524^               SQL> SHOW APPINFO
SET^525^               SQL> appinfo is ON and set to "This is SQL*Plus"
SET^526^
SET^527^           To make sure that registration has taken place, enter:
SET^528^
SET^529^               SQL> VARIABLE MOD VARCHAR2(50)
SET^530^               SQL> VARIABLE ACT VARCHAR2(40)
SET^531^               SQL> EXECUTE DBMS_APPLICATION_INFO.READ_MODULE(:MOD, :ACT);
SET^532^               SQL> PRINT MOD
SET^533^               MOD
SET^534^               ---------------------------------------------------
SET^535^               This is SQL*Plus
SET^536^
SET^537^           CMDSEP - To specify a TTITLE and format a column on the same
SET^538^           line:
SET^539^
SET^540^               SQL> SET CMDSEP +
SET^541^               SQL> TTITLE LEFT 'SALARIES' + COLUMN SAL FORMAT $9,999
SET^542^               SQL> SELECT ENAME, SAL FROM EMP
SET^543^                 2  WHERE JOB = 'CLERK';
SET^544^
SET^545^           The following output results:
SET^546^
SET^547^               SALARIES
SET^548^               ENAME          SAL
SET^549^               ---------- -------
SET^550^               SMITH         $800
SET^551^               ADAMS       $1,100
SET^552^               JAMES         $950
SET^553^               MILLER      $1,300
SET^554^
SET^555^           COLUMN SEPARATOR - To set the column separator to "|":
SET^556^
SET^557^               SQL> SET COLSEP '|'
SET^558^               SQL> SELECT ENAME, JOB, DEPTNO
SET^559^                 2  FROM EMP
SET^560^                 3  WHERE DEPTNO = 20;
SET^561^
SET^562^           The following output results:
SET^563^
SET^564^               ENAME      |JOB      |   DEPTNO
SET^565^               -------------------------------
SET^566^               SMITH      |CLERK    |       20
SET^567^               JONES      |MANAGER  |       20
SET^568^               SCOTT      |ANALYST  |       20
SET^569^               ADAMS      |CLERK    |       20
SET^570^               FORD       |ANALYST  |       20
SET^571^
SET^572^           COMPATIBILITY - To run command file SALARY.SQL, created with
SET^573^           Version 6 of Oracle, enter:
SET^574^
SET^575^               SQL> SET COMPATIBILITY V6
SET^576^               SQL> START SALARY
SET^577^
SET^578^           After running the file, reset compatibility to V7:
SET^579^
SET^580^               SQL> SET COMPATIBILITY V7
SET^581^
SET^582^           Or you could add SET COMPATIBILITY V6 to the beginning of the
SET^583^           command file, and reset COMPATIBILITY to V7 at its end.
SET^584^
SET^585^           ESCAPE - If you define the escape character as !, then:
SET^586^
SET^587^                SQL> SET ESCAPE !
SET^588^                SQL> ACCEPT v1 PROMPT 'Enter !&1:'
SET^589^
SET^590^           displays the prompt:  Enter &1:
SET^591^
SET^592^           HEADING - The next example suppresses the display of column
SET^593^           headings in a report, then runs a SELECT statement:
SET^594^
SET^595^               SQL> SET HEADING OFF
SET^596^               SQL> SELECT ENAME, SAL FROM EMP
SET^597^                 2  WHERE JOB = 'CLERK';
SET^598^
SET^599^           Output:  ADAMS        1100
SET^600^                    JAMES         950
SET^601^                    MILLER       1300
SET^602^
SET^603^           LONG - To set the maximum width for displaying and copying LONG
SET^604^           values to 500, enter:
SET^605^
SET^606^               SQL> SET LONG 500
SET^607^
SET^608^           The LONG data will wrap on your screen; SQL*Plus truncates at
SET^609^           the 501st character.
SET^610^
SET^611^           LONGCHUNKSIZE - To set the size of the increments in which
SET^612^           SQL*Plus retrieves LONG values to 100 characters enter:
SET^613^
SET^614^               SQL> SET LONGCHUNKSIZE 100
SET^615^
SET^616^           The LONG data will be retrieved in increments of 100 characters
SET^617^           until the entire value is retrieved, or the value of SET LONG
SET^618^           is reached.
SET^619^
SET^620^           SERVEROUTPUT - To enable the display of DBMS_OUTPUT.PUT_LINE,
SET^621^           enter:
SET^622^
SET^623^               SQL> SET SERVEROUTPUT ON
SET^624^
SET^625^           The following example shows what happens when you execute an
SET^626^           anonymous procedure with SET SERVER OUTPUT ON:
SET^627^
SET^628^               SQL> BEGIN
SET^629^                 2  DBMS_OUTPUT.PUT_LINE('Task is complete');
SET^630^                 3  END;
SET^631^                 4  /
SET^632^               Task is complete.
SET^633^               PL/SQL procedure successfully completed.
SET^634^
SET^635^           The following example shows what happens when you create a
SET^636^           trigger with SET SERVEROUTPUT ON:
SET^637^
SET^638^               SQL> CREATE TRIGGER SERVER_TRIG BEFORE INSERT
SET^639^                 2  OR UPDATE OR DELETE ON SERVER_TAB
SET^640^                 3  BEGIN
SET^641^                 4  DBMS_OUTPUT.PUT_LINE('Task is complete.');
SET^642^                 5  END;
SET^643^                 6  /
SET^644^               Trigger created.
SET^645^               SQL> INSERT INTO SERVER_TAB VALUES ('TEXT');
SET^646^               Task is complete.
SET^647^               1 row created.
SET^648^
SET^649^           To set the output to WORD_WRAPPED, enter
SET^650^
SET^651^               SQL> SET SERVEROUTPUT ON FORMAT WORD_WRAPPED
SET^652^               SQL> SET LINESIZE 20
SET^653^               SQL> BEGIN
SET^654^                 2  DBMS_OUTPUT.PUT_LINE('If there is nothing left to do');
SET^655^                 3  DBMS_OUTPUT.PUT_LINE('shall we continue with plan B?');
SET^656^                 4  end;
SET^657^                 5  /
SET^658^               If there is nothing
SET^659^               left to do
SET^660^               shall we continue
SET^661^               with plan B?
SET^662^
SET^663^           To set the output to TRUNCATED, enter
SET^664^
SET^665^               SQL> SET SERVEROUTPUT ON FORMAT TRUNCATED
SET^666^               SQL> SET LINESIZE 20
SET^667^               SQL> BEGIN
SET^668^                 2  DBMS_OUTPUT.PUT_LINE('If there is nothing left to do');
SET^669^                 3  DBMS_OUTPUT.PUT_LINE('shall we continue with plan B?');
SET^670^                 4  END;
SET^671^                 5  /
SET^672^               If there is nothing
SET^673^               shall we continue wi
SET^674^
SET^675^           SQLCONTINUE - To set the SQL*Plus command continuation prompt to
SET^676^           an exclamation point followed by a space, enter:
SET^677^
SET^678^               SQL> SET SQLCONTINUE '! '
SET^679^
SET^680^           SQL*Plus prompts for continuation as follows:
SET^681^
SET^682^               SQL> TTITLE 'YEARLY INCOME' -
SET^683^               ! RIGHT SQL.PNO SKIP 2 -
SET^684^               ! CENTER 'PC DIVISION'
SET^685^               SQL>
SET^686^
SET^687^           SUFFIX - To set the default command file extension to UFI:
SET^688^
SET^689^               SQL> SET SUFFIX UFI
SET^690^
SET^691^           If you then enter:
SET^692^
SET^693^               SQL> GET EXAMPLE
SET^694^
SET^695^           SQL*Plus looks for file EXAMPLE.UFI instead of file EXAMPLE.SQL.
SET^696^
SET^697^
SET^698^
SET^699^ See also:  commands.
SET^700^
SHOW^1^
SHOW^2^
SHOW^3^
SHOW^4^                                    SHOW
SHOW^5^
SHOW^6^ SHO[W] option
SHOW^7^
SHOW^8^     where option can be:
SHOW^9^
SHOW^10^     system_variable
SHOW^11^     ALL
SHOW^12^     BTI[TLE]
SHOW^13^     ERR[ORS] [{FUNCTION|PROCEDURE|PACKAGE|PACKAGE BODY|TRIGGER|
SHOW^14^        VIEW} [schema.]name]
SHOW^15^     LABEL
SHOW^16^     LNO
SHOW^17^     PNO
SHOW^18^     REL[EASE]
SHOW^19^     REPF[OOTER]
SHOW^20^     REPH[EADER]
SHOW^21^     SPOO[L]
SHOW^22^     SQLCODE
SHOW^23^     TT[ITLE]
SHOW^24^     USER
SHOW^25^
SHOW^26^ Use SHOW to show the value of a SQL*Plus system variable, or the
SHOW^27^ current SQL*Plus environment.
SHOW^28^
SHOW^29^     system_variable
SHOW^30^         is any system variable set by the SET command.
SHOW^31^
SHOW^32^     ALL
SHOW^33^         lists the settings of all SHOW options, except ERRORS and
SHOW^34^         LABEL, in alphabetical order.
SHOW^35^
SHOW^36^     BTI[TLE]
SHOW^37^         shows the current BTITLE definition.
SHOW^38^
SHOW^39^     ERR[ORS] [{FUNCTION|PROCEDURE|PACKAGE|PACKAGE BODY|
SHOW^40^        TRIGGER|VIEW} [schema.]name]
SHOW^41^         shows the compilation errors of a stored procedure
SHOW^42^         (includes stored functions, procedures, and packages).
SHOW^43^         When you use the CREATE command to create a stored
SHOW^44^         procedure, a message is displayed if there are any
SHOW^45^         compilation errors.  To see the errors, you use SHOW
SHOW^46^         ERRORS.  When you specify SHOW ERRORS with no
SHOW^47^         arguments, compilation errors for the most recently
SHOW^48^         created or altered stored procedure are displayed.
SHOW^49^         When you specify the type (function, procedure, package,
SHOW^50^         package body, trigger, or view) and the name of the
SHOW^51^         PL/SQL stored procedure, SQL*Plus shows errors for that
SHOW^52^         stored procedure.
SHOW^53^
SHOW^54^         schema contains the named object.  If you omit the
SHOW^55^         schema, SHOW ERRORS assumes the object is located in
SHOW^56^         your current schema.
SHOW^57^
SHOW^58^         Note: You must have DBA privilege to view other schemas,
SHOW^59^
SHOW^60^         or other schema's object errors.
SHOW^61^
SHOW^62^         SHOW ERRORS output displays the line and column
SHOW^63^         number of the error (LINE/COL) as well as the error
SHOW^64^         itself (ERROR).  LINE/COL and ERROR have default widths
SHOW^65^         of 8 and 65, respectively.  You can alter these widths
SHOW^66^         using the COLUMN command.
SHOW^67^
SHOW^68^     LABEL
SHOW^69^         shows the security level for the current session.
SHOW^70^
SHOW^71^     LNO shows the current line number--the position in the current page
SHOW^72^         of the display and/or spooled output.
SHOW^73^
SHOW^74^     PNO shows the current page number.
SHOW^75^
SHOW^76^     REL[EASE]
SHOW^77^         shows the release number of Oracle Server SQL*Plus is accessing.
SHOW^78^
SHOW^79^     REPF[OOTER]
SHOW^80^         shows the current REPFOOTER definition.
SHOW^81^
SHOW^82^     REPH[EADER]
SHOW^83^         shows the current REPHEADER definition.
SHOW^84^
SHOW^85^     SPOO[L]
SHOW^86^         shows whether or not output is being spooled.
SHOW^87^
SHOW^88^     SQLCODE
SHOW^89^         shows the value of SQL.SQLCODE; the SQL return code of the most
SHOW^90^         recent operation.
SHOW^91^
SHOW^92^     TTI[TLE]
SHOW^93^         shows the current TTITLE definition.
SHOW^94^
SHOW^95^     USER
SHOW^96^         shows the username currently accessing SQL*Plus.
SHOW^97^
SHOW^98^
SHOW^99^
SHOW^100^ Example:  To list the current LINESIZE, enter:
SHOW^101^
SHOW^102^               SQL> SHOW LINESIZE
SHOW^103^
SHOW^104^           If the current linesize is 80 characters, SQL*Plus responds:
SHOW^105^
SHOW^106^               linesize 80
SHOW^107^
SHOW^108^           Following is an example of how to show the compilation
SHOW^109^           errors of a PL/SQL procedure:
SHOW^110^
SHOW^111^               SQL> connect system/manager
SHOW^112^               SQL> create procedure scott.proc1 as
SHOW^113^               SQL> begin
SHOW^114^               SQL>   :p1 := 1;
SHOW^115^               SQL> end;
SHOW^116^               SQL> /
SHOW^117^
SHOW^118^               Warning: Procedure created with compilation errors.
SHOW^119^
SHOW^120^               SQL> show errors
SHOW^121^               Errors for PROCEDURE SCOTT.PROC1:
SHOW^122^
SHOW^123^               LINE/COL ERROR
SHOW^124^               --------------------------------------------------------
SHOW^125^               3/3      PLS-00049: bad bind variable 'P1'
SHOW^126^
SHOW^127^               SQL> show errors procedure proc1
SHOW^128^               No errors.
SHOW^129^               SQL> show errors procedure scott.proc1
SHOW^130^               Errors for PROCEDURE SCOTT.PROC1:
SHOW^131^
SHOW^132^               LINE/COL ERROR
SHOW^133^               --------------------------------------------------------
SHOW^134^               3/3      PLS-00049: bad bind variable 'P1'
SHOW^135^
SHOW^136^
SHOW^137^
SHOW^138^ See also:  commands.
SHOW^139^
/^1^
/^2^
/^3^
/^4^                                / (slash)
/^5^
/^6^ /
/^7^
/^8^ Enter a slash (/) at the command prompt or at a line number prompt to
/^9^ execute a SQL command or PL/SQL block in the SQL buffer.  The slash
/^10^ command works like RUN, but does not list the command on your screen
/^11^ buffer.
/^12^
/^13^ Executing a SQL command or PL/SQL block with the slash does not change the
/^14^ current line number in the SQL buffer unless the command in the buffer has
/^15^ an error.  If so, SQL*Plus makes the line with the error the current line.
/^16^
/^17^
/^18^
/^19^ Examples: Type LIST to see the contents of the buffer:
/^20^
/^21^               SQL> LIST
/^22^                 1* SELECT ENAME, JOB FROM EMP WHERE ENAME = 'JAMES'
/^23^
/^24^           Enter slash (/) to execute the command in the buffer:
/^25^
/^26^               SQL> /         Output:  ENAME   JOB
/^27^                                       ------  -----
/^28^                                       JAMES   CLERK
/^29^
/^30^
/^31^
/^32^ See also: @, buffer, edit, get, list, run, save, parameters,
/^33^           spool, start, commands.
/^34^
SPOOL^1^
SPOOL^2^
SPOOL^3^
SPOOL^4^                                   SPOOL
SPOOL^5^
SPOOL^6^ SPO[OL] [file_name[.ext]|OFF|OUT]
SPOOL^7^
SPOOL^8^ Use SPOOL to store query results in an operating system file, or send the
SPOOL^9^ file to a printer.
SPOOL^10^
SPOOL^11^     file_name[.ext]
SPOOL^12^         is the name of the file to receive the spool.  SPOOL file_name
SPOOL^13^         begins spooling displayed output to the named file.  If you omit
SPOOL^14^         an extension, SPOOL uses a default extension (usually LST or LIS).
SPOOL^15^
SPOOL^16^     OFF stops spooling.
SPOOL^17^
SPOOL^18^     OUT stops spooling and sends the file to your host computer's default
SPOOL^19^         printer.  for the current spooling status.
SPOOL^20^
SPOOL^21^ To spool output generated by commands in a command file without displaying
SPOOL^22^ the output on the screen, use SET TERMOUT OFF.  SET TERMOUT OFF does not
SPOOL^23^ affect output from commands run interactively.
SPOOL^24^
SPOOL^25^
SPOOL^26^
SPOOL^27^ Examples: To record your displayed output in a file named DIARY using the
SPOOL^28^           default file extension, enter:
SPOOL^29^
SPOOL^30^               SQL> SPOOL DIARY
SPOOL^31^
SPOOL^32^           To stop spooling and print the file on your default printer:
SPOOL^33^
SPOOL^34^               SQL> SPOOL OUT
SPOOL^35^
SPOOL^36^
SPOOL^37^
SPOOL^38^ See also:  commands.
SPOOL^39^
STORE^1^
STORE^2^
STORE^3^
STORE^4^                                     STORE
STORE^5^
STORE^6^ STORE {SET} file_name[.ext] [CRE[ATE]|REP[LACE]|APP[END]]
STORE^7^
STORE^8^ Saves attributes of the current SQL*Plus environment in a host operating
STORE^9^ system file (a command file).
STORE^10^
STORE^11^     SET
STORE^12^         Saves the values of the system variables.
STORE^13^
STORE^14^ Refer to the SAVE command for information on the other terms and clauses
STORE^15^ in the STORE command syntax.
STORE^16^
STORE^17^ This command creates a command file which can be executed with the START,
STORE^18^ @ or @@ commands.
STORE^19^
STORE^20^ To store a file under a name identical to a STORE command clause (that
STORE^21^ is, CREATE, REPLACE or APPEND), or the word FILE, you must put the name
STORE^22^ in single quotes or specify a file extension.
STORE^23^
STORE^24^
STORE^25^
STORE^26^ Examples: To store the current SQL*Plus system variables in a file named
STORE^27^           DEFAULTENV with the default command-file extension, enter
STORE^28^
STORE^29^               SQL> STORE SET DEFAULTENV
STORE^30^
STORE^31^           To append the current SQL*Plus system variables to an existing
STORE^32^           file called DEFAULTENV with the extension OLD, enter
STORE^33^
STORE^34^               SQL> STORE SET DEFAULTENV.OLD APPEND
STORE^35^
STORE^36^
STORE^37^
STORE^38^ See also:  @, @@, save, start.
STORE^39^
SQLPLUS^1^
SQLPLUS^2^
SQLPLUS^3^
SQLPLUS^4^                                    SQLPLUS
SQLPLUS^5^
SQLPLUS^6^ SQLPLUS [[-S[ILENT]] [logon] [start]]|-?
SQLPLUS^7^
SQLPLUS^8^     logon:  username[/password][@database_specification]|/|/NOLOG
SQLPLUS^9^     start:  @file_name[.ext ] [arg ...]
SQLPLUS^10^
SQLPLUS^11^ SQLPLUS starts SQL*Plus from the operating system prompt.  Start enables
SQLPLUS^12^ you to enter a command filename and arguments.  SQL*Plus passes the
SQLPLUS^13^ arguments to the command file as though you executed the file with the
SQLPLUS^14^ SQL*Plus START command.
SQLPLUS^15^
SQLPLUS^16^ If you omit logon and specify start, SQL*Plus assumes that the first line
SQLPLUS^17^ of the command file contains a valid logon.  If both start and logon are
SQLPLUS^18^ omitted, SQL*Plus prompts for logon information.
SQLPLUS^19^
SQLPLUS^20^     username[/password]
SQLPLUS^21^         are the username and password with which to start SQL*Plus and
SQLPLUS^22^         connect to Oracle.  If omitted, SQL*Plus prompts for them.  If
SQLPLUS^23^         you enter a slash (/) or enter RETURN to the prompt for username,
SQLPLUS^24^         SQL*Plus logs you in with a default logon (see "/" below).
SQLPLUS^25^
SQLPLUS^26^     /   is a default logon using operating system authentication.  In
SQLPLUS^27^         a default logon, SQL*Plus tries to log in with the username
SQLPLUS^28^         OPS$name, where name is your operating system username.  You
SQLPLUS^29^         cannot enter a database_specification with a default logon.
SQLPLUS^30^
SQLPLUS^31^     /NOLOG
SQLPLUS^32^         establishes no initial connection to Oracle.  Before issuing any
SQLPLUS^33^         SQL commands, you must issue a CONNECT command to establish a
SQLPLUS^34^         valid logon.  Use /NOLOG to have a SQL*Plus command file prompt
SQLPLUS^35^         for the username, password or database specification. The first
SQLPLUS^36^         line of this command file is not assumed to contain a logon.
SQLPLUS^37^
SQLPLUS^38^     @database_specification
SQLPLUS^39^         consists of a SQL*Net connection string; the syntax depends on the
SQLPLUS^40^         SQL*Net communications protocol your Oracle installation uses.
SQLPLUS^41^
SQLPLUS^42^     -S[ILENT]
SQLPLUS^43^         suppresses all SQL*Plus information and prompt messages, including
SQLPLUS^44^         the command prompt and the banner usually displayed when SQL*Plus
SQLPLUS^45^         is started.  Use SILENT to make the use of SQL*Plus invisible to
SQLPLUS^46^         the user when invoking SQL*Plus within another program.
SQLPLUS^47^
SQLPLUS^48^     -?  makes SQLPLUS display its current version and level number, then
SQLPLUS^49^         returns control to the operating system.  The ? (question mark)
SQLPLUS^50^         must come right after the - (hyphen); a space is not permitted.
SQLPLUS^51^
SQLPLUS^52^ The SQLPLUS command may be known by a different name under some
SQLPLUS^53^ operating systems, for example, plus32.
SQLPLUS^54^
SQLPLUS^55^ SQL*Plus supports a Site Profile, a SQL*Plus command file created by the
SQLPLUS^56^ database administrator.  This file is generally named GLOGIN.SQL.  This
SQLPLUS^57^ file is executed whenever a user starts SQL*Plus and SQL*Plus establishes
SQLPLUS^58^ the Oracle connection.  The Site Profile enables the DBA to set up
SQLPLUS^59^ SQL*Plus environment defaults for all users at a particular site.
SQLPLUS^60^ Users cannot directly access the Site Profile.  The default name
SQLPLUS^61^ and location of the Site Profile depend on your system.
SQLPLUS^62^
SQLPLUS^63^ SQL*Plus also supports a User Profile, executed after the Site Profile.
SQLPLUS^64^ SQL*Plus searches for file LOGIN.SQL in your current directory.  If it's
SQLPLUS^65^ not there, SQL*Plus searches a system dependent path to find the file;
SQLPLUS^66^ some operating systems may not support this path-search.
SQLPLUS^67^
SQLPLUS^68^ If you fail to log in successfully to SQL*Plus because your username or
SQLPLUS^69^ password is invalid, or some other error, SQL*Plus will return an error
SQLPLUS^70^ status equivalent to an EXIT FAILURE command.  See the EXIT command for
SQLPLUS^71^ further information on EXIT FAILURE.
SQLPLUS^72^
SQLPLUS^73^
SQLPLUS^74^
SQLPLUS^75^ Examples: To start SQL*Plus with username SCOTT and password TIGER, enter:
SQLPLUS^76^
SQLPLUS^77^               SQLPLUS SCOTT/TIGER
SQLPLUS^78^
SQLPLUS^79^           To start SQL*Plus, as above, and to make POLICY (where POLICY is
SQLPLUS^80^           a valid SQL*Net database connection string) the default database,
SQLPLUS^81^           enter:
SQLPLUS^82^
SQLPLUS^83^               SQLPLUS SCOTT/TIGER@POLICY
SQLPLUS^84^
SQLPLUS^85^           To start SQL*Plus with username SCOTT and password TIGER and run
SQLPLUS^86^           a command file named STARTUP with the extension SQL, enter:
SQLPLUS^87^
SQLPLUS^88^               SQLPLUS SCOTT/TIGER @STARTUP
SQLPLUS^89^
SQLPLUS^90^           Note the space between TIGER and @STARTUP.
SQLPLUS^91^
SQLPLUS^92^
SQLPLUS^93^
SQLPLUS^94^ See also:  remote databases, commands, exit.
SQLPLUS^95^
START^1^
START^2^
START^3^
START^4^                                  START
START^5^
START^6^ STA[RT] file_name[.ext] [arg ...]
START^7^
START^8^ START executes the contents of a command file.  The @ ("at" sign) and @@
START^9^ (double "at" sign) commands work similarly to the START command, but do
START^10^ not enable the passing of values to parameters.
START^11^
START^12^     file_name[.ext]
START^13^         is the command file to execute. If you omit an extension, SQL*Plus
START^14^         assumes the default command-file extension (normally SQL).
START^15^
START^16^         When you enter START file_name.ext, SQL*Plus searches for a file
START^17^         with the specified name and extension in the current default
START^18^         directory.  If SQL*Plus doesn't find the file, it searches a
START^19^         system dependent path for the FROM file.  Some operating systems
START^20^         don't support this path-search.
START^21^
START^22^     arg ...
START^23^         are data items to be passed to parameters in the command file.
START^24^         If you enter one or more arguments, SQL*Plus substitutes the
START^25^         values into the parameters (&1, &2, and so forth) in the command
START^26^         file.  The first argument replaces each occurrence of &1, the
START^27^         second replaces each occurrence of &2, and so forth.
START^28^
START^29^ The START command DEFINEs the parameters with the values of the arguments;
START^30^ if you START the file again in this session, you can enter new arguments
START^31^ or omit the arguments to use the old values.
START^32^
START^33^ The EXIT or QUIT commands in a command file terminate SQL*Plus.
START^34^
START^35^ Disabling the START command in the Product User Profile also disables the
START^36^ @ and @@ commands.
START^37^
START^38^
START^39^
START^40^ Example:  File PROMOTE.SQL, used to promote employees, contains:
START^41^
START^42^               SELECT * FROM EMP WHERE MGR=&1 AND JOB='&2' AND SAL>&3;
START^43^
START^44^           To run this command file, enter:
START^45^
START^46^               SQL> START PROMOTE 7280 CLERK 950
START^47^
START^48^           SQL*Plus then executes the following command:
START^49^
START^50^               SELECT * FROM EMP
START^51^               WHERE MGR = 7280 AND JOB = 'CLERK' AND SAL > 950;
START^52^
START^53^
START^54^
START^55^ See also:  @, @@, define, commands.
START^56^
SUBSTITUTION^1^
SUBSTITUTION^2^
SUBSTITUTION^3^
SUBSTITUTION^4^                                Substitution
SUBSTITUTION^5^
SUBSTITUTION^6^ A substitution variable is a user variable name preceded by one or two
SUBSTITUTION^7^ ampersands (&).  When a substitution variable is in a command, SQL*Plus
SUBSTITUTION^8^ executes the command as though it contained the value of the substitution
SUBSTITUTION^9^ variable, rather than the reference to the variable.
SUBSTITUTION^10^
SUBSTITUTION^11^
SUBSTITUTION^12^
SUBSTITUTION^13^ Example:  If the variable SORTCOL is "JOB", and the variable MYTABLE is
SUBSTITUTION^14^           "EMP", SQL*Plus executes the commands:
SUBSTITUTION^15^
SUBSTITUTION^16^               SQL> BREAK ON &SORTCOL SQL> SELECT &SORTCOL, SAL
SUBSTITUTION^17^                 2  FROM &MYTABLE
SUBSTITUTION^18^                 3  ORDER BY &SORTCOL;
SUBSTITUTION^19^
SUBSTITUTION^20^           as if they were:  SQL> BREAK ON JOB
SUBSTITUTION^21^                             SQL> SELECT JOB, SAL
SUBSTITUTION^22^                               2  FROM EMP
SUBSTITUTION^23^                               3  ORDER BY JOB;
SUBSTITUTION^24^
SUBSTITUTION^25^ You can use substitution variables anywhere in SQL and SQL*Plus commands,
SUBSTITUTION^26^ except as the first word entered at the prompt.  If SQL*Plus finds an
SUBSTITUTION^27^ undefined substitution variable in a command, you are asked for its value.
SUBSTITUTION^28^
SUBSTITUTION^29^
SUBSTITUTION^30^
SUBSTITUTION^31^ Example:  If the variable GIVENNAME is undefined and you enter:
SUBSTITUTION^32^
SUBSTITUTION^33^               SQL> SELECT * FROM EMP WHERE ENAME = '&GIVENNAME';
SUBSTITUTION^34^
SUBSTITUTION^35^           SQL*Plus displays the prompt:
SUBSTITUTION^36^
SUBSTITUTION^37^               Enter value for givenname:
SUBSTITUTION^38^
SUBSTITUTION^39^ You can enter any string at the prompt, even with blanks and punctuation.
SUBSTITUTION^40^ Quote marks are not needed if they surround the substitution variable in
SUBSTITUTION^41^ the command.  SQL*Plus reads your response from the keyboard, even if you
SUBSTITUTION^42^ have redirected terminal input or output to a file.  If a terminal is not
SUBSTITUTION^43^ available (running the file in batch mode, for example), SQL*Plus uses the
SUBSTITUTION^44^ redirected file.  To append characters immediately after a substitution
SUBSTITUTION^45^ variable, use a period to separate the variable from the characters:
SUBSTITUTION^46^
SUBSTITUTION^47^               SQL> SELECT * FROM EMP WHERE EMPNO='&E.01';
SUBSTITUTION^48^               Enter value for E:  123
SUBSTITUTION^49^
SUBSTITUTION^50^     is interpreted as:   SQL> SELECT * FROM EMP WHERE EMPNO='12301';
SUBSTITUTION^51^
SUBSTITUTION^52^
SUBSTITUTION^53^
SUBSTITUTION^54^ & and &&
SUBSTITUTION^55^
SUBSTITUTION^56^ If you use a substitution variable with one ampersand, SQL*Plus does not
SUBSTITUTION^57^ implicitly DEFINE the variable when you input a value.  Thus, if SQL*Plus
SUBSTITUTION^58^ later executes the same command (or another one with the same substitution
SUBSTITUTION^59^ variable), SQL*Plus will prompt you again for the value of the variable.
SUBSTITUTION^60^ If you use a substitution variable with two ampersands, the variable is
SUBSTITUTION^61^ automatically defined when you input a value.  Thus, if the same command
SUBSTITUTION^62^ is executed later in that session, SQL*Plus will not prompt you again for
SUBSTITUTION^63^ the value of the variable.
SUBSTITUTION^64^
SUBSTITUTION^65^
SUBSTITUTION^66^
SUBSTITUTION^67^ Example:  A command file named STATS (for calculating subgroup statistics
SUBSTITUTION^68^           on a numeric column) contains:
SUBSTITUTION^69^
SUBSTITUTION^70^               SELECT &&GROUP_COL, MAX(&&NUMBER_COL)  MAXIMUM,
SUBSTITUTION^71^                   MIN(&&NUMBER_COL) MINIMUM,
SUBSTITUTION^72^                   SUM(&&NUMBER_COL) TOTAL,
SUBSTITUTION^73^                   AVG(&&NUMBER_COL) AVERAGE
SUBSTITUTION^74^               FROM &TABLE
SUBSTITUTION^75^               GROUP BY &&GROUP_COL;
SUBSTITUTION^76^
SUBSTITUTION^77^           When you run this file, SQL*Plus prompts you for the values, by
SUBSTITUTION^78^           name, before running the file:
SUBSTITUTION^79^
SUBSTITUTION^80^               Enter value for group_col: PROJNO
SUBSTITUTION^81^               Enter value for number_col: SAL
SUBSTITUTION^82^               Enter value for table: EMP
SUBSTITUTION^83^
SUBSTITUTION^84^           SQL*Plus runs the following query:
SUBSTITUTION^85^
SUBSTITUTION^86^               SELECT PROJNO, MAX(SAL)  MAXIMUM,
SUBSTITUTION^87^                   MIN(SAL) MINIMUM,
SUBSTITUTION^88^                   SUM(SAL) TOTAL,
SUBSTITUTION^89^                   AVG(SAL) AVERAGE
SUBSTITUTION^90^               FROM EMP
SUBSTITUTION^91^               GROUP BY PROJNO;
SUBSTITUTION^92^
SUBSTITUTION^93^           If you run the query again during the same session, you will be
SUBSTITUTION^94^           prompted for TABLE (its name has a single ampersand) but not for
SUBSTITUTION^95^           GROUP_COL or NUMBER_COL (their names have double ampersands).
SUBSTITUTION^96^
SUBSTITUTION^97^
SUBSTITUTION^98^
SUBSTITUTION^99^ Restrictions on Substitution
SUBSTITUTION^100^
SUBSTITUTION^101^ You can't use substitution variables or parameters in the editing commands
SUBSTITUTION^102^ APPEND, CHANGE, DEL, and INPUT, nor in other commands where substitution
SUBSTITUTION^103^ would be meaningless, like HELP, REMARK, and TIMING.  APPEND, CHANGE, and
SUBSTITUTION^104^ INPUT treat text beginning with & or && like any other text string.
SUBSTITUTION^105^
SUBSTITUTION^106^ These SET variables affect substitution variables and parameters:
SUBSTITUTION^107^
SUBSTITUTION^108^ SET DEFINE    turns substitution on and off and defines the substitution
SUBSTITUTION^109^               character.  & is the default.
SUBSTITUTION^110^
SUBSTITUTION^111^ SET ESCAPE    defines an escape character to use before the substitution
SUBSTITUTION^112^               character.  The escape character instructs SQL*Plus to treat
SUBSTITUTION^113^               the substitution character as an ordinary character, not a
SUBSTITUTION^114^               variable substitution request.  \ is the default character.
SUBSTITUTION^115^
SUBSTITUTION^116^ SET VERIFY ON shows each line of the file before and after substitution.
SUBSTITUTION^117^
SUBSTITUTION^118^ SET CONCAT    defines the character between the name of a substitution
SUBSTITUTION^119^               variable or parameter and characters immediately after the
SUBSTITUTION^120^               variable or parameter (. is the default).  See SET.
SUBSTITUTION^121^
SUBSTITUTION^122^
SUBSTITUTION^123^
SUBSTITUTION^124^ See also: commands.
SUBSTITUTION^125^
TIMING^1^
TIMING^2^
TIMING^3^
TIMING^4^                                    TIMING
TIMING^5^
TIMING^6^ TIMI[NG] [START text|SHOW|STOP]
TIMING^7^
TIMING^8^ TIMING records timing data for an elapsed time period, lists the current
TIMING^9^ timer's name and timing data, or lists the number of active timers.
TIMING^10^
TIMING^11^     START text
TIMING^12^         sets up a timer and makes text its name.  To have more than
TIMING^13^         one active timer, START additional timers before STOPping the
TIMING^14^         first; SQL*Plus nests each new timer within the preceding one.  The
TIMING^15^         timer most recently STARTed is the current timer.
TIMING^16^
TIMING^17^     SHOW
TIMING^18^         shows the current timer's name and timing data.
TIMING^19^
TIMING^20^     STOP
TIMING^21^         shows the current timer's title and timing data, then erases
TIMING^22^         the timer.  If other timers are active, the next most
TIMING^23^         recently STARTed timer becomes the current timer.  Use the
TIMING^24^         CLEAR command's TIMING clause to delete all timers.  Enter
TIMING^25^         TIMING with no clauses to list the number of active timers.
TIMING^26^
TIMING^27^
TIMING^28^
TIMING^29^ You can use this data to do a performance analysis on commands or blocks
TIMING^30^ run during the period.  SET TIMING ON automatically displays timing data
TIMING^31^ after each SQL command or PL/SQL block you run.
TIMING^32^
TIMING^33^ To delete all timers, use the CLEAR TIMING command.
TIMING^34^
TIMING^35^
TIMING^36^
TIMING^37^ Examples: To create a timer named SQL_TIMER, enter:
TIMING^38^
TIMING^39^               SQL> TIMING START SQL_TIMER
TIMING^40^
TIMING^41^           To list the current timer's title and accumulated time:
TIMING^42^
TIMING^43^               SQL> TIMING SHOW
TIMING^44^
TIMING^45^           To list the current timer's title and accumulated time,
TIMING^46^           and remove the timer, enter:
TIMING^47^
TIMING^48^               SQL> TIMING STOP
TIMING^49^
TIMING^50^
TIMING^51^
TIMING^52^ See also:  clear, show, set, start, commands.
TIMING^53^
TTITLE^1^
TTITLE^2^
TTITLE^3^
TTITLE^4^                                   TTITLE
TTITLE^5^
TTITLE^6^ TTI[TLE] [printspec [text|variable] ...] | [OFF|ON]
TTITLE^7^
TTITLE^8^ where printspec is one or more of the clauses:
TTITLE^9^
TTITLE^10^         COL n          LE[FT]        BOLD
TTITLE^11^         S[KIP] [n]     CE[NTER]      FORMAT text
TTITLE^12^         TAB n          R[IGHT]
TTITLE^13^
TTITLE^14^ TTITLE places and formats a title at the top of each report page.  Enter
TTITLE^15^ TTITLE with no clause to list its current definition.  The old form of
TTITLE^16^ TTITLE is used if only a single word or string in quotes follows the
TTITLE^17^ TTITLE command.
TTITLE^18^
TTITLE^19^ See OLD COMMANDS for a description of the old form of TTITLE.
TTITLE^20^
TTITLE^21^     text
TTITLE^22^         is the title text.  Enter text in single quotes if you wish to
TTITLE^23^         place more than one word on a single line.
TTITLE^24^
TTITLE^25^     variable
TTITLE^26^         is a user variable or any of these system maintained values:
TTITLE^27^
TTITLE^28^              SQL.LNO       current line number
TTITLE^29^              SQL.PNO       current page number
TTITLE^30^              SQL.RELEASE   current Oracle release number
TTITLE^31^              SQL.SQLCODE   current error code
TTITLE^32^              SQL.USER      current username
TTITLE^33^
TTITLE^34^         To print one of these values, reference the appropriate variable
TTITLE^35^         in the title.  You can format variable with the FORMAT clause.
TTITLE^36^
TTITLE^37^     OFF turns the title off (suppresses its display) without affecting
TTITLE^38^         its definition.
TTITLE^39^
TTITLE^40^     ON  turns the title on (restores its display).  When you define a
TTITLE^41^         top title, SQL*Plus automatically sets TTITLE to ON.
TTITLE^42^
TTITLE^43^     COL n
TTITLE^44^         indents to column n of the current line (backward if column n has
TTITLE^45^         been passed).  "Column" here is print position, not table column.
TTITLE^46^
TTITLE^47^     S[KIP] [n]
TTITLE^48^         skips to the start of a new line n times; if n omitted, one time.
TTITLE^49^         If n = 0, skips backward to the start of the current line.
TTITLE^50^
TTITLE^51^     TAB n
TTITLE^52^         skips forward n columns (backward if you enter a negative value
TTITLE^53^         for n).  "Column" here is print position, not table column.
TTITLE^54^
TTITLE^55^     LE[FT], CE[NTER], and R[IGHT]
TTITLE^56^         aligns data left, center, or right on the current line.  SQL*Plus
TTITLE^57^         aligns the following data items as a group, up to the end of the
TTITLE^58^         printspec or the next LEFT, CENTER, RIGHT, or COL command.  CENTER
TTITLE^59^         and RIGHT use the SET LINESIZE value to calculate the position of
TTITLE^60^         the data item that follows.
TTITLE^61^
TTITLE^62^     BOLD
TTITLE^63^         prints data in bold print.  SQL*Plus represents bold print on your
TTITLE^64^         terminal by repeating the data on three consecutive lines.  On
TTITLE^65^         some operating systems, SQL*Plus may instruct your printer to
TTITLE^66^         print bolded text on three consecutive lines, instead of bold.
TTITLE^67^
TTITLE^68^     FORMAT text
TTITLE^69^         specifies a format model that determines the format data items to
TTITLE^70^         the next FORMAT clause or the end of the command.  The format
TTITLE^71^         model must be a text constant like A10 or $999.  See COLUMN
TTITLE^72^         FORMAT for more information on formatting.
TTITLE^73^
TTITLE^74^         If the datatype of the format model does not match the datatype of
TTITLE^75^         a given data item, the FORMAT clause has no effect on that item.
TTITLE^76^
TTITLE^77^         If no FORMAT model precedes a given data item, SQL*Plus prints
TTITLE^78^         NUMBER values in the format specified by SET NUMFORMAT or, if you
TTITLE^79^         have not used SET NUMFORMAT, the default format.  SQL*Plus prints
TTITLE^80^         DATE values in the default format.
TTITLE^81^
TTITLE^82^ If you don't enter a printspec clause before the first occurrence of text,
TTITLE^83^ TTITLE left justifies the text.  SQL*Plus interprets TTITLE in the new
TTITLE^84^ form if a valid printspec clause (LEFT, SKIP, COL, and so on) immediately
TTITLE^85^ follows the command name.  TTITLE's terms and clauses also apply to
TTITLE^86^ the BTITLE command.
TTITLE^87^
TTITLE^88^ See COLUMN NEW_VALUE for information on printing column and DATE values
TTITLE^89^ in the top title.  You can use any number of constants and variables in
TTITLE^90^ a printspec.  SQL*Plus displays the constants and variables in the order
TTITLE^91^ specified, positioning and formatting each constant or variable by the
TTITLE^92^ printspec clause that precedes it.
TTITLE^93^
TTITLE^94^
TTITLE^95^
TTITLE^96^ Examples: To define "Monthly Analysis" as the top title and left-align it,
TTITLE^97^           to center the date, to right-align the page number with a three
TTITLE^98^           digit format, and to display "Date in Thousands" in the
TTITLE^99^           center of the next line, enter:
TTITLE^100^
TTITLE^101^               SQL> TTITLE LEFT 'Monthly Analysis' CENTER '11 Mar 88' -
TTITLE^102^                  > RIGHT 'Page:' FORMAT 999 SQL.PNO SKIP CENTER -
TTITLE^103^                  > 'Data in Thousands'
TTITLE^104^
TTITLE^105^           The following title results:
TTITLE^106^
TTITLE^107^               Monthly Analysis            11 Mar 88             Page: 1
TTITLE^108^                                       Data in Thousands
TTITLE^109^
TTITLE^110^           To suppress the top title display without changing its
TTITLE^111^           definition, enter:
TTITLE^112^
TTITLE^113^               SQL> TTITLE OFF
TTITLE^114^
TTITLE^115^
TTITLE^116^
TTITLE^117^ See also:  old commands, btitle, repheader, repfooter, set, commands.
TTITLE^118^
UNDEFINE^1^
UNDEFINE^2^
UNDEFINE^3^
UNDEFINE^4^                               UNDEFINE
UNDEFINE^5^
UNDEFINE^6^ UNDEF[INE] variable ...
UNDEFINE^7^
UNDEFINE^8^ UNDEFINE deletes one or more user variables that you defined either
UNDEFINE^9^ explicitly (with the DEFINE command), or implicitly (with a START
UNDEFINE^10^ command argument).
UNDEFINE^11^
UNDEFINE^12^     variable
UNDEFINE^13^         is the name of the user variable you wish to delete. One or more
UNDEFINE^14^         user variables may be deleted in the same command.
UNDEFINE^15^
UNDEFINE^16^
UNDEFINE^17^
UNDEFINE^18^ Example:  To undefine a user variable named POS, enter:
UNDEFINE^19^
UNDEFINE^20^               SQL> UNDEFINE POS
UNDEFINE^21^
UNDEFINE^22^           To undefine two user variables named MYVAR1 and MYVAR2, enter:
UNDEFINE^23^
UNDEFINE^24^               SQL: UNDEFINE MYVAR1 MYVAR2
UNDEFINE^25^
UNDEFINE^26^
UNDEFINE^27^
UNDEFINE^28^ See also:  define, start, @, commands.
UNDEFINE^29^
VARIABLE^1^
VARIABLE^2^
VARIABLE^3^
VARIABLE^4^                             VARIABLE
VARIABLE^5^
VARIABLE^6^ VAR[IABLE] [variable [NUMBER|CHAR|CHAR (n)|VARCHAR2 (n)|REFCURSOR]]
VARIABLE^7^
VARIABLE^8^ VARIABLE declares a bind variable that can then be referenced in
VARIABLE^9^ PL/SQL.  VARIABLE with no arguments displays a list of all the
VARIABLE^10^ variables declared in the session.  VARIABLE followed by a name
VARIABLE^11^ lists that variable.
VARIABLE^12^
VARIABLE^13^     variable
VARIABLE^14^         represents the name of the bind variable you wish to create.
VARIABLE^15^
VARIABLE^16^     NUMBER
VARIABLE^17^         creates a variable of type NUMBER with a fixed length.
VARIABLE^18^
VARIABLE^19^     CHAR
VARIABLE^20^         creates a variable of type CHAR with a length of one.
VARIABLE^21^
VARIABLE^22^     CHAR (n)
VARIABLE^23^         creates a variable of type CHAR with a maximum length
VARIABLE^24^         of n, up to 255.
VARIABLE^25^
VARIABLE^26^     VARCHAR2 (n)
VARIABLE^27^         creates a variable of type VARCHAR2 with a maximum length
VARIABLE^28^         of n, up to 2000.
VARIABLE^29^
VARIABLE^30^     REFCURSOR
VARIABLE^31^         creates a variable of type REF CURSOR.
VARIABLE^32^
VARIABLE^33^ Bind variables may be used as parameters to stored procedures,
VARIABLE^34^ or may be directly referenced in anonymous PL/SQL blocks.
VARIABLE^35^
VARIABLE^36^ To display the value of a bind variable created with VARIABLE,
VARIABLE^37^ use the PRINT command.
VARIABLE^38^
VARIABLE^39^ To automatically display the value of a bind variable created
VARIABLE^40^ with VARIABLE, use the SET AUTOPRINT command.
VARIABLE^41^
VARIABLE^42^ Bind variables cannot be used in the COPY command or SQL
VARIABLE^43^ statements, except in PL/SQL blocks.  Instead, use substitution
VARIABLE^44^ variables.
VARIABLE^45^
VARIABLE^46^ SQL*Plus REFCURSOR bind variables may be used to reference
VARIABLE^47^ PL/SQL 2.3 Cursor Variables, allowing PL/SQL output to be
VARIABLE^48^ formatted by SQL*Plus.
VARIABLE^49^
VARIABLE^50^ When you execute a VARIABLE ... REFCURSOR command, SQL*Plus
VARIABLE^51^ creates a cursor bind variable.  The cursor is automatically
VARIABLE^52^ opened by an OPEN ... FOR SELECT statement referencing the bind
VARIABLE^53^ variable in a PL/SQL block.  SQL*Plus closes the cursor after
VARIABLE^54^ completing a PRINT statement for that bind variable, or on exit.
VARIABLE^55^
VARIABLE^56^ SQL*Plus formatting commands such as BREAK, COLUMN, COMPUTE and
VARIABLE^57^ SET may be used to format the output from PRINTing a REFCURSOR.
VARIABLE^58^
VARIABLE^59^ A REFCURSOR bind variable may not be PRINTed more than once
VARIABLE^60^ without re-executing the PL/SQL OPEN ... FOR statement.
VARIABLE^61^
VARIABLE^62^
VARIABLE^63^
VARIABLE^64^ Example:  The following example illustrates creating a bind variable
VARIABLE^65^ and then setting it to a value returned by a function:
VARIABLE^66^
VARIABLE^67^              SQL> VARIABLE id NUMBER
VARIABLE^68^              SQL> BEGIN
VARIABLE^69^                2    :id := emp_management.hire
VARIABLE^70^                3      ('BLAKE','MANAGER','KING',2990,'SALES');
VARIABLE^71^                4  END;
VARIABLE^72^
VARIABLE^73^ The following example automatically displays a bind variable:
VARIABLE^74^
VARIABLE^75^              SQL> SET AUTOPRINT ON
VARIABLE^76^              SQL> VARIABLE a REFCURSOR
VARIABLE^77^              SQL> BEGIN
VARIABLE^78^                2  OPEN :a FOR SELECT * FROM DEPT ORDER BY DEPTNO;
VARIABLE^79^                3  END;
VARIABLE^80^                4  /
VARIABLE^81^
VARIABLE^82^              PL/SQL procedure successfully completed.
VARIABLE^83^
VARIABLE^84^              DEPTNO   DNAME         LOC
VARIABLE^85^              -------- ------------- -------------
VARIABLE^86^                    10 ACCOUNTING    NEW YORK
VARIABLE^87^                    20 RESEARCH      DALLAS
VARIABLE^88^                    30 SALES         CHICAGO
VARIABLE^89^                    40 OPERATIONS    BOSTON
VARIABLE^90^
VARIABLE^91^ The following example creates some variables and lists them:
VARIABLE^92^
VARIABLE^93^              SQL> VARIABLE id NUMBER
VARIABLE^94^              SQL> VARIABLE txt CHAR (20)
VARIABLE^95^              SQL> VARIABLE myvar REFCURSOR
VARIABLE^96^              SQL> VARIABLE
VARIABLE^97^              variable id
VARIABLE^98^              datatype number
VARIABLE^99^
VARIABLE^100^              variable txt
VARIABLE^101^              datatype CHAR(20)
VARIABLE^102^
VARIABLE^103^              variable myvar
VARIABLE^104^              datatype REFCURSOR
VARIABLE^105^
VARIABLE^106^ The following example lists a single variable:
VARIABLE^107^
VARIABLE^108^              SQL> VARIABLE txt
VARIABLE^109^              variable txt
VARIABLE^110^              datatype CHAR(20)
VARIABLE^111^
VARIABLE^112^ The following example illustrates producing a report listing
VARIABLE^113^ individual salaries and computing the departmental and total
VARIABLE^114^ salary cost:
VARIABLE^115^
VARIABLE^116^              SQL> VARIABLE RC REFCURSOR
VARIABLE^117^                2  BEGIN
VARIABLE^118^                3    OPEN :RC FOR SELECT DNAME, ENAME, SAL
VARIABLE^119^                4            FROM EMP, DEPT
VARIABLE^120^                5            WHERE EMP.DEPTNO = DEPT.DEPTNO
VARIABLE^121^                6            ORDER BY EMP.DEPTNO, ENAME;
VARIABLE^122^                7  END;
VARIABLE^123^                8  /
VARIABLE^124^
VARIABLE^125^              PL/SQL procedure successfully completed.
VARIABLE^126^
VARIABLE^127^              SQL> SET PAGESIZE 100 FEEDBACK OFF
VARIABLE^128^              SQL> TTITLE LEFT '*** Departmental Salary Bill *** ' SKIP 2
VARIABLE^129^              SQL> COLUMN SAL FORMAT $999,990.99 HEADING 'Salary'
VARIABLE^130^              SQL> COLUMN DNAME HEADING 'Department'
VARIABLE^131^              SQL> COLUMN ENAME HEADING 'Employee'
VARIABLE^132^              SQL> COMPUTE SUM LABEL 'Subtotal:' OF SAL ON DNAME
VARIABLE^133^              SQL> COMPUTE SUM LABEL 'Total:' OF SAL ON REPORT
VARIABLE^134^              SQL> BREAK ON DNAME SKIP 1 ON REPORT SKIP 1
VARIABLE^135^              SQL> PRINT RC
VARIABLE^136^
VARIABLE^137^              *** Departmental Salary Bill ***
VARIABLE^138^
VARIABLE^139^
VARIABLE^140^
VARIABLE^141^              Department     Employee         Salary
VARIABLE^142^              -------------- ---------- ------------
VARIABLE^143^              ACCOUNTING     CLARK         $2,450.00
VARIABLE^144^                             KING          $5,000.00
VARIABLE^145^                             MILLER        $1,300.00
VARIABLE^146^              **************            ------------
VARIABLE^147^              Subtotal:                    $8,750.00
VARIABLE^148^
VARIABLE^149^              RESEARCH       ADAMS         $1,100.00
VARIABLE^150^                             FORD          $3,000.00
VARIABLE^151^                             JONES         $2,975.00
VARIABLE^152^                             SCOTT         $3,000.00
VARIABLE^153^                             SMITH           $800.00
VARIABLE^154^              **************            ------------
VARIABLE^155^              Subtotal:                   $10,875.00
VARIABLE^156^
VARIABLE^157^              SALES          ALLEN         $1,600.00
VARIABLE^158^                             BLAKE         $2,850.00
VARIABLE^159^                             JAMES           $950.00
VARIABLE^160^                             MARTIN        $1,250.00
VARIABLE^161^                             TURNER        $1,500.00
VARIABLE^162^                             WARD          $1,250.00
VARIABLE^163^              **************            ------------
VARIABLE^164^              Subtotal:                    $9,400.00
VARIABLE^165^
VARIABLE^166^                                        ------------
VARIABLE^167^              Total:                      $29,025.00
VARIABLE^168^
VARIABLE^169^
VARIABLE^170^
VARIABLE^171^ See also:  print, set autoprint, set serveroutput.
VARIABLE^172^
VARIABLES^1^
VARIABLES^2^
VARIABLES^3^
VARIABLES^4^                              Variables
VARIABLES^5^
VARIABLES^6^ Use variables to store the results of a query, or to calculate
VARIABLES^7^ values to insert into tables. You can declare a variable to be
VARIABLES^8^ of any SQL or PL/SQL datatype: NUMBER, CHAR, VARCHAR2, REFCURSOR,
VARIABLES^9^ DATE, or BOOLEAN.  Examples: balance NUMBER(5,2);  wkphone CHAR(12);
VARIABLES^10^ sex BOOLEAN.
VARIABLES^11^
VARIABLES^12^ You can also create bind variables in SQL*Plus with the VARIABLE
VARIABLES^13^ command.  Bind variables can be referenced in PL/SQL and displayed
VARIABLES^14^ in SQL*Plus (using the PRINT command).  Bind variables can be of type
VARIABLES^15^ NUMBER, CHAR, CHAR (n), VARCHAR2 (n), or REFCURSOR.  Bind variables
VARIABLES^16^ are useful for storing return codes and debugging your PL/SQL because
VARIABLES^17^ you can display their values in SQL*Plus.
VARIABLES^18^
VARIABLES^19^ There are two ways you can assign values to a variable:
VARIABLES^20^   1 - use := (assignment operator)    discount := price * 0.15
VARIABLES^21^
VARIABLES^22^   2 - SELECT or FETCH table values INTO a variable:
VARIABLES^23^               SELECT price * 0.15 INTO discount FROM pricelist
VARIABLES^24^               WHERE stockdate <= SYSDATE - 60
VARIABLES^25^
VARIABLES^26^ To declare a constant, put CONSTANT  after the name and assign
VARIABLES^27^ its value immediately: discount  CONSTANT NUMBER(2,2) := 0.15;
VARIABLES^28^
VARIABLES^29^
VARIABLES^30^
VARIABLES^31^ See also: declare, number, char, varchar2, date, boolean, select into,
VARIABLES^32^           fetch, variable, print
VARIABLES^33^
WHENEVER OSERROR^1^
WHENEVER OSERROR^2^
WHENEVER OSERROR^3^
WHENEVER OSERROR^4^                             WHENEVER OSERROR
WHENEVER OSERROR^5^
WHENEVER OSERROR^6^ WHENEVER OSERROR {EXIT [SUCCESS|FAILURE|n|variable]
WHENEVER OSERROR^7^    [COMMIT|ROLLBACK]|CONTINUE [COMMIT|ROLLBACK|NONE]}
WHENEVER OSERROR^8^
WHENEVER OSERROR^9^ WHENEVER OSERROR exits SQL*Plus if an operating system error occurs,
WHENEVER OSERROR^10^ (such as a file I/O error).
WHENEVER OSERROR^11^
WHENEVER OSERROR^12^     EXIT [SUCCESS|FAILURE|n|variable]
WHENEVER OSERROR^13^         directs SQL*Plus to exit as soon as an operating system error
WHENEVER OSERROR^14^         is detected.  You can also specify whether SQL*Plus should
WHENEVER OSERROR^15^         return a success or failure code, the operating system failure
WHENEVER OSERROR^16^         code, or a number or variable of your choice.
WHENEVER OSERROR^17^
WHENEVER OSERROR^18^     CONTINUE
WHENEVER OSERROR^19^         turns off the EXIT option.
WHENEVER OSERROR^20^
WHENEVER OSERROR^21^     COMMIT
WHENEVER OSERROR^22^         directs SQL*Plus to execute a COMMIT before exiting or
WHENEVER OSERROR^23^         continuing and save pending changes to the database.
WHENEVER OSERROR^24^
WHENEVER OSERROR^25^     ROLLBACK
WHENEVER OSERROR^26^         directs SQL*Plus to execute a ROLLBACK before exiting or
WHENEVER OSERROR^27^         continuing and abandon pending changes to the database.
WHENEVER OSERROR^28^
WHENEVER OSERROR^29^     NONE
WHENEVER OSERROR^30^         directs SQL*Plus to take no action before continuing.
WHENEVER OSERROR^31^         NONE is only valid with CONTINUE.
WHENEVER OSERROR^32^
WHENEVER OSERROR^33^ If you do not enter the WHENEVER OSERROR command, the default
WHENEVER OSERROR^34^ behavior of SQL*Plus is to continue and take no action when an
WHENEVER OSERROR^35^ operating system error occurs.
WHENEVER OSERROR^36^
WHENEVER OSERROR^37^
WHENEVER OSERROR^38^
WHENEVER OSERROR^39^ Examples:  The commands in the following command file cause
WHENEVER OSERROR^40^            SQL*Plus to exit and COMMIT any pending changes if an
WHENEVER OSERROR^41^            error occurs when writing to the output file:
WHENEVER OSERROR^42^
WHENEVER OSERROR^43^                 WHENEVER OSERROR EXIT SQL.OSCODE COMMIT
WHENEVER OSERROR^44^                 SPOOL MYLOG
WHENEVER OSERROR^45^                 UPDATE EMP SET SAL = SAL*1.1
WHENEVER OSERROR^46^                 COPY TO SCOTT/TIGER@HQDB -
WHENEVER OSERROR^47^                 REPLACE EMP -
WHENEVER OSERROR^48^                 USING SELECT * FROM EMP
WHENEVER OSERROR^49^                 SPOOL OUT
WHENEVER OSERROR^50^                 SELECT SAL FROM EMP
WHENEVER OSERROR^51^
WHENEVER OSERROR^52^
WHENEVER OSERROR^53^
WHENEVER OSERROR^54^ See also:  whenever sqlerror, exit.
WHENEVER OSERROR^55^
WHENEVER SQLERROR^1^
WHENEVER SQLERROR^2^
WHENEVER SQLERROR^3^
WHENEVER SQLERROR^4^                             WHENEVER SQLERROR
WHENEVER SQLERROR^5^
WHENEVER SQLERROR^6^ WHENEVER SQLERROR {EXIT [SUCCESS|FAILURE|WARNING|n|variable]
WHENEVER SQLERROR^7^    [COMMIT|ROLLBACK]|CONTINUE [COMMIT|ROLLBACK|NONE]}
WHENEVER SQLERROR^8^
WHENEVER SQLERROR^9^ Exits SQL*Plus if a SQL command or PL/SQL block generates an error.
WHENEVER SQLERROR^10^
WHENEVER SQLERROR^11^     EXIT [SUCCESS|FAILURE|WARNING|n|variable]
WHENEVER SQLERROR^12^         directs SQL*Plus to exit as soon as it detects any SQL
WHENEVER SQLERROR^13^         command or PL/SQL block error (but after printing the
WHENEVER SQLERROR^14^         error message).SQL*Plus will not exit on a SQL*Plus error.
WHENEVER SQLERROR^15^
WHENEVER SQLERROR^16^     CONTINUE
WHENEVER SQLERROR^17^         turns off the EXIT option.
WHENEVER SQLERROR^18^
WHENEVER SQLERROR^19^     COMMIT
WHENEVER SQLERROR^20^         directs SQL*Plus to execute a COMMIT before exiting or
WHENEVER SQLERROR^21^         continuing and save pending changes to the database.
WHENEVER SQLERROR^22^
WHENEVER SQLERROR^23^     ROLLBACK
WHENEVER SQLERROR^24^         directs SQL*Plus to execute a ROLLBACK before exiting or
WHENEVER SQLERROR^25^         continuing and abandon pending changes to the database.
WHENEVER SQLERROR^26^
WHENEVER SQLERROR^27^     NONE
WHENEVER SQLERROR^28^         directs SQL*Plus to take no action before continuing.
WHENEVER SQLERROR^29^
WHENEVER SQLERROR^30^ The WHENEVER SQLERROR command is triggered by SQL command or PL/SQL
WHENEVER SQLERROR^31^ block errors, and not by SQL*Plus command errors.
WHENEVER SQLERROR^32^
WHENEVER SQLERROR^33^ If you do not enter the WHENEVER SQLERROR command, the default
WHENEVER SQLERROR^34^ behavior of SQL*Plus is to continue and take no action when a
WHENEVER SQLERROR^35^ SQL error occurs.
WHENEVER SQLERROR^36^
WHENEVER SQLERROR^37^
WHENEVER SQLERROR^38^
WHENEVER SQLERROR^39^ Examples:  The commands in the following command file cause
WHENEVER SQLERROR^40^            SQL*Plus to exit and return the SQL error code if the
WHENEVER SQLERROR^41^            SQL UPDATE command fails:
WHENEVER SQLERROR^42^
WHENEVER SQLERROR^43^                 SQL> WHENEVER SQLERROR EXIT SQL.SQLCODE
WHENEVER SQLERROR^44^                 SQL> UPDATE EMP SET SAL = SAL*1.1
WHENEVER SQLERROR^45^
WHENEVER SQLERROR^46^
WHENEVER SQLERROR^47^            The following SQL command error causes SQL*Plus to
WHENEVER SQLERROR^48^            exit and return the SQL error code:
WHENEVER SQLERROR^49^
WHENEVER SQLERROR^50^                 SQL> WHENEVER SQLERROR EXIT SQL.SQLCODE
WHENEVER SQLERROR^51^                 SQL> select column_does_not_exits from dual;
WHENEVER SQLERROR^52^                 select column_does_not_exits from dual
WHENEVER SQLERROR^53^                        *
WHENEVER SQLERROR^54^                 ERROR at line 1:
WHENEVER SQLERROR^55^                 ORA-00904: invalid column name
WHENEVER SQLERROR^56^                 Disconnected from Oracle.....
WHENEVER SQLERROR^57^
WHENEVER SQLERROR^58^
WHENEVER SQLERROR^59^            The following SQL command error causes SQL*Plus to
WHENEVER SQLERROR^60^            exit and return the value of the variable my_error_var:
WHENEVER SQLERROR^61^
WHENEVER SQLERROR^62^                 SQL> define my_error_var 99
WHENEVER SQLERROR^63^                 SQL> WHENEVER SQLERROR EXIT my_error_var
WHENEVER SQLERROR^64^                 SQL> UPDATE non_existed_table set col1 = col1 + 1;
WHENEVER SQLERROR^65^                 UPDATE NON_ESISTED_TABLE set col1 = col1 + 1
WHENEVER SQLERROR^66^                        *
WHENEVER SQLERROR^67^                 ERROR at line 1:
WHENEVER SQLERROR^68^                 ORA-00942: table or view does not exist
WHENEVER SQLERROR^69^
WHENEVER SQLERROR^70^                 Disconnected from Oracle.....
WHENEVER SQLERROR^71^
WHENEVER SQLERROR^72^
WHENEVER SQLERROR^73^            The following examples show that the WHENEVER
WHENEVER SQLERROR^74^            SQLERROR command does not have any effect on
WHENEVER SQLERROR^75^            SQL*Plus commands, but does on SQL commands and
WHENEVER SQLERROR^76^            PL/SQL blocks:
WHENEVER SQLERROR^77^
WHENEVER SQLERROR^78^                 SQL> WHENEVER SQLERROR EXIT SQL.SQLCODE
WHENEVER SQLERROR^79^                 SQL> column ename headiing "Employee Name"
WHENEVER SQLERROR^80^                 Unknown COLUMN option "headiing"
WHENEVER SQLERROR^81^                 SQL> show non_existed_option
WHENEVER SQLERROR^82^                 Unknown SHOW option "non_existed_option"
WHENEVER SQLERROR^83^                 SQL> get non_existed_file.sql
WHENEVER SQLERROR^84^                 Unable to open "non_existed_file.sql"
WHENEVER SQLERROR^85^                 SQL>
WHENEVER SQLERROR^86^
WHENEVER SQLERROR^87^
WHENEVER SQLERROR^88^            The following PL/SQL block error causes SQL*Plus
WHENEVER SQLERROR^89^            to exit and return the SQL error code:
WHENEVER SQLERROR^90^
WHENEVER SQLERROR^91^                 SQL> WHENEVER SQLERROR EXIT SQL.SQLCODE
WHENEVER SQLERROR^92^                 SQL> begin
WHENEVER SQLERROR^93^                   2    select column_does_not_exits from dual;
WHENEVER SQLERROR^94^                   3  end;
WHENEVER SQLERROR^95^                   4  /
WHENEVER SQLERROR^96^                 select column_does_not_exits from dual;
WHENEVER SQLERROR^97^                        *
WHENEVER SQLERROR^98^                 ERROR at line 2:
WHENEVER SQLERROR^99^                 ORA-06550: line 2, column 10:
WHENEVER SQLERROR^100^                 PLS-00201: identifier 'COLUMN_DOES_NOT_EXITS' must be declared
WHENEVER SQLERROR^101^                 ORA-06550: line 2, column 3:
WHENEVER SQLERROR^102^                 PL/SQL: SQL Statement ignored
WHENEVER SQLERROR^103^
WHENEVER SQLERROR^104^                 Disconnected from Oracle.....
WHENEVER SQLERROR^105^
WHENEVER SQLERROR^106^
WHENEVER SQLERROR^107^
WHENEVER SQLERROR^108^ See also:  whenever oserror, exit.
WHENEVER SQLERROR^109^
